using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Audio;

public class DustBehavior : MonoBehaviour
{
	public float fadeOutTime = 2.5f;
	private float elapsedTime = -4.5f;
	private bool soundPlayed = false;
	private SpriteRenderer[] renderers;
	private AudioSource audioSource;
	public AudioClip audioClip;

	private void Start()
	{
		renderers = GetComponentsInChildren<SpriteRenderer>();
		audioSource = gameObject.AddComponent<AudioSource>();
		audioSource.clip = audioClip;
	}

	private void Update()
	{
		if (!GetComponent<PersonBehaviour>().IsAlive())
		{
			elapsedTime += Time.deltaTime;
			float alpha = 1.0f - (elapsedTime / fadeOutTime);

			if (alpha <= 0.0f)
			{
				Destroy(gameObject);
			}
			else
			{
				foreach (SpriteRenderer r in renderers)
				{
					Color color = r.color;
					color.a = alpha;
					r.color = color;
				}

				if (alpha <= 0.8f && !soundPlayed)
				{
					audioSource.Play();
					soundPlayed = true;
				}
			}
		}
	}
}
// Originally uploaded by '󠀦󠀦hunter'. Do not reupload without their explicit permission.
