using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.Events;
namespace Mod
{
    public class MonsterSoulBehaviour : MonoBehaviour
    {
        public bool Dead = false;
        public LimbBehaviour BeforeLimb;
        public PersonBehaviour Person;
        public Sprite BrokenHeart = ModAPI.LoadSprite("Characters/asgore/BrokenHeart.png");
        public Sprite HeartShard1 = ModAPI.LoadSprite("Characters/asgore/HeartShard1.png");
		public Sprite HeartShard2 = ModAPI.LoadSprite("Characters/asgore/HeartShard4.png");
		public Sprite HeartShard3 = ModAPI.LoadSprite("Characters/asgore/HeartShard3.png");
		public Sprite HeartShard4 = ModAPI.LoadSprite("Characters/asgore/HeartShard4.png");
		public Sprite HeartShard5 = ModAPI.LoadSprite("Characters/asgore/HeartShard5.png");
        public Sprite HeartShapedObject = ModAPI.LoadSprite("Characters/asgore/Heart.png");
        public GameObject cObj;
        public GameObject Shield;
        public SpriteRenderer ShieldSprite;
        public SpriteRenderer ShardSprite;
		public SpriteRenderer ShardSprite1;
		public SpriteRenderer ShardSprite2;
		public SpriteRenderer ShardSprite3;
		public SpriteRenderer ShardSprite4;
        public SpriteRenderer cSpr;
        public Transform Head;
        public Transform Torso;
        public Transform LTorso;
        public Transform HeadReal;
        public AudioSource HeartBreakSound;
        public AudioSource SoulPing;
        public AudioSource UnHeartBreakSound;
        public Rigidbody2D HeadRB;
        public Rigidbody2D TorsoRB;
        public Rigidbody2D MTorsoRB;
        public Rigidbody2D LTorsoRB;
        public BoxCollider2D ShieldCollider;

        void Awake(){
            Person = this.gameObject.GetComponent<PersonBehaviour>();
            Head = this.gameObject.transform.GetChild(6).GetChild(0);
            Torso = this.gameObject.transform.GetChild(6).GetChild(1);
            LTorso = this.gameObject.transform.GetChild(6).GetChild(2);
            HeadReal = this.gameObject.transform.GetChild(5);
            HeadRB = HeadReal.GetComponent<Rigidbody2D>();
            TorsoRB = Head.GetComponent<Rigidbody2D>();
            MTorsoRB = Torso.GetComponent<Rigidbody2D>();
            LTorsoRB = LTorso.GetComponent<Rigidbody2D>();
            cObj = new GameObject("HeartObject");
            cObj.transform.SetParent(Head);
            cObj.transform.localPosition = new Vector3(0.099f, 0f);
            cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            cObj.transform.localScale = new Vector3(0.45f, 0.45f);
            cSpr = cObj.AddComponent<SpriteRenderer>();
            cSpr .sprite = HeartShapedObject;
			cSpr.color = new Color(1f, 1f, 1f, 0f);
            cSpr.sortingLayerName = "Top";
            HeartBreakSound = cObj.AddComponent<AudioSource>();
            HeartBreakSound.clip = ModAPI.LoadSound("HeartBreak.mp3");
            UnHeartBreakSound = cObj.AddComponent<AudioSource>();
            UnHeartBreakSound.clip = ModAPI.LoadSound("snd_break1_c.wav");
        }
        void Update() {
            cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
            Person.AdrenalineLevel = 1f;
            foreach (LimbBehaviour p2 in Person.Limbs) {
                BeforeLimb = p2;
                p2.BreakingThreshold += 1f;
                p2.CirculationBehaviour.InternalBleedingIntensity *= 0.4f;
                p2.ImpactPainMultiplier *= 0.1f;
                p2.Vitality *= 0.03f;
                p2.SkinMaterialHandler.RottenProgress *= 0.6f;
                foreach (LimbBehaviour p3 in Person.Limbs) {
                    if (p3.gameObject.name == "Head" && p3.Health <= 0f) {
                            StartCoroutine("BreakHeartWait");
                            /* BeforeLimb.gameObject.layer = 10; */
                            BeforeLimb.CirculationBehaviour.HealBleeding();
                            /* BeforeLimb.gameObject.GetComponent<SpriteRenderer>().enabled = false;
                            BeforeLimb.gameObject.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static; */
                    } else if (p3.gameObject.name == "Head" && p3.Broken == true) { 
                            StartCoroutine("BreakHeartWait");
                            /* BeforeLimb.gameObject.layer = 10; */
                            BeforeLimb.CirculationBehaviour.HealBleeding();
/*                             BeforeLimb.gameObject.GetComponent<SpriteRenderer>().enabled = false;
                            BeforeLimb.gameObject.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static; */
                    } else if (p3.gameObject.name == "Head" && !p3.CirculationBehaviour.HasBloodFlow) { 
                            StartCoroutine("BreakHeartWait");
                            /* BeforeLimb.gameObject.layer = 10; */
                            BeforeLimb.CirculationBehaviour.HealBleeding();
                            /* BeforeLimb.gameObject.GetComponent<SpriteRenderer>().enabled = false;
                            BeforeLimb.gameObject.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static; */
                    } else if (p3.gameObject.name == "UpperBody" && !p3.CirculationBehaviour.HasBloodFlow) { 
                            StartCoroutine("BreakHeartWait");
                            /* BeforeLimb.gameObject.layer = 10; */
                            BeforeLimb.CirculationBehaviour.HealBleeding();
                            /* BeforeLimb.gameObject.GetComponent<SpriteRenderer>().enabled = false; */
                            /* BeforeLimb.gameObject.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static; */
                    } else if (p3.gameObject.name == "UpperBody" && !p3.CirculationBehaviour.HasCirculation) { 
                            StartCoroutine("BreakHeartWait");
                            /* BeforeLimb.gameObject.layer = 10; */
                            BeforeLimb.CirculationBehaviour.HealBleeding();
                            /* BeforeLimb.gameObject.GetComponent<SpriteRenderer>().enabled = false; */
                            /* BeforeLimb.gameObject.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static; */
                    } else if (p3.gameObject.name == "Head" && !p3.CirculationBehaviour.HasCirculation) { 
                            StartCoroutine("BreakHeartWait");
                            /* BeforeLimb.gameObject.layer = 10; */
                            BeforeLimb.CirculationBehaviour.HealBleeding();
                            /* BeforeLimb.gameObject.GetComponent<SpriteRenderer>().enabled = false; */
                            /* BeforeLimb.gameObject.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static; */
                    }
                };
            };
        }
        IEnumerator BreakHeartWait() {
            if (Dead == false) {
                Dead = true;
				yield return (object) new WaitForSeconds(1f);
				cSpr.color = new Color(1f, 1f, 1f, 1f);
                if (UnityEngine.Random.Range(1, 20) == 1) { 
                    yield return (object) new WaitForSeconds(1f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.09f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.09f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.08f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.07f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.05f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.04f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.04f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.04f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.04f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.03f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.02f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.02f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.01f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.01f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.01f);
                    cObj.GetComponent<SpriteRenderer>().sprite = BrokenHeart;
                    UnHeartBreakSound.Play();
                    yield return (object) new WaitForSeconds(2.5f);
                    UnHeartBreakSound.Play();
                    cObj.GetComponent<SpriteRenderer>().sprite = HeartShapedObject;
                    ModAPI.Notify("* But it refused.");
                    yield return (object) new WaitForSeconds(0.5f);
                    foreach (LimbBehaviour p3 in Person.Limbs) {
                        //p3.gameObject.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Dynamic;
                        //BeforeLimb.gameObject.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Dynamic;
                        p3.LungsPunctured = false;
                        //p3.gameObject.GetComponent<SpriteRenderer>().enabled = true;
                        BeforeLimb.HealBone();
                        //BeforeLimb.gameObject.GetComponent<SpriteRenderer>().enabled = true;
                        BeforeLimb.LungsPunctured = false;
                        BeforeLimb.Health = BeforeLimb.InitialHealth;
                        BeforeLimb.CirculationBehaviour.IsPump = true;
                        BeforeLimb.CirculationBehaviour.BloodFlow = 1f;
                        BeforeLimb.gameObject.layer = 9;
                        p3.Health = p3.InitialHealth;
                        p3.CirculationBehaviour.IsPump = true;
                        p3.CirculationBehaviour.BloodFlow = 1f;
                        p3.gameObject.layer = 9;
                        p3.HealBone();
                    }
                    Person.Consciousness = 1f;
                    Person.ShockLevel = 0.0f;
                    Person.PainLevel = 0.0f;
                    Person.OxygenLevel = 1f;
                    Person.AdrenalineLevel = 1f;
                    //
                    //BeforeLimb.gameObject.layer = 9;
                    //BeforeLimb.CirculationBehaviour.HealBleeding();
                    //BeforeLimb.gameObject.GetComponent<SpriteRenderer>().enabled = true;
                    //BeforeLimb.LungsPunctured = false;
                    //BeforeLimb.HealBone();
                    //BeforeLimb.Health = BeforeLimb.InitialHealth;
                    //BeforeLimb.Numbness = 0.0f;
                    //BeforeLimb.CirculationBehaviour.HealBleeding();
                    //BeforeLimb.CirculationBehaviour.IsPump = BeforeLimb.CirculationBehaviour.WasInitiallyPumping;
                    //BeforeLimb.CirculationBehaviour.BloodFlow = 1f;
                    //double num = (double) BeforeLimb.CirculationBehaviour.AddLiquid(BeforeLimb.GetOriginalBloodType(), Mathf.Max(0.0f, 1f - BeforeLimb.CirculationBehaviour.GetAmount(BeforeLimb.GetOriginalBloodType())));
                    //BeforeLimb.BruiseCount = (ushort) 0;
                    //BeforeLimb.CirculationBehaviour.GunshotWoundCount = (ushort) 0;
                    //BeforeLimb.CirculationBehaviour.StabWoundCount = (ushort) 0;
                } else { 
                    //Destroy(cObj.GetComponent<ExistInDetailView>());
                    //ShieldSprite.enabled = false;
                    Vector3 normalized = (Vector3) Random.insideUnitCircle.normalized;
                    cObj.transform.localPosition = new Vector3(0.099f, 0f);
                    yield return (object) new WaitForSeconds(1f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.09f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.09f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.08f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.07f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.05f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.04f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.04f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.04f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.04f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.03f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.02f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.02f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.01f);
                    cObj.transform.position += new Vector3(-0.05f, 0f, 0f);
                    yield return (object) new WaitForSeconds(0.01f);
                    cObj.transform.position += new Vector3(0.05f, 0f);
                    yield return (object) new WaitForSeconds(0.01f);
                    cObj.transform.localPosition = new Vector3(0.099f, 0f);
                    HeartBreakSound.Play();
                    cObj.GetComponent<SpriteRenderer>().sprite = BrokenHeart;
                    yield return (object) new WaitForSeconds(1.2f);
                    cObj.GetComponent<SpriteRenderer>().enabled = false;
                    var HeartShard = new GameObject("HeartShard");
                    HeartShard.transform.SetParent(Head);
                    HeartShard.layer = 10;
                    HeartShard.transform.rotation = Quaternion.Euler(0f, 0f, Random.Range(-360f, 360f));
                    HeartShard.transform.localScale = new Vector3(0.45f, 0.45f);
                    HeartShard.transform.position = Head.position;
                    ShardSprite = HeartShard.AddComponent<SpriteRenderer>();
                    ShardSprite.sprite = HeartShard1;
					
					var HeartShard11 = new GameObject("HeartShard11");
                    HeartShard11.transform.SetParent(Head);
                    HeartShard11.layer = 10;
                    HeartShard11.transform.rotation = Quaternion.Euler(0f, 0f, Random.Range(-340f, 340f));
                    HeartShard11.transform.localScale = new Vector3(0.45f, 0.45f);
                    HeartShard11.transform.position = Head.position;
                    ShardSprite1 = HeartShard11.AddComponent<SpriteRenderer>();
                    ShardSprite1.sprite = HeartShard2;
					
					var HeartShard22 = new GameObject("HeartShard22");
                    HeartShard22.transform.SetParent(Head);
                    HeartShard22.layer = 10;
                    HeartShard22.transform.rotation = Quaternion.Euler(0f, 0f, Random.Range(-380f, 380f));
                    HeartShard22.transform.localScale = new Vector3(0.45f, 0.45f);
                    HeartShard22.transform.position = Head.position;
                    ShardSprite2 = HeartShard22.AddComponent<SpriteRenderer>();
                    ShardSprite2.sprite = HeartShard3;
					
					var HeartShard33 = new GameObject("HeartShard33");
                    HeartShard33.transform.SetParent(Head);
                    HeartShard33.layer = 10;
                    HeartShard33.transform.rotation = Quaternion.Euler(0f, 0f, Random.Range(-320f, 320f));
                    HeartShard33.transform.localScale = new Vector3(0.45f, 0.45f);
                    HeartShard33.transform.position = Head.position;
                    ShardSprite3 = HeartShard33.AddComponent<SpriteRenderer>();
                    ShardSprite3.sprite = HeartShard4;
					
					var HeartShard44 = new GameObject("HeartShard44");
                    HeartShard44.transform.SetParent(Head);
                    HeartShard44.layer = 10;
                    HeartShard44.transform.rotation = Quaternion.Euler(0f, 0f, Random.Range(-450f, 450f));
                    HeartShard44.transform.localScale = new Vector3(0.45f, 0.45f);
                    HeartShard44.transform.position = Head.position;
                    ShardSprite4 = HeartShard44.AddComponent<SpriteRenderer>();
                    ShardSprite4.sprite = HeartShard5;

                    HeartShard.AddComponent<Rigidbody2D>();
					HeartShard11.AddComponent<Rigidbody2D>();
					HeartShard22.AddComponent<Rigidbody2D>();
					HeartShard33.AddComponent<Rigidbody2D>();
					HeartShard44.AddComponent<Rigidbody2D>();
					
                    HeartShard.FixColliders();
					HeartShard11.FixColliders();
					HeartShard22.FixColliders();
					HeartShard33.FixColliders();
					HeartShard44.FixColliders();
					
                    GameObject instance = Object.Instantiate<GameObject>(HeartShard, cObj.transform.position, Quaternion.identity);
                    GameObject instance2 = Object.Instantiate<GameObject>(HeartShard11, cObj.transform.position, Quaternion.identity);
                    GameObject instance3 = Object.Instantiate<GameObject>(HeartShard22, cObj.transform.position, Quaternion.identity);
                    GameObject instance4 = Object.Instantiate<GameObject>(HeartShard33, cObj.transform.position, Quaternion.identity);
                    GameObject instance5 = Object.Instantiate<GameObject>(HeartShard44, cObj.transform.position, Quaternion.identity);
                    instance.GetComponent<Rigidbody2D>().AddForce((Vector2) (normalized * 7f * Random.Range(0.5f, 1.3f)), ForceMode2D.Impulse);
                    instance2.GetComponent<Rigidbody2D>().AddForce((Vector2) (normalized * 7f * Random.Range(0.7f, 1.3f)), ForceMode2D.Impulse);
                    instance3.GetComponent<Rigidbody2D>().AddForce((Vector2) (normalized * 7f * Random.Range(0.9f, -1.3f)), ForceMode2D.Impulse);
                    instance4.GetComponent<Rigidbody2D>().AddForce((Vector2) (normalized * 7f * Random.Range(-0.5f, -1.3f)), ForceMode2D.Impulse);
                    instance5.GetComponent<Rigidbody2D>().AddForce((Vector2) (normalized * 7f * Random.Range(0.7f, -1.3f)), ForceMode2D.Impulse);
                    yield return (object) new WaitForSeconds(5f);
                    Destroy(instance);
                    Destroy(instance2);
                    Destroy(instance3);
                    Destroy(instance4);
                    Destroy(instance5);
                }

            }
        }
    }
}
// Originally uploaded by '󠀦󠀦hunter'. Do not reupload without their explicit permission.
