using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;
using System.IO;

namespace Mod
{
	public class Mod
    {			
		public static void Main()
        {
			CategoryBuilder.Create("UNDERTALE Mod", "Adds characters/items from UNDERTALE", ModAPI.LoadSprite("category icon.png"));
Liquid.Register("dustblood", new bblood());	
Liquid.Register("GreenBlood", new blood());
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Frisk",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "It's you!",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/Ficon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/frisk/friskskin.png");
							var flesh = ModAPI.LoadTexture("Characters/frisk/friskflesh.png");
							var bone = ModAPI.LoadTexture("Characters/frisk/friskbone.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
							Instance.AddComponent<SoulBehavior>();
						}
					}
				);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Annoying Dog",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "It's me! Toby Fox, the creator of Undertale! ;)",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Tobyicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/Toby Fox.png"),
								
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/Tobyskinlowerleg.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/Tobyskinlowerleg2.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),

						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Toby Fox & Tem/head.png"),
						
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/Toby Fox.png"),
								
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),

						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Toby Fox & Tem/head.png"),
						
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/Toby Fox.png"),
								
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),

						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
							if (limbs.gameObject.name.Contains("Head"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
							if (limbs.gameObject.name.Contains("UpperBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
							if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerLeg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, 0f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
 						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(-0.215f, -0.44f);
						legLeft.Find("UpperLegFront").GetComponent<SpriteRenderer>().sortingLayerName = "Default";

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0.243f, -0.44f);
						
 						   foreach (var body in persn.Limbs)
							{
								body.transform.root.localScale *= -0.9985f;
	                            body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.gameObject.AddComponent<undeath>();
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.BloodDecal = null;
							} 
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Stick"),
                NameOverride = "Stiсk",
				NameToOrderByOverride = "A-HNR",
                DescriptionOverride = "Its bark is worse than its bite.",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/stcicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/stick.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Bandage", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "It has already been used many times.", 
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Bdgicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Bandage.png"); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 1;
                        prop.sprite = ModAPI.LoadSprite("item/Bandage.png");
                        prop.armorPoints = 50;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );
/* ModAPI.Register(
                 new Modification()
                    {
						OriginalItem = ModAPI.FindSpawnable("Rod"),
						NameOverride = "button RESET",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Resets the current timeline",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("item/RESET.png"),
						AfterSpawn = (Instance) =>
                        {
							Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/RESET.png");
							
							foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/RESET.png");
                            Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
                            Instance.GetComponent<SpriteRenderer>().color = new Color(0.20f, 0.20f, 0.20f, 1f);
							Instance.AddComponent<PolygonCollider2D>();
							
							Instance.FixColliders();
							Instance.transform.root.localScale *= 0.2f;
							
							Instance.AddComponent<ResetBehavior>();
                        }
                    }
				); */
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Flowey",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "In this world, it's kill or BE killed.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Floweyicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {

                    ModAPI.LoadSprite("Characters/flowey/skinhead.png"),
					
                    ModAPI.LoadSprite("Characters/flowey/skinupperbody.png"),
						ModAPI.LoadSprite("Characters/flowey/empty.png"),
						ModAPI.LoadSprite("Characters/flowey/empty.png"),
								
						ModAPI.LoadSprite("Characters/flowey/empty.png"),
						ModAPI.LoadSprite("Characters/flowey/empty.png"),
						ModAPI.LoadSprite("Characters/flowey/empty.png"),
						ModAPI.LoadSprite("Characters/flowey/empty.png"),
						ModAPI.LoadSprite("Characters/flowey/empty.png"),
						ModAPI.LoadSprite("Characters/flowey/empty.png"),

						ModAPI.LoadSprite("Characters/flowey/empty.png"),
						ModAPI.LoadSprite("Characters/flowey/empty.png"),
						ModAPI.LoadSprite("Characters/flowey/empty.png"),
						ModAPI.LoadSprite("Characters/flowey/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/flowey/meathead.png"),
						
						ModAPI.LoadTexture("Characters/flowey/meatupperbody.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
								
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),

						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/flowey/bonehead.png"),
						
						ModAPI.LoadTexture("Characters/flowey/boneupperbody.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
								
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),

						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
						ModAPI.LoadTexture("Characters/flowey/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }					

						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
                        persn.SetBruiseColor(4, 100, 4);
                        persn.SetSecondBruiseColor(0, 70, 3);
                        persn.SetThirdBruiseColor(0, 0, 0);
                        persn.SetBloodColour(2, 150, 30);
                        persn.SetRottenColour(100, 100, 100);

                    var head = Instance.transform.Find("Head");
                    var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0f, 0.625f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.325f);
					
					foreach (var body in persn.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health *= 5000f;
                            body.InitialHealth *= 3500f;
                            body.ShotDamageMultiplier *= 0.2f;
                            body.BreakingThreshold += 700f;
                            body.RegenerationSpeed += 10f;
                            body.Vitality *= 5f;
                            body.ImpactPainMultiplier *= 0.1f;
                            body.Numbness *= 2f;
                            body.CirculationBehaviour.BloodFlow *= 4f;
						}
						
						
					    foreach (LimbBehaviour limb in persn.Limbs)
                        {
                            limb.BloodLiquidType = "GreenBlood";
                            limb.CirculationBehaviour.ClearLiquid();
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("GreenBlood"), 1f);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
				}
			}
		);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Toriel",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "I am TORIEL, caretaker of the RUINS.",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/Ticon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
							var skin = ModAPI.LoadTexture("Characters/toriel/TorielSkin.png");
							var flesh = ModAPI.LoadTexture("Characters/toriel/Torielflesh.png");
							var bone = ModAPI.LoadTexture("Characters/toriel/Torielflesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							Instance.AddComponent<MonsterSoulBehaviour>();
							
							GameObject horns = new GameObject();
							horns.transform.SetParent(Instance.transform.Find("Head"));
							horns.transform.localPosition = new Vector3(-0.086f, -0.015f);
							horns.transform.localScale = new Vector3(0.5f, 0.5f);
							var hornsSprite = horns.AddComponent<SpriteRenderer>();
							hornsSprite.sprite = ModAPI.LoadSprite("Characters/toriel/horns.png");
							hornsSprite.sortingLayerName = "Top";
							
							var backpack1 = new GameObject("Backpack1");
							backpack1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
							backpack1.transform.localPosition = new Vector3(-0.0214f, -0.43f);
							backpack1.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack1Sprite = backpack1.AddComponent<SpriteRenderer>();
							backpack1Sprite.sprite = ModAPI.LoadSprite("Characters/toriel/Skirt.png");
							backpack1.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
							
							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
								
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.transform.root.localScale *= 1.0160f;
								body.BloodDecal = null;
								body.BaseStrength += 6f;
								body.Health *= 4000f;
								body.InitialHealth *= 4400f;
								body.ShotDamageMultiplier *= 0.5f;
								body.BreakingThreshold += 700f;
								body.RegenerationSpeed += 10f;
								body.Vitality *= 5f;
								body.ImpactPainMultiplier *= 0.1f;
								body.Numbness *= 2f;
							}
							
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>();
							dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Insulator"),
                NameOverride = "Butterscotch Cinnamon Pie",
				NameToOrderByOverride = "A-HNR",
                DescriptionOverride = "What could be better than a delicious homemade pie?",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/BCPicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Butterscotch_Cinnamon_Pie.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Dummy",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "A cotton heart and a button eye, You are the apple of my eye.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Dumicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Dummy/head.png"),

							ModAPI.LoadSprite("Characters/Dummy/bodytop.png"),
							ModAPI.LoadSprite("Characters/Dummy/bodymid.png"),
							ModAPI.LoadSprite("Characters/Dummy/bodybot.png"),
							

							ModAPI.LoadSprite("sprites/Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Dummy/empty.png"),

							ModAPI.LoadSprite("sprites/Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Dummy/empty.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Dummy/head.png"),

							ModAPI.LoadTexture("Characters/Dummy/bodytop.png"),
							ModAPI.LoadTexture("Characters/Dummy/bodymid.png"),
							ModAPI.LoadTexture("Characters/Dummy/bodybot.png"),
							

							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),

							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Dummy/head.png"),

							ModAPI.LoadTexture("Characters/Dummy/bodytop.png"),
							ModAPI.LoadTexture("Characters/Dummy/bodymid.png"),
							ModAPI.LoadTexture("Characters/Dummy/bodybot.png"),
							

							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),

							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Dummy/empty.png")
						};
						
							foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
							  if (limbs.gameObject.name.Contains("LowerArmFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperLeg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerLeg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Foot"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("FootFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limb = persn.Limbs;
						for (int i = 0; i < limb.Length; i++)
						{
							limb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limb[i].GetComponents<Collider2D>());
							var hitbox = limb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var daBod = Instance.transform.Find("Body");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						
						head.transform.localPosition = new Vector2(0.08f, 1.242f);
						
  						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.843f);
 						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.5f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, -0.07f);
							
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
 						   foreach (var body in persn.Limbs)
							{
								body.transform.root.localScale *= -0.9890f;
								body.DoBalanceJerk = false;
								body.IsLethalToBreak = false;
								body.BloodDecal = null;
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.gameObject.AddComponent<undeath>();
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
							} 
							
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Froggit",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Life is difficult for this enemy.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Frogicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Froggit/head.png"),
						
						ModAPI.LoadSprite("Characters/Froggit/bodytop.png"),
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
								
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),

						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Froggit/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Froggit/headflesh.png"),
						
						ModAPI.LoadTexture("Characters/Froggit/bodytopflesh.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
								
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),

						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Froggit/headflesh.png"),
						
						ModAPI.LoadTexture("Characters/Froggit/bodytopflesh.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
								
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),

						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
                    var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0.1f, -0.4f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, -1f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
					var dustBehavior = Instance.AddComponent<DustBehavior>();
					dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Whimsun",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This monster is too sensitive to fight...",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Vimicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Whimsun/head.png"),
						
						ModAPI.LoadSprite("Characters/Whimsun/bodytop.png"),
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
								
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),

						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsun/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Whimsun/head.png"),
						
						ModAPI.LoadTexture("Characters/Whimsun/bodytop.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
								
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),

						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Whimsun/head.png"),
						
						ModAPI.LoadTexture("Characters/Whimsun/bodytop.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
								
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),

						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsun/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
							if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0f, 0.4f);
						
						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0f);
						
							AnimationBehaviour1 animBeh = Instance.transform.Find("Head").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							animBeh.AnimationDelay = 0.05f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Whimsun/1.png"),
								ModAPI.LoadSprite("Characters/Whimsun/2.png"),
								ModAPI.LoadSprite("Characters/Whimsun/3.png"),
								ModAPI.LoadSprite("Characters/Whimsun/4.png"),
								ModAPI.LoadSprite("Characters/Whimsun/5.png"),
								ModAPI.LoadSprite("Characters/Whimsun/6.png"),
								ModAPI.LoadSprite("Characters/Whimsun/6.png"),
								ModAPI.LoadSprite("Characters/Whimsun/5.png"),
								ModAPI.LoadSprite("Characters/Whimsun/4.png"),
								ModAPI.LoadSprite("Characters/Whimsun/3.png"),
								ModAPI.LoadSprite("Characters/Whimsun/2.png"),
								ModAPI.LoadSprite("Characters/Whimsun/1.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(-0.3428f, 0.0714f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;

							}
						
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
								

				}
			}
		);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Knife"),
                NameOverride = "Toy Knife",
				NameToOrderByOverride = "A-HNR",
                DescriptionOverride = "Made of plastic. A rarity nowadays.",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/TKicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Toy Knife.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Moldsmal",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Stereotypical: Curvaceously attractive, but no brains...",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Molicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {

                    ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
					
					ModAPI.LoadSprite("Characters/Moldsmal/head.png"),
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
								
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),

						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
						ModAPI.LoadSprite("Characters/Moldsmal/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						
						ModAPI.LoadTexture("Characters/Moldsmal/head.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
								
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),

						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						
						ModAPI.LoadTexture("Characters/Moldsmal/head.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
								
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),

						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
						ModAPI.LoadTexture("Characters/Moldsmal/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
/* 							if (limbs.gameObject.name.Contains("Head"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          } */
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
					
                    head.transform.localPosition = new Vector2(0f, 0.45f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Loox",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Don't pick on him.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Vazovskiicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {

                    ModAPI.LoadSprite("Characters/Loox/head.png"),
					
					ModAPI.LoadSprite("Characters/Loox/bodytop.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
								
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),

						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Loox/head.png"),
						
						ModAPI.LoadTexture("Characters/Loox/bodytop.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
								
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),

						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Loox/head.png"),
						
						ModAPI.LoadTexture("Characters/Loox/bodytop.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
								
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),

						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
					var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0f, 0f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0.015f, -0.375f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
					var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Vegetoid",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Serving Size: 1 Monster.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Vegicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Vegetoid/bodytop.png"),
						
						ModAPI.LoadSprite("Characters/Vegetoid/bodymid.png"),
						ModAPI.LoadSprite("Characters/Vegetoid/bodymid.png"),
						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),
								
						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),
						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),
						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),
						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),
						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),
						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),

						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),
						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),
						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),
						ModAPI.LoadSprite("Characters/Vegetoid/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Vegetoid/bodytop.png"),
						
						ModAPI.LoadTexture("Characters/Vegetoid/bodymid.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/bodymid.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
								
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),

						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Vegetoid/bodytop.png"),
						
						ModAPI.LoadTexture("Characters/Vegetoid/bodymid.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/bodymid.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
								
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),

						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
						ModAPI.LoadTexture("Characters/Vegetoid/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0f, 0.45f);
						
						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0f);
						
						
						var cac = new GameObject("cac");
						cac.transform.SetParent(Instance.transform.Find("Head"));
						cac.transform.localScale = new Vector3(1f, 1f);
						cac.transform.localPosition = new Vector3(0.03f, 0.45f);
						var cacSprite = cac.AddComponent<SpriteRenderer>();
						cacSprite.sprite = ModAPI.LoadSprite("Characters/Vegetoid/hvst.png"); 
						cac.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
						
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);					
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Migosp",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "It seems evil, but it's just with the wrong crowd..",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Micon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Migosp/head.png"),
						
						ModAPI.LoadSprite("Characters/Migosp/bodytop.png"),
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
								
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),

						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
						ModAPI.LoadSprite("Characters/Migosp/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Migosp/head.png"),
						
						ModAPI.LoadTexture("Characters/Migosp/bodytop.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
								
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),

						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Migosp/head.png"),
						
						ModAPI.LoadTexture("Characters/Migosp/bodytop.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
								
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),

						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
						ModAPI.LoadTexture("Characters/Migosp/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
					
						head.transform.localPosition = new Vector2(0f, 0.36f);
						
						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Faded Ribbon", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "If you're cuter, monsters won't hit you as hard.", 
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/FaRiicon.png"),
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Faded_Ribbon.png"); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 1;
                        prop.sprite = ModAPI.LoadSprite("item/Faded_Ribbon.png");
                        prop.armorPoints = 150;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Napstablook",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This monster doesn't seem to have a sense of humor.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Napicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),

							ModAPI.LoadSprite("Characters/Napstablook/bodytop.png"),
							ModAPI.LoadSprite("Characters/Napstablook/bodymid.png"),
							ModAPI.LoadSprite("Characters/Napstablook/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),
							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),
							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),
							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),
							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),
							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),

							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),
							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),
							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),
							ModAPI.LoadSprite("Characters/Napstablook/empty.png"),

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),

							ModAPI.LoadTexture("Characters/Napstablook/bodytop.png"),
							ModAPI.LoadTexture("Characters/Napstablook/bodymid.png"),
							ModAPI.LoadTexture("Characters/Napstablook/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),

							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),

							ModAPI.LoadTexture("Characters/Napstablook/bodytop.png"),
							ModAPI.LoadTexture("Characters/Napstablook/bodymid.png"),
							ModAPI.LoadTexture("Characters/Napstablook/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),

							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
							ModAPI.LoadTexture("Characters/Napstablook/empty.png"),
						};
						
							foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
								if (limbs.gameObject.name.Contains("Head"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerArmFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Leg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Foot"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbpr = persn.Limbs;
						for (int i = 0; i < limbpr.Length; i++)
						{
							limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbpr[i].GetComponents<Collider2D>());
							var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var daBod = Instance.transform.Find("Body");
						
   						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 1.06f);
 						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.425f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, -0.08f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);
							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;
								body.DoBalanceJerk = false;
								body.IsLethalToBreak = false;
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.gameObject.AddComponent<undeath>();
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "sans.",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "i'm Sans. Sans the skeleton.",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/Sansicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/sans/sansskin.png");
							var flesh = ModAPI.LoadTexture("Characters/sans/sansflesh.png");
							var bone = ModAPI.LoadTexture("Characters/sans/sansbone.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
							
							person.SetBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);					
							foreach (var body in person.Limbs)
							{
								body.BloodDecal = null;
								
/* 								if (body.HasBrain)
								{
									body.gameObject.AddComponent<TeleportForward>();

									body.gameObject.AddComponent<UseEventTrigger>().Action = () =>
									{
										body.transform.Find("Body").Find("UpperBody").gameObject.GetComponent<TeleportForward>().Teleport();
									};

								} */
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Stick"),
                NameOverride = "ketchup",
                DescriptionOverride = "What could be better than, a bottle of ketchup, kid?",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/ketchupicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/ketchup.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Crystal"),
                NameOverride = "Bone",
                DescriptionOverride = "Why did the skeleton start a fight? He had a BONE to pick.",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/Boneicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Bone.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
                 new Modification()
                    {
						OriginalItem = ModAPI.FindSpawnable("Rod"),
						NameOverride = "Gaster Blaster",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "do you want to have a BAD TIME?",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/GBicon.png"),
						AfterSpawn = (Instance) =>
                        {
							Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/GasterBlaster1.png");
							Instance.FixColliders();

							var GasterBlasterBehaviour = Instance.GetOrAddComponent<GasterBlasterBehaviour>();

							var GBlaster = Instance.GetComponent<GasterBlasterBehaviour>();

							GBlaster.A = ModAPI.LoadSprite("item/GasterBlaster1.png");
							GBlaster.B = ModAPI.LoadSprite("item/GasterBlaster2.png");
							Instance.AddComponent<UseEventTrigger>().Action = () => {
							Instance.FixColliders();
							};
							Instance.AddComponent<Blaster>();
							Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;
						}
                    }
				);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Papyrus",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Nyeh heh heh!",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/Papsicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/papyrus/Papyrusskin.png");
							var flesh = ModAPI.LoadTexture("Characters/papyrus/Papyrusflesh.png");
							var bone = ModAPI.LoadTexture("Characters/papyrus/Papyrusbone.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);

							var Backpack3 = new GameObject("Backpack3");
							Backpack3.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
							Backpack3.transform.localPosition = new Vector3(0, 0.1f);
							Backpack3.transform.localScale = new Vector3(1f, 1f);
							var Backpack3Sprite = Backpack3.AddComponent<SpriteRenderer>();
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/papyrus/Scarf.png");
							Backpack3.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							Backpack3.AddComponent<UseEventTrigger>().Action = () => {
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/papyrus/Scarf.png");
							};
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BloodDecal = null;
								body.BaseStrength += 2f;
								body.Health *= 2000f;
								body.InitialHealth *= 2200f;
								body.RegenerationSpeed += 2f;
								body.Vitality *= 2f;
								body.Numbness *= 2f;
								body.transform.root.localScale *= 1.0150f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Stick"),
                NameOverride = "spaghetti",
                DescriptionOverride = "I am the great Papyrus, prepared for you the best spaghetti of your life!",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/spaghettiicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/spaghetti.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Crystal"),
					NameOverride = "Blue Bone",
					DescriptionOverride = "Why are bones so calm? Nothing gets under their skin.",
					NameToOrderByOverride = "A-HNR",
					CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
					ThumbnailOverride = ModAPI.LoadSprite("icon/Bone_bluicon.png"),
					AfterSpawn = (Instance) =>
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Bone_blu.png");
						Instance.FixColliders();
					
						GameObject hat2 = new GameObject();
						hat2.transform.SetParent(Instance.transform);
						var hatsprite2 = hat2.AddComponent<SpriteRenderer>();
						hat2.transform.localPosition = new Vector3(0f, 0f);
						hatsprite2.sprite = ModAPI.LoadSprite("item/Bone_blu.png");
						hatsprite2.sortingLayerName = "Default";
						hatsprite2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Bone_blu.png");
						hatsprite2.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
						hatsprite2.GetComponent<SpriteRenderer>().color = new Color(0.10f, 0.10f, 0.10f, 1f);
				}
            }
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Snowdrake",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This teen comedian fights to keep a captive audience.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Snowyicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Snowdrake/head.png"),
						
						ModAPI.LoadSprite("Characters/Snowdrake/bodytop.png"),
						ModAPI.LoadSprite("Characters/Snowdrake/bodytop.png"),
						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),
								
						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),

						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Snowdrake/head.png"),
						
						ModAPI.LoadTexture("Characters/Snowdrake/bodytop.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/bodytop.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
								
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),

						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Snowdrake/head.png"),
						
						ModAPI.LoadTexture("Characters/Snowdrake/bodytop.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/bodytop.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
								
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),

						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
                    var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0.14f, 1.06f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0f);	
					/* daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0f); */
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
 								 
								body.CirculationBehaviour.BloodFlow = 0.000000000f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Chilldrake",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Rebels against everything!! Looking for its friend Snowy.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/chillicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Chilldrake/head.png"),
						
						ModAPI.LoadSprite("Characters/Chilldrake/bodytop.png"),
						ModAPI.LoadSprite("Characters/Chilldrake/bodytop.png"),
						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),
								
						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),
						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),
						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),
						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),
						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),
						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),

						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),
						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),
						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),
						ModAPI.LoadSprite("Characters/Chilldrake/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Chilldrake/head.png"),
						
						ModAPI.LoadTexture("Characters/Chilldrake/bodytop.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/bodytop.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
								
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),

						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Chilldrake/head.png"),
						
						ModAPI.LoadTexture("Characters/Chilldrake/bodytop.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/bodytop.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
								
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),

						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
						ModAPI.LoadTexture("Characters/Chilldrake/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
                    var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0.14f, 1.06f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0f);
					/* daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0f); */
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								 
								body.CirculationBehaviour.BloodFlow = 0.000000000f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Manly Bandanna", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "It has seen some wear. It has abs drawn on it.", 
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/MBicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Manly_Bandanna.png"); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 1;
                        prop.sprite = ModAPI.LoadSprite("item/Manly_Bandanna.png");
                        prop.armorPoints = 250;
                        prop.offset = new Vector2(-1f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Bowling Pin"),
                NameOverride = "Tough Glove",
				NameToOrderByOverride = "A-HNR",
                DescriptionOverride = "A worn pink leather glove. For five fingered folk.",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/ToughGicon.png"),
                AfterSpawn = (Instance) =>
                {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Tough Glove2.png"); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "LowerArmFront";
                        prop.armorTier = 1;
                        prop.sprite = ModAPI.LoadSprite("item/Tough Glove2.png");
                        prop.armorPoints = 50;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Ice Cap",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This teen wonders why it isn't named 'Ice Hat.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/capicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
					ModAPI.LoadSprite("Characters/Ice Cap/head.png"),
					
                    ModAPI.LoadSprite("Characters/Ice Cap/bodytop.png"),
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
							
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),

					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
					ModAPI.LoadSprite("Characters/Ice Cap/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Ice Cap/head.png"),
						
						ModAPI.LoadTexture("Characters/Ice Cap/bodytop.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
								
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),

						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Ice Cap/head.png"),
						
						ModAPI.LoadTexture("Characters/Ice Cap/bodytop.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
								
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),

						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
						ModAPI.LoadTexture("Characters/Ice Cap/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
					var middle = Instance.transform.Find("Head");
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
					
						head.transform.localPosition = new Vector2(0f, 0.35f);
						
						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0f);
						
						
						var cac = new GameObject("cac");
						cac.transform.SetParent(Instance.transform.Find("Head"));
						cac.transform.localScale = new Vector3(1f, 1f);
						cac.transform.localPosition = new Vector3(0.27f, -0.08f);
						var cacSprite = cac.AddComponent<SpriteRenderer>();
						cacSprite.sprite = ModAPI.LoadSprite("Characters/Ice Cap/hvst2.png"); 
						cac.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						

						var ATLASHEAD = new GameObject("ATLASHEAD");
						ATLASHEAD = GameObject.Instantiate(ModAPI.FindSpawnable("Wooden Pillar").Prefab);
						ATLASHEAD.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
						ATLASHEAD.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";

						SpriteRenderer rotorRenderer = ATLASHEAD.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("Characters/Ice Cap/hvst.png");
						ATLASHEAD.transform.SetParent(middle.transform);
						ATLASHEAD.transform.localScale = new Vector3(1f, 1f);
									
						ATLASHEAD.GetComponent<PhysicalBehaviour>().MakeWeightless();
							

						ATLASHEAD.FixColliders();

						HingeJoint2D hingeJoint = ATLASHEAD.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = middle.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;
						limits.min = 0;
                        limits.max = 0;
                        hingeJoint.limits = limits;
                        hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						ATLASHEAD.transform.localPosition = new Vector3(0f, 0.52f);
									
						ATLASHEAD.gameObject.layer = 9;
						
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								 
								body.CirculationBehaviour.BloodFlow = 0.000000000f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						

						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Human"),
					NameOverride = "Doggo",
					NameToOrderByOverride = "A-HNR",
					DescriptionOverride = "Easily excited by movement.",
					CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
					ThumbnailOverride = ModAPI.LoadSprite("icon/Doggoicon.png"),
					AfterSpawn = (Instance) =>
					{
						var persn = Instance.GetComponent<PersonBehaviour>();
						var skin = ModAPI.LoadTexture("Characters/DOGS/doggo/skin.png");
						var flesh = ModAPI.LoadTexture("Characters/DOGS/doggo/flesh.png");
						var bone = ModAPI.LoadTexture("Characters/DOGS/doggo/flesh.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
						
							var Backpack3 = new GameObject("Backpack3");
							Backpack3.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
							Backpack3.transform.localPosition = new Vector3(-0.32f, -0.2f);
							Backpack3.transform.localScale = new Vector3(0.5f, 0.5f);
							var Backpack3Sprite = Backpack3.AddComponent<SpriteRenderer>();
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/DOGS/doggo/hvs.png");
							Backpack3.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							Backpack3.AddComponent<UseEventTrigger>().Action = () => {
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/DOGS/doggo/hvs.png");
							};
							
								var head = Instance.transform.Find("Head");
								head.transform.localPosition = new Vector2(0.055f, 0.72f);
								head.transform.localScale = new Vector3(0.5f, 0.5f);
								
								Instance.transform.Find("Head").GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/DOGS/doggo/head.png");
								Instance.transform.Find("Head").GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadTexture("Characters/DOGS/doggo/headflesh.png"));
								Instance.transform.Find("Head").GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadTexture("Characters/DOGS/doggo/headflesh.png"));

							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.BaseStrength += 1.5f;
								body.Health *= 1100;
								body.InitialHealth *= 1100f;
								body.transform.root.localScale *= 1.0155f;
								if (body.gameObject.name == "Head")
								{
									body.IsLethalToBreak = false;
								}
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
					}
				}
			);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Sword"),
                NameOverride = "knife doggo",
                DescriptionOverride = "Move if you dare",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/knife_doggoicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/knife_doggo.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Nice Cream Guy",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Tell your friends... There's ice cream... Hidden in the depths of a watery cavern...",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/NCGicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/Nice Cream Guy/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/Nice Cream Guy/flesh.png");
							var bone = ModAPI.LoadTexture("Characters/Nice Cream Guy/flesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							GameObject horns = new GameObject();
							horns.transform.SetParent(Instance.transform.Find("Head"));
							horns.transform.localPosition = new Vector3(-0.043f, 0.0568f);
							horns.transform.localScale = new Vector3(0.5f, 0.5f);
							var hornsSprite = horns.AddComponent<SpriteRenderer>();
							hornsSprite.sprite = ModAPI.LoadSprite("Characters/Nice Cream Guy/hairstyle.png");
							hornsSprite.sortingLayerName = "Bubbles";
							
							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Human"),
					NameOverride = "Dogamy",
					NameToOrderByOverride = "A-HNR",
					DescriptionOverride = "What!? It smells like...",
					CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
					ThumbnailOverride = ModAPI.LoadSprite("icon/dogamicon.png"),
					AfterSpawn = (Instance) =>
					{
						var persn = Instance.GetComponent<PersonBehaviour>();
						var skin = ModAPI.LoadTexture("Characters/DOGS/Dogamy and Dogaressa/manskin.png");
						var flesh = ModAPI.LoadTexture("Characters/DOGS/Dogamy and Dogaressa/manflesh.png");
						var bone = ModAPI.LoadTexture("Characters/DOGS/Dogamy and Dogaressa/manflesh.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
						
							var Backpack3 = new GameObject("Backpack3");
							Backpack3.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
							Backpack3.transform.localPosition = new Vector3(-0.32f, 0.04f);
							Backpack3.transform.localScale = new Vector3(0.5f, 0.5f);
							var Backpack3Sprite = Backpack3.AddComponent<SpriteRenderer>();
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/DOGS/Dogamy and Dogaressa/hvs.png");
							Backpack3.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							Backpack3.AddComponent<UseEventTrigger>().Action = () => {
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/DOGS/Dogamy and Dogaressa/hvs.png");
							};
								
								var head = Instance.transform.Find("Head");
								head.transform.localPosition = new Vector2(0.02f, 0.71f);
								head.transform.localScale = new Vector3(0.5f, 0.5f);

								Instance.transform.Find("Head").GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/DOGS/Dogamy and Dogaressa/manhead.png");
								Instance.transform.Find("Head").GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadTexture("Characters/DOGS/Dogamy and Dogaressa/manheadflesh.png"));
								Instance.transform.Find("Head").GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadTexture("Characters/DOGS/Dogamy and Dogaressa/manheadflesh.png"));
								
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.BaseStrength += 1.5f;
								body.Health *= 1100;
								body.InitialHealth *= 1100f;
								body.transform.root.localScale *= 1.0155f;
								if (body.gameObject.name == "Head")
								{
									body.IsLethalToBreak = false;
								}
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
					}
				}
			);
ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Human"),
					NameOverride = "Dogaressa",
					NameToOrderByOverride = "A-HNR",
					DescriptionOverride = "(Are you really a little puppy!?)",
					CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
					ThumbnailOverride = ModAPI.LoadSprite("icon/Dogaressaicon.png"),
					AfterSpawn = (Instance) =>
					{
						var persn = Instance.GetComponent<PersonBehaviour>();
						var skin = ModAPI.LoadTexture("Characters/DOGS/Dogamy and Dogaressa/womenskin.png");
						var flesh = ModAPI.LoadTexture("Characters/DOGS/Dogamy and Dogaressa/womenflesh.png");
						var bone = ModAPI.LoadTexture("Characters/DOGS/Dogamy and Dogaressa/womenflesh.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
						
							var Backpack3 = new GameObject("Backpack3");
							Backpack3.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
							Backpack3.transform.localPosition = new Vector3(-0.32f, 0.04f);
							Backpack3.transform.localScale = new Vector3(0.5f, 0.5f);
							var Backpack3Sprite = Backpack3.AddComponent<SpriteRenderer>();
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/DOGS/Dogamy and Dogaressa/hvs.png");
							Backpack3.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							Backpack3.AddComponent<UseEventTrigger>().Action = () => {
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/DOGS/Dogamy and Dogaressa/hvs.png");
							};
								
								var head = Instance.transform.Find("Head");
								head.transform.localPosition = new Vector2(0.02f, 0.71f);
								head.transform.localScale = new Vector3(0.5f, 0.5f);

								Instance.transform.Find("Head").GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/DOGS/Dogamy and Dogaressa/womenhead.png");
								Instance.transform.Find("Head").GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", ModAPI.LoadTexture("Characters/DOGS/Dogamy and Dogaressa/womenheadflesh.png"));
								Instance.transform.Find("Head").GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", ModAPI.LoadTexture("Characters/DOGS/Dogamy and Dogaressa/womenheadflesh.png"));
								
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.BaseStrength += 1.5f;
								body.Health *= 1100;
								body.InitialHealth *= 1100f;
								body.transform.root.localScale *= 1.0155f;
								if (body.gameObject.name == "Head")
								{
									body.IsLethalToBreak = false;
								}
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
					}
				}
			);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Sword"),
                NameOverride = "Axe Dogamy & Dogaressa",
                DescriptionOverride = "Show me what you can do, puppy!",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/knife_DS_DGicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/knife_DS_DG.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Lesser Dog",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Wields a stone dogger made of pomer-granite.",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/SDicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/DOGS/small dog/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/DOGS/small dog/flesh.png");
							var bone = ModAPI.LoadTexture("Characters/DOGS/small dog/flesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							var Backpack3 = new GameObject("Backpack3");
							Backpack3.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
							Backpack3.transform.localPosition = new Vector3(-0.335f, 0.026f);
							Backpack3.transform.localScale = new Vector3(0.5f, 0.5f);
							var Backpack3Sprite = Backpack3.AddComponent<SpriteRenderer>();
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/DOGS/small dog/hvs.png");
							Backpack3.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							Backpack3.AddComponent<UseEventTrigger>().Action = () => {
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/DOGS/small dog/hvs.png");
							};

							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								if (body.gameObject.name == "UpperBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "Head")
								{
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BloodDecal = null;
								}
								else if (body.gameObject.name == "MiddleBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperLegFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperLeg")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperArmFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerArmFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperArm")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerArm")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Sword"),
                NameOverride = "Sword Lesser Dog",
                DescriptionOverride = "",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/knife_SDicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/knife_SD.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Shield Lesser Dog",
                DescriptionOverride = "",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/Shield_SDicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Shield_SD.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Greater Dog",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "It's so excited that it thinks fighting is just play",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/BDicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/DOGS/big dog/head.png"),

							ModAPI.LoadSprite("Characters/DOGS/big dog/bodytop.png"),
							ModAPI.LoadSprite("Characters/DOGS/big dog/bodymid.png"),
							ModAPI.LoadSprite("Characters/DOGS/big dog/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/DOGS/big dog/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/DOGS/big dog/legbot.png"),
							ModAPI.LoadSprite("Characters/DOGS/big dog/foot.png"),
							ModAPI.LoadSprite("Characters/DOGS/big dog/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/DOGS/big dog/legbot.png"),
							ModAPI.LoadSprite("Characters/DOGS/big dog/foot.png"),

							ModAPI.LoadSprite("Characters/DOGS/big dog/armtop.png"),
							ModAPI.LoadSprite("Characters/DOGS/big dog/armbot.png"),
							ModAPI.LoadSprite("Characters/DOGS/big dog/armtop.png"),
							ModAPI.LoadSprite("Characters/DOGS/big dog/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/DOGS/big dog/headflesh.png"),

							ModAPI.LoadTexture("Characters/DOGS/big dog/bodytop.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/bodymid.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/DOGS/big dog/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/legbot.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/foot.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/legbot.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/foot.png"),

							ModAPI.LoadTexture("Characters/DOGS/big dog/armtop.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/armbotflesh.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/armtop.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/armbotflesh.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/DOGS/big dog/headflesh.png"),

							ModAPI.LoadTexture("Characters/DOGS/big dog/bodytop.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/bodymid.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/DOGS/big dog/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/legbot.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/foot.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/legbot.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/foot.png"),

							ModAPI.LoadTexture("Characters/DOGS/big dog/armtop.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/armbotflesh.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/armtop.png"),
							ModAPI.LoadTexture("Characters/DOGS/big dog/armbotflesh.png")
						};
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0.029f, 1.682f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0.014f, 1.011f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.369f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, -0.075f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
 						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.5f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(0.04f, -0.9f);
						legLeft.Find("FootFront").transform.localPosition = new Vector2(0.097f, -1.142f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.5f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(0.04f, -0.9f);
						legRight.Find("Foot").transform.localPosition = new Vector2(0.097f, -1.142f);
						
						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(0f, 0.5f);
 						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(0f, -0.3f);
						
						armRight.Find("UpperArm").transform.localPosition = new Vector2(0f, 0.5f);
 						armRight.Find("LowerArm").transform.localPosition = new Vector2(0f, -0.3f);
							
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);

							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}	
							
 						foreach (var body in persn.Limbs)
							{
								if (body.gameObject.name == "UpperBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "Head")
								{
									body.BloodDecal = null;
									body.BaseStrength += 7f;
									body.Health *= 4000;
									body.InitialHealth *= 4500;
								}
								else if (body.gameObject.name == "MiddleBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperLegFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerLegFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "FootFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperLeg")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerLeg")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "Foot")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperArmFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerArmFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperArm")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerArm")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								
								body.transform.root.localScale *= -0.9890f;
							}
							
						var cac = new GameObject("cac");
						cac.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
						cac.transform.localScale = new Vector3(1f, 1f);
						cac.transform.localPosition = new Vector3(-0.5f, 0.1f);
						var cacSprite = cac.AddComponent<SpriteRenderer>();
						cacSprite.sprite = ModAPI.LoadSprite("Characters/DOGS/big dog/hvs.png"); 
						cac.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Spear"),
                NameOverride = "Spear Greater Dog",
                DescriptionOverride = "",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/knife_BDicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/knife_BD.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Jerry",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Everyone knows Jerry",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Jericon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {

                    ModAPI.LoadSprite("Characters/Jerry/empty.png"),
					
					ModAPI.LoadSprite("Characters/Jerry/head.png"),
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
								
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),

						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
						ModAPI.LoadSprite("Characters/Jerry/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						
						ModAPI.LoadTexture("Characters/Jerry/head.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
								
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),

						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						
						ModAPI.LoadTexture("Characters/Jerry/head.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
								
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),

						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
						ModAPI.LoadTexture("Characters/Jerry/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
							if (limbs.gameObject.name.Contains("Head"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
					
                    head.transform.localPosition = new Vector2(0f, 0f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Snowdin Shopkeeper",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Hello, traveller. How can I help you?",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/SNSPicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/Snowdin Shopkeeper/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/Snowdin Shopkeeper/skin.png");
							var bone = ModAPI.LoadTexture("Characters/Snowdin Shopkeeper/skin.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							GameObject horns = new GameObject();
							horns.transform.SetParent(Instance.transform.Find("Head"));
							horns.transform.localPosition = new Vector3(-0.0215f, 0.121f);
							horns.transform.localScale = new Vector3(0.5f, 0.5f);
							var hornsSprite = horns.AddComponent<SpriteRenderer>();
							hornsSprite.sprite = ModAPI.LoadSprite("Characters/Snowdin Shopkeeper/hvst.png");
							hornsSprite.sortingLayerName = "Top";
							
							var backpack1 = new GameObject("Backpack1");
							backpack1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
							backpack1.transform.localPosition = new Vector3(-0.0073f, -0.43f);
							backpack1.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack1Sprite = backpack1.AddComponent<SpriteRenderer>();
							backpack1Sprite.sprite = ModAPI.LoadSprite("Characters/Snowdin Shopkeeper/hvst2.png");
							backpack1.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
							
							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BloodDecal = null;
								body.transform.root.localScale *= 1.0080f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Monster kid",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Hey, don't tell my parents I'm here. Ha ha.",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/MKicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/monster kid/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/monster kid/flesh.png");
							var bone = ModAPI.LoadTexture("Characters/monster kid/flesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1f);
							
							GameObject horns = new GameObject();
							horns.transform.SetParent(Instance.transform.Find("Head"));
							horns.transform.localPosition = new Vector3(0.1858f, 0.01427f);
							horns.transform.localScale = new Vector3(1f, 1f);
							var hornsSprite = horns.AddComponent<SpriteRenderer>();
							hornsSprite.sprite = ModAPI.LoadSprite("Characters/monster kid/hairstyle.png");
							hornsSprite.sortingLayerName = "Top";
							
							foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
							  if (limbs.gameObject.name.Contains("LowerArmFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
							
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Grillby",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "...",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/Grilbsicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/grillby/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/grillby/skin.png");
							var bone = ModAPI.LoadTexture("Characters/grillby/skin.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");

							var cac3 = new GameObject("cac3");
							cac3.transform.SetParent(Instance.transform.Find("Head"));
							cac3.transform.localScale = new Vector3(0.5f, 0.5f);
							cac3.transform.localPosition = new Vector3(0f, 0f);
							var cac3Sprite = cac3.AddComponent<SpriteRenderer>();
							cac3Sprite.sprite = ModAPI.LoadSprite("Characters/grillby/head.png");
							cac3Sprite.material = ModAPI.FindMaterial("VeryBright");
							cac3Sprite.GetComponent<SpriteRenderer>().color = new Color(0.20f, 0.20f, 0.20f, 1f);
							cac3.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
							
							var cac = new GameObject("cac");
							cac.transform.SetParent(Instance.transform.Find("FrontArm").Find("LowerArmFront"));
							cac.transform.localScale = new Vector3(0.5f, 0.5f);
							cac.transform.localPosition = new Vector3(0f, 0f);
							var cacSprite = cac.AddComponent<SpriteRenderer>();
							cacSprite.sprite = ModAPI.LoadSprite("Characters/grillby/hvst.png");
							cacSprite.material = ModAPI.FindMaterial("VeryBright");
							cacSprite.GetComponent<SpriteRenderer>().color = new Color(0.20f, 0.20f, 0.20f, 1f);
							cac.GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							
							var cac1 = new GameObject("cac1");
							cac1.transform.SetParent(Instance.transform.Find("BackArm").Find("LowerArm"));
							cac1.transform.localScale = new Vector3(0.5f, 0.5f);
							cac1.transform.localPosition = new Vector3(0f, 0f);
							var cac1Sprite = cac1.AddComponent<SpriteRenderer>();
							cac1Sprite.sprite = ModAPI.LoadSprite("Characters/grillby/hvst.png");
							cac1Sprite.material = ModAPI.FindMaterial("VeryBright");
							cac1Sprite.GetComponent<SpriteRenderer>().color = new Color(0.20f, 0.20f, 0.20f, 1f);
							cac1.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							
							AnimationBehaviour2 animBeh = Instance.transform.Find("Head").gameObject.AddComponent<AnimationBehaviour2>();
							animBeh.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
							animBeh.AnimationDelay = 0.1f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/grillby/1.png"),
								ModAPI.LoadSprite("Characters/grillby/2.png"),
								ModAPI.LoadSprite("Characters/grillby/3.png"),
								ModAPI.LoadSprite("Characters/grillby/4.png"),
								ModAPI.LoadSprite("Characters/grillby/5.png"),
								ModAPI.LoadSprite("Characters/grillby/6.png"),
								ModAPI.LoadSprite("Characters/grillby/7.png"),
								ModAPI.LoadSprite("Characters/grillby/8.png"),
							};
							animBeh.AnimationObject.transform.localScale = new Vector3(0.5f, 0.5f, 1f);
							animBeh.AnimationObject.transform.localPosition = new Vector3(-0.07143f, 0.12855f);
							animBeh.AnimationObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
							animBeh.AnimationObject.GetComponent<SpriteRenderer>().color = new Color(0.20f, 0.20f, 0.20f, 1f);

							Instance.transform.Find("BackArm").Find("UpperArm").GetComponent<SpriteRenderer>().sortingLayerName = "Background";
							Instance.transform.Find("BackArm").Find("LowerArm").GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BloodDecal = null;
								body.transform.root.localScale *= 1.0150f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
						}
					}
				);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Mad Mew Mew",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Once I fuse with this PERFECT new body, mew~ A brand new, WONDERFUL life is going to begin!",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/MMMicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Mad Mew Mew/head.png"),

							ModAPI.LoadSprite("Characters/Mad Mew Mew/bodytop.png"),
							ModAPI.LoadSprite("Characters/Mad Mew Mew/bodymid.png"),
							ModAPI.LoadSprite("Characters/Mad Mew Mew/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/Mad Mew Mew/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Mad Mew Mew/legbot.png"),
							ModAPI.LoadSprite("Characters/Mad Mew Mew/foot.png"),
							ModAPI.LoadSprite("Characters/Mad Mew Mew/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Mad Mew Mew/legbot.png"),
							ModAPI.LoadSprite("Characters/Mad Mew Mew/foot.png"),

							ModAPI.LoadSprite("Characters/Mad Mew Mew/armtop.png"),
							ModAPI.LoadSprite("Characters/Mad Mew Mew/armbot.png"),
							ModAPI.LoadSprite("Characters/Mad Mew Mew/armtop.png"),
							ModAPI.LoadSprite("Characters/Mad Mew Mew/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Mad Mew Mew/head.png"),

							ModAPI.LoadTexture("Characters/Mad Mew Mew/bodytop.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/bodymid.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Mad Mew Mew/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/legbot.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/foot.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/legbot.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/foot.png"),

							ModAPI.LoadTexture("Characters/Mad Mew Mew/armtop.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/armbot.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/armtop.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/armbot.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Mad Mew Mew/head.png"),

							ModAPI.LoadTexture("Characters/Mad Mew Mew/bodytop.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/bodymid.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Mad Mew Mew/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/legbot.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/foot.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/legbot.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/foot.png"),

							ModAPI.LoadTexture("Characters/Mad Mew Mew/armtop.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/armbot.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/armtop.png"),
							ModAPI.LoadTexture("Characters/Mad Mew Mew/armbot.png")
						};
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limb = persn.Limbs;
						for (int i = 0; i < limb.Length; i++)
						{
							limb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limb[i].GetComponents<Collider2D>());
							var hitbox = limb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(-0.04f, 0.82f);
						head.transform.localScale = new Vector2(0.84f, 0.84f);
						
						daBod.Find("UpperBody").transform.localPosition = new Vector2(-0.0145f, 0.38f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(-0.0145f, 0.104f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, -0.24f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.55f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(0f, -0.85f);
						legLeft.Find("FootFront").transform.localPosition = new Vector2(0.07f, -1.05f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.55f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(0f, -0.85f);
						legRight.Find("Foot").transform.localPosition = new Vector2(0.07f, -1.05f);
						
/* 						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(-0.05f, -0.12f);
						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(-0.05f, -0.72f);
						
						armRight.Find("UpperArm").transform.localPosition = new Vector2(-0.05f, -0.12f);
						armRight.Find("LowerArm").transform.localPosition = new Vector2(-0.05f, -0.72f); */
						
						var cac = new GameObject("cac");
						cac.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
						cac.transform.localScale = new Vector3(1f, 1f);
						cac.transform.localPosition = new Vector3(-0.38f, 0.05f);
						var cacSprite = cac.AddComponent<SpriteRenderer>();
						cacSprite.sprite = ModAPI.LoadSprite("Characters/Mad Mew Mew/hvst.png"); 
						cac.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
 						foreach (var body in persn.Limbs)
							{
								body.transform.root.localScale *= -0.9890f;
							}
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Old Tutu", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Finally, a protective piece of armor.", 
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Tutuicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Old_Tutu.png"); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 1;
                        prop.sprite = ModAPI.LoadSprite("item/Old_Tutu.png");
                        prop.armorPoints = 300;
                        prop.offset = new Vector2(0f, -3f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "River Person",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Tra la la. I am the riverman. Or am I the riverwoman...? It doesn't really matter. I love to ride in my boat. Would you care to join me?",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/RPicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/River Person/head.png"),

							ModAPI.LoadSprite("Characters/River Person/bodytop.png"),
							ModAPI.LoadSprite("Characters/River Person/bodymid.png"),
							ModAPI.LoadSprite("Characters/River Person/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/River Person/empty.png"),
							ModAPI.LoadSprite("Characters/River Person/empty.png"),
							ModAPI.LoadSprite("Characters/River Person/empty.png"),
							ModAPI.LoadSprite("Characters/River Person/empty.png"),
							ModAPI.LoadSprite("Characters/River Person/empty.png"),
							ModAPI.LoadSprite("Characters/River Person/empty.png"),

							ModAPI.LoadSprite("Characters/River Person/empty.png"),
							ModAPI.LoadSprite("Characters/River Person/empty.png"),
							ModAPI.LoadSprite("Characters/River Person/empty.png"),
							ModAPI.LoadSprite("Characters/River Person/empty.png"),

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/River Person/head.png"),

							ModAPI.LoadTexture("Characters/River Person/bodytop.png"),
							ModAPI.LoadTexture("Characters/River Person/bodymid.png"),
							ModAPI.LoadTexture("Characters/River Person/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),

							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/River Person/head.png"),

							ModAPI.LoadTexture("Characters/River Person/bodytop.png"),
							ModAPI.LoadTexture("Characters/River Person/bodymid.png"),
							ModAPI.LoadTexture("Characters/River Person/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),

							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
							ModAPI.LoadTexture("Characters/River Person/empty.png"),
						};
						
							foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
							  if (limbs.gameObject.name.Contains("LowerArmFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Leg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Foot"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0f, 1.63f);
						
  						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 1.06f);
 						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.48f);
					/*	daBod.Find("LowerBody").transform.localPosition = new Vector2(-0.015f, -0.45f); */
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.transform.root.localScale *= -0.9890f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
						
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Stick"),
                NameOverride = "Boat",
                DescriptionOverride = "",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/Boaticon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Boat.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Aaron",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This seahorse has a lot of HP (Horsepower)",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Aaronicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Aaron/head.png"),

							ModAPI.LoadSprite("Characters/Aaron/bodytop.png"),
							ModAPI.LoadSprite("Characters/Aaron/bodymid.png"),
							ModAPI.LoadSprite("Characters/Aaron/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/Aaron/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Aaron/empty.png"),
							ModAPI.LoadSprite("Characters/Aaron/empty.png"),
							ModAPI.LoadSprite("Characters/Aaron/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Aaron/empty.png"),
							ModAPI.LoadSprite("Characters/Aaron/empty.png"),

							ModAPI.LoadSprite("Characters/Aaron/armtop.png"),
							ModAPI.LoadSprite("Characters/Aaron/armbot.png"),
							ModAPI.LoadSprite("Characters/Aaron/armtop.png"),
							ModAPI.LoadSprite("Characters/Aaron/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Aaron/headflesh.png"),

							ModAPI.LoadTexture("Characters/Aaron/bodytopflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/bodymidflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/bodybotflesh.png"),
							

							ModAPI.LoadTexture("Characters/Aaron/skinlowerlegflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/empty.png"),
							ModAPI.LoadTexture("Characters/Aaron/empty.png"),
							ModAPI.LoadTexture("Characters/Aaron/skinlowerlegflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/empty.png"),
							ModAPI.LoadTexture("Characters/Aaron/empty.png"),

							ModAPI.LoadTexture("Characters/Aaron/armtopflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/armbotflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/armtopflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/armbotflesh.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Aaron/headflesh.png"),

							ModAPI.LoadTexture("Characters/Aaron/bodytopflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/bodymidflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/bodybotflesh.png"),
							

							ModAPI.LoadTexture("Characters/Aaron/skinlowerlegflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/empty.png"),
							ModAPI.LoadTexture("Characters/Aaron/empty.png"),
							ModAPI.LoadTexture("Characters/Aaron/skinlowerlegflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/empty.png"),
							ModAPI.LoadTexture("Characters/Aaron/empty.png"),

							ModAPI.LoadTexture("Characters/Aaron/armtopflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/armbotflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/armtopflesh.png"),
							ModAPI.LoadTexture("Characters/Aaron/armbotflesh.png")
						};
						
						foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
							  if (limbs.gameObject.name.Contains("UpperLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerLeg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Foot"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0.187f, 1.35f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0.0575f, 0.76f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0.0282f, 0.3f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, 0f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(-0.27f, -0.4f);
						
 						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(0f, 0.2f);
 						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(0.0145f, -0.29f);
						
 						armRight.Find("UpperArm").transform.localPosition = new Vector2(0f, 0.2f);
 						armRight.Find("LowerArm").transform.localPosition = new Vector2(0.0145f, -0.29f);
						
						GameObject hat2 = new GameObject();
						hat2.transform.SetParent(Instance.transform.Find("Head"));
						hat2.transform.localPosition = new Vector3(-0.14f, 0.09f);
						hat2.transform.localScale = new Vector3(1f, 1f);
						var hatsprite2 = hat2.AddComponent<SpriteRenderer>();
						hatsprite2.sprite = ModAPI.LoadSprite("Characters/Aaron/hvst.png");
						hatsprite2.sortingLayerName = "Default";
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Moldbygg",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "One size greater than Moldaverage.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/MOBIicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Moldbygg/head.png"),
						
						ModAPI.LoadSprite("Characters/Moldbygg/bodytop.png"),
						ModAPI.LoadSprite("Characters/Moldbygg/bodymid.png"),
						ModAPI.LoadSprite("Characters/Moldbygg/bodybot.png"),
								
						ModAPI.LoadSprite("Characters/Moldbygg/skinlowerleg.png"),
						ModAPI.LoadSprite("Characters/Moldbygg/empty.png"),
						ModAPI.LoadSprite("Characters/Moldbygg/empty.png"),
						ModAPI.LoadSprite("Characters/Moldbygg/skinlowerleg.png"),
						ModAPI.LoadSprite("Characters/Moldbygg/empty.png"),
						ModAPI.LoadSprite("Characters/Moldbygg/empty.png"),

						ModAPI.LoadSprite("Characters/Moldbygg/empty.png"),
						ModAPI.LoadSprite("Characters/Moldbygg/empty.png"),
						ModAPI.LoadSprite("Characters/Moldbygg/empty.png"),
						ModAPI.LoadSprite("Characters/Moldbygg/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Moldbygg/head.png"),
						
						ModAPI.LoadTexture("Characters/Moldbygg/bodytop.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/bodymid.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/bodybot.png"),
								
						ModAPI.LoadTexture("Characters/Moldbygg/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),

						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Moldbygg/head.png"),
						
						ModAPI.LoadTexture("Characters/Moldbygg/bodytop.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/bodymid.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/bodybot.png"),
								
						ModAPI.LoadTexture("Characters/Moldbygg/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),

						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
						ModAPI.LoadTexture("Characters/Moldbygg/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerLeg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerLegFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperLegFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }
					
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0f, 1.63f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 1.1f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.72f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, 0.36f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.05f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Woshua",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This humble germophobe seeks to cleanse the whole world.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Woshicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
						
						ModAPI.LoadSprite("Characters/Woshua/bodytop.png"),
						ModAPI.LoadSprite("Characters/Woshua/bodymid.png"),
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
								
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),

						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
						ModAPI.LoadSprite("Characters/Woshua/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						
						ModAPI.LoadTexture("Characters/Woshua/bodytop.png"),
						ModAPI.LoadTexture("Characters/Woshua/bodymid.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
								
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),

						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						
						ModAPI.LoadTexture("Characters/Woshua/bodytop.png"),
						ModAPI.LoadTexture("Characters/Woshua/bodymid.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
								
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),

						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Woshua/empty.png"),
						ModAPI.LoadTexture("Characters/Froggit/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
/*                           if (limbs.gameObject.name.Contains("Head"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          } */
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
					head.transform.localPosition = new Vector2(0f, 0f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0f);
					/* daBod.Find("UpperBody").GetComponent<SpriteRenderer>().sortingLayerName = "Background"; */
					daBod.Find("MiddleBody").transform.localPosition = new Vector2(0.04f, -0.45f);
					/* daBod.Find("MiddleBody").GetComponent<SpriteRenderer>().sortingLayerName = "Bottom"; */
					
							AnimationBehaviour1 animBeh = Instance.transform.Find("Body").Find("UpperBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh.GetComponent<SpriteRenderer>().sortingOrder = 1;
							animBeh.AnimationDelay = 0.1f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Woshua/head1.png"),
								ModAPI.LoadSprite("Characters/Woshua/head2.png"),
								ModAPI.LoadSprite("Characters/Woshua/head3.png"),
								ModAPI.LoadSprite("Characters/Woshua/head4.png"),
								ModAPI.LoadSprite("Characters/Woshua/head5.png"),
								ModAPI.LoadSprite("Characters/Woshua/head4.png"),
								ModAPI.LoadSprite("Characters/Woshua/head3.png"),
								ModAPI.LoadSprite("Characters/Woshua/head2.png"),
								ModAPI.LoadSprite("Characters/Woshua/head1.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(0.05f, -0.03f);
							
							
							AnimationBehaviour1 animBeh1 = Instance.transform.Find("Body").Find("UpperBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh1.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							animBeh1.AnimationDelay = 0.1f;
							animBeh1.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Woshua/arm1.png"),
								ModAPI.LoadSprite("Characters/Woshua/arm2.png"),
								ModAPI.LoadSprite("Characters/Woshua/arm3.png"),
								ModAPI.LoadSprite("Characters/Woshua/arm4.png"),
								ModAPI.LoadSprite("Characters/Woshua/arm4.png"),
								ModAPI.LoadSprite("Characters/Woshua/arm3.png"),
								ModAPI.LoadSprite("Characters/Woshua/arm2.png"),
								ModAPI.LoadSprite("Characters/Woshua/arm1.png"),
							};
							animBeh1.AnimationObject.transform.localPosition = new Vector3(0.5f, -0.055f);
							
							
							AnimationBehaviour1 animBeh2 = Instance.transform.Find("Body").Find("UpperBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh2.GetComponent<SpriteRenderer>().sortingOrder = 1;
							animBeh2.AnimationDelay = 0.15f;
							animBeh2.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Woshua/hvst1.png"),
								ModAPI.LoadSprite("Characters/Woshua/hvst2.png"),
								ModAPI.LoadSprite("Characters/Woshua/hvst3.png"),
								ModAPI.LoadSprite("Characters/Woshua/hvst3.png"),
								ModAPI.LoadSprite("Characters/Woshua/hvst2.png"),
								ModAPI.LoadSprite("Characters/Woshua/hvst1.png"),
							};
							animBeh2.AnimationObject.transform.localPosition = new Vector3(0.055f, 0.212f);
							
							
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
					
					var allColliders = Instance.GetComponentsInChildren<Collider2D>();
					foreach (var a in allColliders)
						foreach (var b in allColliders)

							Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Ballet Shoes",
					NameToOrderByOverride = "A-HNR",					
                    DescriptionOverride = "These used shoes make you feel incredibly dangerous.", 
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/BSicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Ballet_Shoes.png"); 

                        int PartCount = 2;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "Foot";
                        prop.armorTier = 1;
                        prop.sprite = ModAPI.LoadSprite("item/Ballet_Shoes.png");
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 100;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("item/Ballet_Shoes.png");
                        armProp[0].armorPiece = "FootFront";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 1;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 100;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Undyne",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "The heroine that NEVER gives up.",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/Unicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/undyne/Undyneskin.png");
							var flesh = ModAPI.LoadTexture("Characters/undyne/Undyneflesh.png");
							var bone = ModAPI.LoadTexture("Characters/undyne/Undyneflesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							GameObject hairstyle = new GameObject();
							hairstyle.transform.SetParent(Instance.transform.Find("Head"));
							hairstyle.transform.localPosition = new Vector3(-0.086f, -0.015f);
							hairstyle.transform.localScale = new Vector3(0.5f, 0.5f);
							var hairstyleSprite = hairstyle.AddComponent<SpriteRenderer>();
							hairstyleSprite.sprite = ModAPI.LoadSprite("Characters/undyne/hairstyle.png");
							hairstyleSprite.sortingLayerName = "Default";
							
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BloodDecal = null;
								body.BaseStrength += 4f;
								body.Health = 10000f;
								body.InitialHealth = 10000f;
								body.BreakingThreshold = 10000f;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.RegenerationSpeed += 10f;
								body.Numbness *= 3f;
								body.CirculationBehaviour.BloodFlow *= 4f;
								body.ImpactPainMultiplier *= 0f;
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.transform.root.localScale *= 1.0160f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
							
							Instance.AddComponent<SpawnsItemWhenDead>().Name = "Undyne the Undying";
							Instance.GetComponent<SpawnsItemWhenDead>().isPerson = true;
							Instance.GetComponent<SpawnsItemWhenDead>().NewSprite = ModAPI.LoadSprite("Characters/undyne/The True Hero/skin.png", 2f);
							Instance.GetComponent<SpawnsItemWhenDead>().IconSprite = ModAPI.LoadSprite("icon/TTHicon.png");
						}
					}
				);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Undyne Armor", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This armor can withstand anything, you snot!",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/ArmorKicon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/UndyneArmor/upperchestplate.png"); 

                        int PartCount = 14;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = ModAPI.LoadSprite("item/UndyneArmor/upperchestplate.png");
                        prop.offset = new Vector3(0.008f, 0f); 
                        prop.scaleOffset = new Vector3(-0.087f, -0.03f);
                        prop.armorPoints = 2000;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("item/UndyneArmor/lowerchestplate.png");
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = new Vector3(0.0065f, 0f); 
                        armProp[0].armorTier = 4;
                        armProp[0].scaleOffset = new Vector3(-0.05f, -0.03f);
                        armProp[0].armorPoints = 2000;

                        armProp[1].sprite = ModAPI.LoadSprite("item/UndyneArmor/faulds.png");
                        armProp[1].armorPiece = "LowerBody";
                        armProp[1].offset = new Vector2(-0.1f, -2.5f) * ModAPI.PixelSize;
                        armProp[1].armorTier = 4;
                        armProp[1].scaleOffset = new Vector3(-0.05f, -0.03f);
                        armProp[1].armorPoints = 2000;
						
                        armProp[2].sprite = ModAPI.LoadSprite("item/UndyneArmor/leatherPadding.png");
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].offset = offset;
                        armProp[2].armorTier = 4;
                        armProp[2].scaleOffset = new Vector3(0.05f, 0.05f);     
                        armProp[2].armorPoints = 2000;
						
                        armProp[3].sprite = ModAPI.LoadSprite("item/UndyneArmor/leatherPadding.png");
                        armProp[3].armorPiece = "UpperArmFront";
                        armProp[3].offset = offset;
                        armProp[3].armorTier = 4;
                        armProp[3].scaleOffset = new Vector3(0.05f, 0.05f);     
                        armProp[3].armorPoints = 2000;
				
                        armProp[4].sprite = ModAPI.LoadSprite("item/UndyneArmor/medievalgauntlet.png");
                        armProp[4].armorPiece = "LowerArm";
                        armProp[4].offset = offset;
                        armProp[4].armorTier = 4;
                        armProp[4].scaleOffset = new Vector3(0.05f, 0.05f);     
                        armProp[4].armorPoints = 2000;
						
                        armProp[5].sprite = ModAPI.LoadSprite("item/UndyneArmor/medievalgauntlet.png");
                        armProp[5].armorPiece = "LowerArmFront";
                        armProp[5].offset = offset;
                        armProp[5].armorTier = 4;
                        armProp[5].scaleOffset = new Vector3(0.05f, 0.05f);     
                        armProp[5].armorPoints = 2000;
						
                        armProp[6].sprite = ModAPI.LoadSprite("item/UndyneArmor/medievalfauld.png");
                        armProp[6].armorPiece = "UpperLeg";
                        armProp[6].offset = offset;
                        armProp[6].armorTier = 4;
                        armProp[6].scaleOffset = new Vector3(0.05f, 0.05f);     
                        armProp[6].armorPoints = 2000;
						
                        armProp[7].sprite = ModAPI.LoadSprite("item/UndyneArmor/medievalfauld.png");
                        armProp[7].armorPiece = "UpperLegFront";
                        armProp[7].offset = offset;
                        armProp[7].armorTier = 4;
                        armProp[7].scaleOffset = new Vector3(0.05f, 0.05f);     
                        armProp[7].armorPoints = 2000;
						
                        armProp[8].sprite = ModAPI.LoadSprite("item/UndyneArmor/greave.png");
                        armProp[8].armorPiece = "LowerLeg";
                        armProp[8].offset = offset;
                        armProp[8].armorTier = 4;
                        armProp[8].scaleOffset = new Vector3(0.05f, 0.05f);     
                        armProp[8].armorPoints = 2000;
					
                        armProp[9].sprite = ModAPI.LoadSprite("item/UndyneArmor/greave.png");
                        armProp[9].armorPiece = "LowerLegFront";
                        armProp[9].offset = offset;
                        armProp[9].armorTier = 4;
                        armProp[9].scaleOffset = new Vector3(0.05f, 0.05f);     
                        armProp[9].armorPoints = 2000;
						
                        armProp[10].sprite = ModAPI.LoadSprite("item/UndyneArmor/foot.png");
                        armProp[10].armorPiece = "Foot";
                        armProp[10].offset = offset;
                        armProp[10].armorTier = 4;
                        armProp[10].scaleOffset = new Vector3(0.05f, 0.05f);     
                        armProp[10].armorPoints = 2000;
						
                        armProp[11].sprite = ModAPI.LoadSprite("item/UndyneArmor/foot.png");
                        armProp[11].armorPiece = "FootFront";
                        armProp[11].offset = offset;
                        armProp[11].armorTier = 4;
                        armProp[11].scaleOffset = new Vector3(0.05f, 0.05f);     
                        armProp[11].armorPoints = 2000;
						
                        armProp[12].sprite = ModAPI.LoadSprite("item/UndyneArmor/crusaderhelmet.png");
                        armProp[12].armorPiece = "Head";
                        armProp[12].offset = new Vector2(0.5f, 2f) * ModAPI.PixelSize;
                        armProp[12].armorTier = 4;
                        armProp[12].scaleOffset = new Vector3(-0.045f, -0.03f);
                        armProp[12].armorPoints = 2000;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

			if (PlayerPrefs.HasKey("Undertale: Undyne the Undying") && PlayerPrefs.GetInt("Undertale: Undyne the Undying") == 1)
            {
			ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Undyne the Undying",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "THE TRUE HERO",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/TTHicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/undyne/The True Hero/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/undyne/The True Hero/skin.png");
							var bone = ModAPI.LoadTexture("Characters/undyne/The True Hero/skin.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							GameObject hairstyle = new GameObject();
							hairstyle.transform.SetParent(Instance.transform.Find("Head"));
							hairstyle.transform.localPosition = new Vector3(-0.107f, 0.105f);
							hairstyle.transform.localScale = new Vector3(0.5f, 0.5f);
							var hairstyleSprite = hairstyle.AddComponent<SpriteRenderer>();
							hairstyleSprite.sprite = ModAPI.LoadSprite("Characters/undyne/The True Hero/hairstyle.png");
							hairstyleSprite.sortingLayerName = "Default";
							
							var backpack1 = new GameObject("Backpack1");
							backpack1.transform.SetParent(Instance.transform.Find("FrontArm").Find("UpperArmFront"));
							backpack1.transform.localPosition = new Vector3(-0.0785f, 0f);
							backpack1.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack1Sprite = backpack1.AddComponent<SpriteRenderer>();
							backpack1Sprite.sprite = ModAPI.LoadSprite("Characters/undyne/The True Hero/hvst.png");
							backpack1.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
							
							var backpack2 = new GameObject("Backpack2");
							backpack2.transform.SetParent(Instance.transform.Find("BackArm").Find("UpperArm"));
							backpack2.transform.localPosition = new Vector3(-0.0785f, 0f);
							backpack2.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack2Sprite = backpack2.AddComponent<SpriteRenderer>();
							backpack2Sprite.sprite = ModAPI.LoadSprite("Characters/undyne/The True Hero/hvst.png");
							backpack2.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							
							var backpack3 = new GameObject("Backpack3");
							backpack3.transform.SetParent(Instance.transform.Find("FrontArm").Find("LowerArmFront"));
							backpack3.transform.localPosition = new Vector3(-0.0785f, 0.1f);
							backpack3.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack3Sprite = backpack3.AddComponent<SpriteRenderer>();
							backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/undyne/The True Hero/hvst2.png");
							backpack3.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
							
							var backpack4 = new GameObject("Backpack4");
							backpack4.transform.SetParent(Instance.transform.Find("BackArm").Find("LowerArm"));
							backpack4.transform.localPosition = new Vector3(-0.0785f, 0.1f);
							backpack4.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack4Sprite = backpack4.AddComponent<SpriteRenderer>();
							backpack4Sprite.sprite = ModAPI.LoadSprite("Characters/undyne/The True Hero/hvst2.png");
							backpack4.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							
							var Backpack5 = new GameObject("Backpack5");
							Backpack5.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
							Backpack5.transform.localPosition = new Vector3(-0.05f, 0.07f);
							Backpack5.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack5Sprite = Backpack5.AddComponent<SpriteRenderer>();
							backpack5Sprite.sprite = ModAPI.LoadSprite("Characters/undyne/The True Hero/hvst4.png");
							Backpack5.GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							
							var Backpack6 = new GameObject("Backpack6");
							Backpack6.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
							Backpack6.transform.localPosition = new Vector3(-0.0071f, -0.1642f);
							Backpack6.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack6Sprite = Backpack6.AddComponent<SpriteRenderer>();
							backpack6Sprite.sprite = ModAPI.LoadSprite("Characters/undyne/The True Hero/hvst3.png");
							Backpack6.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
							
							AnimationBehaviour2 animBeh = Instance.transform.Find("Head").gameObject.AddComponent<AnimationBehaviour2>();
							animBeh.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							animBeh.AnimationDelay = 0.05f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/1.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/2.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/3.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/4.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/5.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/6.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/7.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/8.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/8.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/9.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/10.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/11.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/12.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/13.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/14.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/15.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/16.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/17.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/17.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/16.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/15.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/14.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/13.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/12.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/11.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/10.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/9.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/8.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/7.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/6.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/5.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/4.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/3.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/2.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/1.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
								ModAPI.LoadSprite("Characters/undyne/The True Hero/Eye animation/0.png"),
							};
							animBeh.AnimationObject.transform.localScale = new Vector3(0.5f, 0.5f, 1f);
							animBeh.AnimationObject.transform.localPosition = new Vector3(0.25f, -0.055f);
							animBeh.AnimationObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
							animBeh.AnimationObject.GetComponent<SpriteRenderer>().color = new Color(0.30f, 0.30f, 0.30f, 0.30f);

	
							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
							
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							

							foreach (var body in person.Limbs)
							{
								if (body.gameObject.name == "UpperBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "Head")
								{
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.BloodDecal = null;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "MiddleBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "LowerBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "UpperLegFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "LowerLegFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "FootFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "UpperLeg")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "LowerLeg")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "Foot")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "UpperArmFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "LowerArmFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "UpperArm")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								else if (body.gameObject.name == "LowerArm")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
									body.BaseStrength += 4f;
									body.Health = float.PositiveInfinity;
									body.InitialHealth = float.MaxValue;
									body.BreakingThreshold = float.PositiveInfinity;
									body.PhysicalBehaviour.Charge = 0f;
									body.ShotDamageMultiplier *= 0f;
									body.Vitality = 0f;
									body.RegenerationSpeed += 10f;
									body.Numbness *= 3f;
									body.ImpactPainMultiplier *= 0f;
									body.IsLethalToBreak = false;
									body.DoBalanceJerk = false;
								}
								
								body.transform.root.localScale *= 1.0160f;
								/* body.gameObject.AddComponent<undeath>(); */
							}
						}
					}
				);
			}
ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Spear"),
					NameOverride = "Spear Undyne",
					DescriptionOverride = "WHEN YOU'RE ABOUT TO DIE!?!",
					NameToOrderByOverride = "A-HNR",
					CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
					ThumbnailOverride = ModAPI.LoadSprite("icon/Spear_UDicon.png"),
					AfterSpawn = (Instance) =>
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Spear.png");
						Instance.FixColliders();
					
					
						GameObject hat2 = new GameObject();
						hat2.transform.SetParent(Instance.transform);
						var hatsprite2 = hat2.AddComponent<SpriteRenderer>();
						hat2.transform.localPosition = new Vector3(0f, 0f);
						hatsprite2.sprite = ModAPI.LoadSprite("item/Spear.png");
						hatsprite2.sortingLayerName = "Default";
						hatsprite2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Spear.png");
						hatsprite2.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
						hatsprite2.GetComponent<SpriteRenderer>().color = new Color(0.10f, 0.10f, 0.10f, 1f);
				}
            }
		);
ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Spear"),
					NameOverride = "Yellow Spear Undyne",
					DescriptionOverride = "NGAAAAAHHHHHHHHHHHHHHHH!",
					NameToOrderByOverride = "A-HNR",
					CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
					ThumbnailOverride = ModAPI.LoadSprite("icon/SpearYE_UDicon.png"),
					AfterSpawn = (Instance) =>
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Spear_Yellow.png");
						Instance.FixColliders();
					
						GameObject hat2 = new GameObject();
						hat2.transform.SetParent(Instance.transform);
						var hatsprite2 = hat2.AddComponent<SpriteRenderer>();
						hat2.transform.localPosition = new Vector3(0f, 0f);
						hatsprite2.sprite = ModAPI.LoadSprite("item/Spear_Yellow.png");
						hatsprite2.sortingLayerName = "Default";
						hatsprite2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Spear_Yellow.png");
						hatsprite2.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
						hatsprite2.GetComponent<SpriteRenderer>().color = new Color(0.10f, 0.10f, 0.10f, 1f);
				}
            }
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Gerson",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "I used to be a hero myself, back in the old days. Gerson, the Hammer of Justice.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Gersonicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Gerson/head.png"),

							ModAPI.LoadSprite("Characters/Gerson/bodytop.png"),
							ModAPI.LoadSprite("Characters/Gerson/bodymid.png"),
							ModAPI.LoadSprite("Characters/Gerson/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/Gerson/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Gerson/legbot.png"),
							ModAPI.LoadSprite("Characters/Gerson/foot.png"),
							ModAPI.LoadSprite("Characters/Gerson/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Gerson/legbot.png"),
							ModAPI.LoadSprite("Characters/Gerson/foot.png"),

							ModAPI.LoadSprite("Characters/Gerson/armtop.png"),
							ModAPI.LoadSprite("Characters/Gerson/armbot.png"),
							ModAPI.LoadSprite("Characters/Gerson/armtop.png"),
							ModAPI.LoadSprite("Characters/Gerson/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Gerson/headflesh.png"),

							ModAPI.LoadTexture("Characters/Gerson/bodytopflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/bodymidflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/bodybotflesh.png"),
							

							ModAPI.LoadTexture("Characters/Gerson/skinlowerlegflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/legbotflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/footflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/skinlowerlegflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/legbotflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/footflesh.png"),

							ModAPI.LoadTexture("Characters/Gerson/armtopflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/armbotflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/armtopflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/armbotflesh.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Gerson/headflesh.png"),

							ModAPI.LoadTexture("Characters/Gerson/bodytopflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/bodymidflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/bodybotflesh.png"),
							

							ModAPI.LoadTexture("Characters/Gerson/skinlowerlegflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/legbotflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/footflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/skinlowerlegflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/legbotflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/footflesh.png"),

							ModAPI.LoadTexture("Characters/Gerson/armtopflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/armbotflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/armtopflesh.png"),
							ModAPI.LoadTexture("Characters/Gerson/armbotflesh.png")
						};
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var middle = Instance.transform.Find("Body").Find("MiddleBody");
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0.131f, 0.74f);
						head.transform.localScale = new Vector3(0.9f, 0.9f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.31f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.02f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, -0.25f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
 						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.55f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(0f, -0.85f);
						legLeft.Find("FootFront").transform.localPosition = new Vector2(0.114f, -1.074f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.55f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(0f, -0.85f);
						legRight.Find("Foot").transform.localPosition = new Vector2(0.114f, -1.074f);
						
 						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(0f, -0.2f);
 						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(0f, -0.67f);
						
 						armRight.Find("UpperArm").transform.localPosition = new Vector2(0f, -0.2f);
 						armRight.Find("LowerArm").transform.localPosition = new Vector2(0f, -0.67f);
						
						var head2 = Instance.transform.GetChild(5);
						var hat2 = new GameObject("hat2");
						hat2.transform.SetParent(head2);
						var hatsprite2 = hat2.AddComponent<SpriteRenderer>();
						hat2.transform.localPosition = new Vector3(0.0497f, -0.311f);
						hatsprite2.sprite = ModAPI.LoadSprite("Characters/Gerson/hvs.png");
						hatsprite2.sortingLayerName = "Bubbles";
						



						var ATLASHEAD = new GameObject("ATLASHEAD");
						ATLASHEAD = GameObject.Instantiate(ModAPI.FindSpawnable("Wooden Pillar").Prefab);
						ATLASHEAD.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
						ATLASHEAD.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";

						SpriteRenderer rotorRenderer = ATLASHEAD.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("Characters/Gerson/hvst.png");
						ATLASHEAD.transform.SetParent(middle.transform);
						ATLASHEAD.transform.localScale = new Vector3(1f, 1f);
									
						ATLASHEAD.GetComponent<PhysicalBehaviour>().MakeWeightless();
							

						ATLASHEAD.FixColliders();

						HingeJoint2D hingeJoint = ATLASHEAD.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = middle.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;
						limits.min = 0;
                        limits.max = 0;
                        hingeJoint.limits = limits;
                        hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						ATLASHEAD.transform.localPosition = new Vector3(-0.31f, 0f);
									
						ATLASHEAD.gameObject.layer = 9;
						
						Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
						Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.BaseStrength += 1.1f;
								body.Health *= 1400;
								body.InitialHealth *= 1500f;
								body.transform.root.localScale *= -0.9970f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Cloudy Glasses", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Glasses marred with wear.", 
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/CGicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Cloudy_Glasses.png"); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 1;
                        prop.sprite = ModAPI.LoadSprite("item/Cloudy_Glasses.png");
                        prop.armorPoints = 200;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Bowling Pin"),
                NameOverride = "Torn Notebook",
				NameToOrderByOverride = "A-HNR",
                DescriptionOverride = "Contains illegible scrawls.",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/Tornbookicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Torn Notebook.png");
					Instance.transform.localScale = new Vector3(0.7f, 0.7f);
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Mad Dummy",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Foolish. Foolish! FOOLISH!",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/MDicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Mad Dummy/head.png"),

							ModAPI.LoadSprite("Characters/Mad Dummy/bodytop.png"),
							ModAPI.LoadSprite("Characters/Mad Dummy/bodymid.png"),
							ModAPI.LoadSprite("Characters/Mad Dummy/bodybot.png"),
							

							ModAPI.LoadSprite("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Mad Dummy/empty.png"),

							ModAPI.LoadSprite("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadSprite("sprites/Mad Dummy/empty.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Mad Dummy/head.png"),

							ModAPI.LoadTexture("Characters/Mad Dummy/bodytop.png"),
							ModAPI.LoadTexture("Characters/Mad Dummy/bodymid.png"),
							ModAPI.LoadTexture("Characters/Mad Dummy/bodybot.png"),
							

							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),

							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Mad Dummy/head.png"),

							ModAPI.LoadTexture("Characters/Mad Dummy/bodytop.png"),
							ModAPI.LoadTexture("Characters/Mad Dummy/bodymid.png"),
							ModAPI.LoadTexture("Characters/Mad Dummy/bodybot.png"),
							

							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),

							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png"),
							ModAPI.LoadTexture("sprites/Mad Dummy/empty.png")
						};
						
							foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
							  if (limbs.gameObject.name.Contains("LowerArmFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperLeg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerLeg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Foot"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("FootFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var daBod = Instance.transform.Find("Body");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						
						head.transform.localPosition = new Vector2(0.08f, 1.242f);
						
  						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.843f);
 						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.5f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, -0.07f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.transform.root.localScale *= -0.9890f;
								body.DoBalanceJerk = false;
								body.IsLethalToBreak = false;
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.gameObject.AddComponent<undeath>();
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
							} 
							
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Shyren",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Si re, si re si mi si mi",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Shicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Shyren/head.png"),
						
						ModAPI.LoadSprite("Characters/Shyren/agenttop.png"),
						ModAPI.LoadSprite("Characters/Shyren/agentmid.png"),
						ModAPI.LoadSprite("Characters/Shyren/empty.png"),
								
						ModAPI.LoadSprite("Characters/Shyren/empty.png"),
						ModAPI.LoadSprite("Characters/Shyren/empty.png"),
						ModAPI.LoadSprite("Characters/Shyren/empty.png"),
						ModAPI.LoadSprite("Characters/Shyren/empty.png"),
						ModAPI.LoadSprite("Characters/Shyren/empty.png"),
						ModAPI.LoadSprite("Characters/Shyren/empty.png"),

						ModAPI.LoadSprite("Characters/Shyren/empty.png"),
						ModAPI.LoadSprite("Characters/Shyren/empty.png"),
						ModAPI.LoadSprite("Characters/Shyren/empty.png"),
						ModAPI.LoadSprite("Characters/Shyren/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Shyren/head.png"),
						
						ModAPI.LoadTexture("Characters/Shyren/agenttop.png"),
						ModAPI.LoadTexture("Characters/Shyren/agentmid.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
								
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),

						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Shyren/head.png"),
						
						ModAPI.LoadTexture("Characters/Shyren/agenttop.png"),
						ModAPI.LoadTexture("Characters/Shyren/agentmid.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
								
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),

						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
						ModAPI.LoadTexture("Characters/Shyren/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
                    var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(-0.14f, 1.6f);
					head.transform.localScale = new Vector2(0.8f, 0.8f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0.015f, 0.86f);
					daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, 0f);
					
 						var cac = new GameObject("cac");
						cac.transform.SetParent(Instance.transform.Find("Head"));
						cac.transform.localScale = new Vector3(1f, 1f);
						cac.transform.localPosition = new Vector3(0.17f, 0.52f);
						var cacSprite = cac.AddComponent<SpriteRenderer>();
						cacSprite.sprite = ModAPI.LoadSprite("Characters/Shyren/hvst.png"); 
						cac.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
 						var cac1 = new GameObject("cac1");
						cac1.transform.SetParent(Instance.transform.Find("Head"));
						cac1.transform.localScale = new Vector3(1f, 1f);
						cac1.transform.localPosition = new Vector3(-0.14f, -0.42f);
						var cac1Sprite = cac1.AddComponent<SpriteRenderer>();
						cac1Sprite.sprite = ModAPI.LoadSprite("Characters/Shyren/hvst2.png"); 
						cac1.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.transform.root.localScale *= -0.9890f;
							} 
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
					
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Bob",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Bob",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Bobicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/head Tem BOB.png"),
						
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/bodytop BOB.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
								
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),

						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/head Tem BOB.png"),
						
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/bodytop BOB.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
								
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),

						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/head Tem BOB.png"),
						
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/bodytop BOB.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
								
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),

						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
                    var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0.22f, -0.42f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, -1f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Temmie",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "hOI!!! i'm tEMMIE!!",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Temicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/head Tem.png"),
						
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/bodytop Tem.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
								
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),

						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadSprite("Characters/Toby Fox & Tem/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/head Tem.png"),
						
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/bodytop Tem.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
								
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),

						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/head Tem.png"),
						
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/bodytop Tem.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
								
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),

						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
						ModAPI.LoadTexture("Characters/Toby Fox & Tem/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
                    var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0.22f, -0.42f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, -1f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Temmie Armor", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "The things you can do with a college education!",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/TemAricon.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/TemArmor/TemArmorUpperBody.png"); 

                        int PartCount = 9;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);
                        Vector3 scaleOffset = new Vector3(0f, 0f);                  
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = ModAPI.LoadSprite("item/TemArmor/TemArmorUpperBody.png");
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;
                        prop.armorPoints = 500;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("item/TemArmor/TemArmorMiddleBody.png");
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 4;
                        armProp[0].scaleOffset = scaleOffset;
                        armProp[0].armorPoints = 500;

                        armProp[1].sprite = ModAPI.LoadSprite("item/TemArmor/TemArmorLowerBody.png");
                        armProp[1].armorPiece = "LowerBody";
                        armProp[1].offset = offset;
                        armProp[1].armorTier = 4;
                        armProp[1].scaleOffset = scaleOffset;
                        armProp[1].armorPoints = 500;
						
                        armProp[2].sprite = ModAPI.LoadSprite("item/TemArmor/TemArmorUpperArm.png");
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].offset = offset;
                        armProp[2].armorTier = 4;
                        armProp[2].scaleOffset = scaleOffset;
                        armProp[2].armorPoints = 500;
						
                        armProp[3].sprite = ModAPI.LoadSprite("item/TemArmor/TemArmorUpperArmFront.png");
                        armProp[3].armorPiece = "UpperArmFront";
                        armProp[3].offset = offset;
                        armProp[3].armorTier = 4;
                        armProp[3].scaleOffset = scaleOffset;
                        armProp[3].armorPoints = 500;
				
                        armProp[4].sprite = ModAPI.LoadSprite("item/TemArmor/TemArmorLowerArm.png");
                        armProp[4].armorPiece = "LowerArm";
                        armProp[4].offset = offset;
                        armProp[4].armorTier = 4;
                        armProp[4].scaleOffset = scaleOffset;
                        armProp[4].armorPoints = 500;
						
                        armProp[5].sprite = ModAPI.LoadSprite("item/TemArmor/TemArmorLowerArmFront.png");
                        armProp[5].armorPiece = "LowerArmFront";
                        armProp[5].offset = offset;
                        armProp[5].armorTier = 4;
                        armProp[5].scaleOffset = scaleOffset;
                        armProp[5].armorPoints = 500;
						
                        armProp[6].sprite = ModAPI.LoadSprite("item/TemArmor/TemArmorUpperLeg.png");
                        armProp[6].armorPiece = "UpperLeg";
                        armProp[6].offset = offset;
                        armProp[6].armorTier = 4;
                        armProp[6].scaleOffset = scaleOffset;
                        armProp[6].armorPoints = 500;
						
                        armProp[7].sprite = ModAPI.LoadSprite("item/TemArmor/TemArmorUpperLegFront.png");
                        armProp[7].armorPiece = "UpperLegFront";
                        armProp[7].offset = offset;
                        armProp[7].armorTier = 4;
                        armProp[7].scaleOffset = scaleOffset;
                        armProp[7].armorPoints = 500;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Alphys",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Ummm... H-h-hiya! I'm Dr. Alphys. I'm ASGORE's royal scientist!",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/ALicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/alphys/alphys skin.png");
							var flesh = ModAPI.LoadTexture("Characters/alphys/alphysflesh.png");
							var bone = ModAPI.LoadTexture("Characters/alphys/alphysflesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							GameObject hairstyle = new GameObject();
							hairstyle.transform.SetParent(Instance.transform.Find("Head"));
							hairstyle.transform.localPosition = new Vector3(-0.01f, -0.007f);
							hairstyle.transform.localScale = new Vector3(0.5f, 0.5f);
							var hairstyleSprite = hairstyle.AddComponent<SpriteRenderer>();
							hairstyleSprite.sprite = ModAPI.LoadSprite("Characters/alphys/hairstyle.png");
							hairstyleSprite.sortingLayerName = "Default";
							
/* 							Sprite[] skinTextures = new Sprite[] {
								ModAPI.LoadSprite("Characters/alphys/alphys hed.png"),
							};
							Texture2D[] meattextures = new Texture2D[] {
								ModAPI.LoadTexture("Characters/alphys/alphys hed.png"),
							};
							Texture2D[] bonetextures = new Texture2D[] {
								ModAPI.LoadTexture("Characters/alphys/alphys hed.png"),
							};
							
							var persn = Instance.GetComponent<PersonBehaviour>();
							var limb = persn.Limbs;
							for (int i = 0; i < limb.Length; i++)
							{
								limb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
								limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
								limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
								foreach (var collider in limb[i].GetComponents<Collider2D>());
								var hitbox = limb[i].gameObject.AddComponent<BoxCollider2D>();
							}
							
							var head = Instance.transform.Find("Head");
							head.transform.localPosition = new Vector2(1f, 1f);
							head.transform.localScale = new Vector3(0.5f, 1.2f);
							
							var allColliders = Instance.GetComponentsInChildren<Collider2D>();
							foreach (var a in allColliders)
								foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b); */
								
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Phone",
                DescriptionOverride = "Hit the yellow button to shoot!",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/Phoneicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Phone.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Mettaton Square",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "I'M NOT GOING TO DESTROY YOU WITHOUT A LIVE TELEVISION AUDIENCE!!",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/MttSicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/mettaton/empty.png"),

							ModAPI.LoadSprite("Characters/mettaton/Square/bodytop.png"),
							ModAPI.LoadSprite("Characters/mettaton/Square/bodymid.png"),
							ModAPI.LoadSprite("Characters/mettaton/Square/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/mettaton/Square/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/mettaton/Square/empty.png"),
							ModAPI.LoadSprite("Characters/mettaton/Square/foot.png"),
							ModAPI.LoadSprite("Characters/mettaton/Square/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/mettaton/Square/empty.png"),
							ModAPI.LoadSprite("Characters/mettaton/Square/foot.png"),

							ModAPI.LoadSprite("Characters/mettaton/Square/armtop.png"),
							ModAPI.LoadSprite("Characters/mettaton/Square/armbot.png"),
							ModAPI.LoadSprite("Characters/mettaton/Square/armtop.png"),
							ModAPI.LoadSprite("Characters/mettaton/Square/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/mettaton/empty.png"),

							ModAPI.LoadTexture("Characters/mettaton/Square/bodytop.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/bodymid.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/mettaton/Square/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/empty.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/foot.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/empty.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/foot.png"),

							ModAPI.LoadTexture("Characters/mettaton/Square/armtop.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/armbot.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/armtop.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/armbot.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/mettaton/empty.png"),

							ModAPI.LoadTexture("Characters/mettaton/Square/bodytop.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/bodymid.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/mettaton/Square/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/empty.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/foot.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/empty.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/foot.png"),

							ModAPI.LoadTexture("Characters/mettaton/Square/armtop.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/armbot.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/armtop.png"),
							ModAPI.LoadTexture("Characters/mettaton/Square/armbot.png")
						};
						
							foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
							  if (limbs.gameObject.name.Contains("Head"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerLeg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Foot"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("FootFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limb = persn.Limbs;
						for (int i = 0; i < limb.Length; i++)
						{
							limb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limb[i].GetComponents<Collider2D>());
							var hitbox = limb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var daBod = Instance.transform.Find("Body");
						
  					 	daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.8f);
 					 	daBod.Find("MiddleBody").transform.localPosition = new Vector2(-0.0144f, 0.32f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, 0.02f);
						
   						foreach (var body in persn.Limbs)
							{
								body.transform.root.localScale *= -0.9890f;
							}
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Burnt Pan",
				NameToOrderByOverride = "A-HNR",
                DescriptionOverride = "Damage is rather consistent.",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/BPanicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Burnt Pan2.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Stained Apron", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Heals 1 HP every other turn.", 
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/SAicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Stained_Apron1.png"); 

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        Vector3 offset = new Vector3(0f, 0f);               
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 1;
                        prop.sprite = ModAPI.LoadSprite("item/Stained_Apron1.png");
                        prop.offset = offset;
                        prop.armorPoints = 250;
                        armor.prop = prop;
                        armor.SetProperties();
                        
                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = ModAPI.LoadSprite("item/Stained_Apron2.png");
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].offset = offset;
                        armProp[0].armorTier = 1;
                        armProp[0].armorPoints = 250;

                        armProp[1].sprite = ModAPI.LoadSprite("item/Stained_Apron3.png");
                        armProp[1].armorPiece = "LowerBody";
                        armProp[1].offset = offset;
                        armProp[1].armorTier = 1;
                        armProp[1].armorPoints = 250;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Vulkin",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Toasty bun!",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/vilicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {

                    ModAPI.LoadSprite("Characters/Vulkin/empty.png"),
					
					ModAPI.LoadSprite("Characters/Vulkin/head.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
								
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),

						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
						ModAPI.LoadSprite("Characters/Loox/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Vulkin/empty.png"),
						
						ModAPI.LoadTexture("Characters/Vulkin/head.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
								
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),

						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Vulkin/empty.png"),
						
						ModAPI.LoadTexture("Characters/Vulkin/head.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
								
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),

						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
						ModAPI.LoadTexture("Characters/Loox/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
/* 							if (limbs.gameObject.name.Contains("Head"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          } */
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
					
                    head.transform.localPosition = new Vector2(0f, 0.45f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Pyrope",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Hot!! HOT!! Hotter!! HOTTER!!",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Pyicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Pyrope/head.png"),
						
						ModAPI.LoadSprite("Characters/Pyrope/bodytop.png"),
						ModAPI.LoadSprite("Characters/Pyrope/bodymid.png"),
						ModAPI.LoadSprite("Characters/Pyrope/bodybot.png"),
								
						ModAPI.LoadSprite("Characters/Pyrope/skinlowerleg.png"),
						ModAPI.LoadSprite("Characters/Pyrope/legbot.png"),
						ModAPI.LoadSprite("Characters/Pyrope/empty.png"),
						ModAPI.LoadSprite("Characters/Pyrope/skinlowerleg.png"),
						ModAPI.LoadSprite("Characters/Pyrope/legbot.png"),
						ModAPI.LoadSprite("Characters/Pyrope/empty.png"),

						ModAPI.LoadSprite("Characters/Pyrope/empty.png"),
						ModAPI.LoadSprite("Characters/Pyrope/empty.png"),
						ModAPI.LoadSprite("Characters/Pyrope/empty.png"),
						ModAPI.LoadSprite("Characters/Pyrope/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Pyrope/head.png"),
						
						ModAPI.LoadTexture("Characters/Pyrope/bodytop.png"),
						ModAPI.LoadTexture("Characters/Pyrope/bodymid.png"),
						ModAPI.LoadTexture("Characters/Pyrope/bodybot.png"),
								
						ModAPI.LoadTexture("Characters/Pyrope/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Pyrope/legbot.png"),
						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),
						ModAPI.LoadTexture("Characters/Pyrope/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Pyrope/legbot.png"),
						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),

						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),
						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),
						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),
						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),
						
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Pyrope/head.png"),
						
						ModAPI.LoadTexture("Characters/Pyrope/bodytop.png"),
						ModAPI.LoadTexture("Characters/Pyrope/bodymid.png"),
						ModAPI.LoadTexture("Characters/Pyrope/bodybot.png"),
								
						ModAPI.LoadTexture("Characters/Pyrope/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Pyrope/legbot.png"),
						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),
						ModAPI.LoadTexture("Characters/Pyrope/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Pyrope/legbot.png"),
						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),

						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),
						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),
						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),
						ModAPI.LoadTexture("Characters/Pyrope/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }
					
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0f, 0.85f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.25f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, -0.01f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, -0.25f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
 						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.47f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(0.15f, -0.7f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.47f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(0.15f, -0.7f);
						
						var cac = new GameObject("cac");
						cac.transform.SetParent(Instance.transform.Find("Head"));
						cac.transform.localScale = new Vector3(1f, 1f);
						cac.transform.localPosition = new Vector3(0f, 0f);
						var cacSprite = cac.AddComponent<SpriteRenderer>();
						cacSprite.sprite = ModAPI.LoadSprite("Characters/Pyrope/hvst2.png");
						cacSprite.material = ModAPI.FindMaterial("VeryBright");
						cacSprite.GetComponent<SpriteRenderer>().color = new Color(0.15f, 0.15f, 0.15f, 1f);
						cac.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
/* 						var cac1 = new GameObject("cac1");
						cac1.transform.SetParent(Instance.transform.Find("Head"));
						cac1.transform.localScale = new Vector3(1f, 1f);
						cac1.transform.localPosition = new Vector3(-0.3f, 0.2857f);
						var cac1Sprite = cac1.AddComponent<SpriteRenderer>();
						cac1Sprite.sprite = ModAPI.LoadSprite("Characters/Pyrope/1.png");
						cac1Sprite.material = ModAPI.FindMaterial("VeryBright");
						cac1Sprite.GetComponent<SpriteRenderer>().color = new Color(0.15f, 0.15f, 0.15f, 1f);
						cac1.GetComponent<SpriteRenderer>().sortingLayerName = "Default"; */
						
							AnimationBehaviour2 animBeh = Instance.transform.Find("Head").gameObject.AddComponent<AnimationBehaviour2>();
							animBeh.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							animBeh.AnimationDelay = 0.1f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Pyrope/1.png"),
								ModAPI.LoadSprite("Characters/Pyrope/2.png"),
								ModAPI.LoadSprite("Characters/Pyrope/3.png"),
								ModAPI.LoadSprite("Characters/Pyrope/4.png"),
								ModAPI.LoadSprite("Characters/Pyrope/5.png"),
								ModAPI.LoadSprite("Characters/Pyrope/6.png"),
								ModAPI.LoadSprite("Characters/Pyrope/7.png"),
								ModAPI.LoadSprite("Characters/Pyrope/8.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(-0.3f, 0.2857f);
							animBeh.AnimationObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
							animBeh.AnimationObject.GetComponent<SpriteRenderer>().color = new Color(0.15f, 0.15f, 0.15f, 1f);
							
/* 							Instance.transform.Find("FrontLeg").Find("LowerLegFront").FixColliders(GameObject);
							Instance.transform.Find("BackLeg").Find("LowerLeg").FixColliders(GameObject); */
							
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
						
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
							
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Muffet",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Don't look so blue, my deary~ ... I think purple is a better look on you! Ahuhuhu~",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/Maficon.png"),
						AfterSpawn = (Instance) =>
						{
/* 							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/Muffet/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/Muffet/skin.png");
							var bone = ModAPI.LoadTexture("Characters/Muffet/skin.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f); */
							
							var skin = ModAPI.LoadTexture("Characters/Muffet/skin.png");
							var skin2 = ModAPI.LoadTexture("Characters/Muffet/skin2.png");
							var skin3 = ModAPI.LoadTexture("Characters/Muffet/skin3.png");
							var flesh = ModAPI.LoadTexture("Characters/Muffet/flesh.png");
							var bone = ModAPI.LoadTexture("Characters/Muffet/skin.png");

							var person = Instance.GetComponent<PersonBehaviour>();
							person.RandomisedSize = false;

							var upper = Instance.transform.Find("Body").Find("UpperBody");

							GameObject croon2 = GameObject.Instantiate(ModAPI.FindSpawnable("Human").Prefab);
							croon2.transform.position = Instance.transform.position;
							var person0 = croon2.gameObject.GetComponent<PersonBehaviour>();

							person0.SetBodyTextures(skin3, flesh, bone, 2f);
							
							
/* 							var arm3 = croon2.transform.Find("FrontArm");
							var arm4 = croon2.transform.Find("BackArm");
							arm3.Find("UpperArmFront").transform.localPosition = new Vector2(0f, -0.25f);
							arm3.Find("LowerArmFront").transform.localPosition = new Vector2(0f, -0.65f);
							
							arm4.Find("UpperArm").transform.localPosition = new Vector2(0f, -0.25f);
							arm4.Find("LowerArm").transform.localPosition = new Vector2(0f, -0.65f); */

							foreach (var limbs in croon2.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
							{
								if (limbs.gameObject.name.Contains("Head"))
							{
							   limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							}
							if (limbs.gameObject.name.Contains("MiddleBody"))
							{
							   limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							}
							if (limbs.gameObject.name.Contains("LowerBody"))
							{
							   limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							}
							if (limbs.gameObject.name.Contains("Leg"))
							{
							   limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							}
							if (limbs.gameObject.name.Contains("Foot"))
							{
							   limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							}
							else
							{
								if (limbs.gameObject.name.Contains("UpperBody"))
							{
								GameObject tank = limbs.gameObject;
								croon2.transform.SetParent(Instance.transform);
						tank.transform.position = upper.gameObject.transform.position;
						tank.transform.eulerAngles = upper.gameObject.transform.eulerAngles;
						tank.gameObject.AddComponent<FixedJoint2D>();
						tank.gameObject.layer = 10;
						tank.transform.root.gameObject.GetComponent<PersonBehaviour>().RandomisedSize = false;
						tank.gameObject.GetComponent<SpriteRenderer>().color = Color.clear;
						tank.gameObject.GetComponent<FixedJoint2D>().connectedBody = upper.gameObject.gameObject.GetComponent<Rigidbody2D>();
						tank.gameObject.GetComponent<FixedJoint2D>().frequency = 10f;
							foreach (var limbs2 in croon2.gameObject.GetComponent<PersonBehaviour>().Limbs)
							{
							var Poop = Instance.gameObject.AddComponent<NoCollide>();
							Poop.NoCollideSetA = limbs2.GetComponentsInChildren<Collider2D>();
							Poop.NoCollideSetB = Instance.gameObject.GetComponentsInChildren<Collider2D>();
							}
							}
							}
							}
							
							
						   GameObject croon = GameObject.Instantiate(ModAPI.FindSpawnable("Human").Prefab);
							croon.transform.position = Instance.transform.position;
							var person2 = croon.gameObject.GetComponent<PersonBehaviour>();

							person2.SetBodyTextures(skin2, flesh, bone, 2f);

							foreach (var limbs in croon.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
							{
								if (limbs.gameObject.name.Contains("Head"))
							{
							   limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							}
							if (limbs.gameObject.name.Contains("MiddleBody"))
							{
							   limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							}
							if (limbs.gameObject.name.Contains("LowerBody"))
							{
							   limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							}
							if (limbs.gameObject.name.Contains("Leg"))
							{
							   limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							}
							if (limbs.gameObject.name.Contains("Foot"))
							{
							   limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							}
							else
							{
								if (limbs.gameObject.name.Contains("UpperBody"))
							{
								GameObject tank = limbs.gameObject;
								croon.transform.SetParent(Instance.transform);
						tank.transform.position = upper.gameObject.transform.position;
						tank.transform.eulerAngles = upper.gameObject.transform.eulerAngles;
						tank.gameObject.AddComponent<FixedJoint2D>();
						tank.gameObject.layer = 10;
						tank.transform.root.gameObject.GetComponent<PersonBehaviour>().RandomisedSize = false;
						tank.gameObject.GetComponent<SpriteRenderer>().color = Color.clear;
						tank.gameObject.GetComponent<FixedJoint2D>().connectedBody = upper.gameObject.gameObject.GetComponent<Rigidbody2D>();
						tank.gameObject.GetComponent<FixedJoint2D>().frequency = 10f;
							foreach (var limbs2 in croon.gameObject.GetComponent<PersonBehaviour>().Limbs)
							{
							var Poop = Instance.gameObject.AddComponent<NoCollide>();
							Poop.NoCollideSetA = limbs2.GetComponentsInChildren<Collider2D>();
							Poop.NoCollideSetB = Instance.gameObject.GetComponentsInChildren<Collider2D>();
							}
							}
							}
							}
							
/* 							var arm5 = croon.transform.Find("FrontArm");
							var arm6 = croon.transform.Find("BackArm");
							arm5.Find("UpperArmFront").transform.localPosition = new Vector2(0f, -0.35f);
							arm6.Find("LowerArmFront").transform.localPosition = new Vector2(0f, -1.5f);
							
							arm5.Find("UpperArm").transform.localPosition = new Vector2(0f, -0.35f);
							arm6.Find("LowerArm").transform.localPosition = new Vector2(0f, -1.5f); */
							
							person.SetBodyTextures(skin, flesh, bone, 2f);

							
							GameObject horns = new GameObject();
							horns.transform.SetParent(Instance.transform.Find("Head"));
							horns.transform.localPosition = new Vector3(-0.0855f, 0.1f);
							horns.transform.localScale = new Vector3(0.5f, 0.5f);
							var hornsSprite = horns.AddComponent<SpriteRenderer>();
							hornsSprite.sprite = ModAPI.LoadSprite("Characters/Muffet/hairstyle.png");
							hornsSprite.sortingLayerName = "Bubbles";
							
							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							croon2.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							croon2.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							croon.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							croon.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "muffin-spider",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Oh, my pet~ Looks like it's time for dessert~",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/MFicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/muffin-spider/head.png"),
						
						ModAPI.LoadSprite("Characters/muffin-spider/bodytop.png"),
						ModAPI.LoadSprite("Characters/muffin-spider/empty.png"),
						ModAPI.LoadSprite("Characters/muffin-spider/empty.png"),
								
						ModAPI.LoadSprite("Characters/muffin-spider/empty.png"),
						ModAPI.LoadSprite("Characters/muffin-spider/empty.png"),
						ModAPI.LoadSprite("Characters/muffin-spider/empty.png"),
						ModAPI.LoadSprite("Characters/muffin-spider/empty.png"),
						ModAPI.LoadSprite("Characters/muffin-spider/empty.png"),
						ModAPI.LoadSprite("Characters/muffin-spider/empty.png"),

						ModAPI.LoadSprite("Characters/muffin-spider/armtop.png"),
						ModAPI.LoadSprite("Characters/muffin-spider/armbot.png"),
						ModAPI.LoadSprite("Characters/muffin-spider/armtop.png"),
						ModAPI.LoadSprite("Characters/muffin-spider/armbot.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/muffin-spider/head.png"),
						
						ModAPI.LoadTexture("Characters/muffin-spider/bodytop.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
								
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),

						ModAPI.LoadTexture("Characters/muffin-spider/armtop.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/armbot.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/armtop.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/armbot.png"),
						
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/muffin-spider/head.png"),
						
						ModAPI.LoadTexture("Characters/muffin-spider/bodytop.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
								
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/empty.png"),

						ModAPI.LoadTexture("Characters/muffin-spider/armtop.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/armbot.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/armtop.png"),
						ModAPI.LoadTexture("Characters/muffin-spider/armbot.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
					var middle = Instance.transform.Find("Body").Find("UpperBody");
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var daBod = Instance.transform.Find("Body");
						var head = Instance.transform.Find("Head");
						
						head.transform.localPosition = new Vector2(0.0145f, 0.528f);
					
						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0f);
						
						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(0.25f, -0.68f);
						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(0.25f, -1.125f);
						
						armRight.Find("UpperArm").transform.localPosition = new Vector2(0.25f, -0.68f);
						armRight.Find("LowerArm").transform.localPosition = new Vector2(0.25f, -1.125f);
						
						
						
						armLeft.Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
						armLeft.Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						
						var ATLASHEAD = new GameObject("ATLASHEAD");
						ATLASHEAD = GameObject.Instantiate(ModAPI.FindSpawnable("Wooden Pillar").Prefab);
						ATLASHEAD.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
						ATLASHEAD.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";

						SpriteRenderer rotorRenderer = ATLASHEAD.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("Characters/muffin-spider/hvst.png");
						ATLASHEAD.transform.SetParent(middle.transform);
						ATLASHEAD.transform.localScale = new Vector3(1f, 1f);
									
						ATLASHEAD.GetComponent<PhysicalBehaviour>().MakeWeightless();
							

						ATLASHEAD.FixColliders();

						HingeJoint2D hingeJoint = ATLASHEAD.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = middle.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;
						limits.min = 0;
                        limits.max = 0;
                        hingeJoint.limits = limits;
                        hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						ATLASHEAD.transform.localPosition = new Vector3(-0.0153f, -0.4275f);
									
						ATLASHEAD.gameObject.layer = 9;
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
					var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "01",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Let's stop him together, bro.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/01icon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Royal Guards/01/head.png"),

							ModAPI.LoadSprite("Characters/Royal Guards/01/bodytop.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/01/bodymid.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/01/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/Royal Guards/01/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/01/legbot.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/01/foot.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/01/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/01/legbot.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/01/foot.png"),

							ModAPI.LoadSprite("Characters/Royal Guards/01/armtop.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/01/armbot.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/01/armtop.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/01/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Royal Guards/01/head.png"),

							ModAPI.LoadTexture("Characters/Royal Guards/01/bodytop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/bodymid.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Royal Guards/01/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/legbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/foot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/legbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/foot.png"),

							ModAPI.LoadTexture("Characters/Royal Guards/01/armtop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/armbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/armtop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/armbot.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Royal Guards/01/head.png"),

							ModAPI.LoadTexture("Characters/Royal Guards/01/bodytop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/bodymid.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Royal Guards/01/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/legbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/foot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/legbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/foot.png"),

							ModAPI.LoadTexture("Characters/Royal Guards/01/armtop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/armbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/armtop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/01/armbot.png")
						};
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0.044f, 1.086f);
						
						daBod.Find("UpperBody").transform.localPosition = new Vector2(0.0425f, 0.405f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, -0.065f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(-0.015f, -0.45f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.755f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(-0.03f, -1.04f);
						legLeft.Find("FootFront").transform.localPosition = new Vector2(0.085f, -1.25f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.755f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(-0.03f, -1.04f);
						legRight.Find("Foot").transform.localPosition = new Vector2(0.085f, -1.25f);
						
						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(-0.05f, -0.12f);
						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(-0.05f, -0.72f);
						
						armRight.Find("UpperArm").transform.localPosition = new Vector2(-0.05f, -0.12f);
						armRight.Find("LowerArm").transform.localPosition = new Vector2(-0.05f, -0.72f);
						
						persn.SetBruiseColor(255, 255, 255);
						persn.SetSecondBruiseColor(255, 255, 255);
						persn.SetThirdBruiseColor(255, 255, 255);
						persn.SetRottenColour(255, 255, 255);
						persn.SetBloodColour(255, 255, 255);	
						
						foreach (var body in persn.Limbs)
							{
								body.IsAndroid = true;
								body.BloodDecal = null;
								body.CirculationBehaviour.BleedingRate = 0.000000000f;
								body.CirculationBehaviour.BloodFlow = 0.000000000f;
								body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								
								body.transform.root.localScale *= -0.9970f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "02",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Bro, it's getting hot in here.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/02icon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Royal Guards/02/head.png"),

							ModAPI.LoadSprite("Characters/Royal Guards/02/bodytop.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/02/bodymid.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/02/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/Royal Guards/02/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/02/legbot.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/02/foot.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/02/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/02/legbot.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/02/foot.png"),

							ModAPI.LoadSprite("Characters/Royal Guards/02/armtop.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/02/armbot.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/02/armtop.png"),
							ModAPI.LoadSprite("Characters/Royal Guards/02/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Royal Guards/02/head.png"),

							ModAPI.LoadTexture("Characters/Royal Guards/02/bodytop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/bodymid.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Royal Guards/02/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/legbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/foot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/legbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/foot.png"),

							ModAPI.LoadTexture("Characters/Royal Guards/02/armtop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/armbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/armtop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/armbot.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Royal Guards/02/head.png"),

							ModAPI.LoadTexture("Characters/Royal Guards/02/bodytop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/bodymid.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Royal Guards/02/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/legbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/foot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/legbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/foot.png"),

							ModAPI.LoadTexture("Characters/Royal Guards/02/armtop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/armbot.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/armtop.png"),
							ModAPI.LoadTexture("Characters/Royal Guards/02/armbot.png")
						};
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(-0.015f, 1.03f);
						
						daBod.Find("UpperBody").transform.localPosition = new Vector2(0.0425f, 0.405f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, -0.065f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(-0.015f, -0.45f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.755f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(-0.03f, -1.04f);
						legLeft.Find("FootFront").transform.localPosition = new Vector2(0.085f, -1.25f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.755f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(-0.03f, -1.04f);
						legRight.Find("Foot").transform.localPosition = new Vector2(0.085f, -1.25f);
						
						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(-0.05f, -0.12f);
						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(-0.05f, -0.72f);
						
						armRight.Find("UpperArm").transform.localPosition = new Vector2(-0.05f, -0.12f);
						armRight.Find("LowerArm").transform.localPosition = new Vector2(-0.05f, -0.72f);
						
						foreach (var body in persn.Limbs)
							{
								body.IsAndroid = true;
								body.BloodDecal = null;
								body.CirculationBehaviour.BleedingRate = 0.000000000f;
								body.CirculationBehaviour.BloodFlow = 0.000000000f;
								body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								
								body.transform.root.localScale *= -0.9970f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Sword"),
                NameOverride = "Knives 01 and 02",
                DescriptionOverride = "Hit the yellow button to shoot!",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/knife_0102icon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/knife_0102.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Catty",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "I'm Catty, and this is my best friend, Bratty.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/CTicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/bratty and catty/catty/head.png"),

							ModAPI.LoadSprite("Characters/bratty and catty/catty/bodytop.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/catty/bodymid.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/catty/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/bratty and catty/catty/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/catty/legbot.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/catty/foot.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/catty/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/catty/legbot.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/catty/foot.png"),

							ModAPI.LoadSprite("Characters/bratty and catty/catty/armtop.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/catty/armbot.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/catty/armtop.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/catty/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/bratty and catty/catty/head.png"),

							ModAPI.LoadTexture("Characters/bratty and catty/catty/bodytop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/bodymid.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/bratty and catty/catty/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/legbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/foot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/legbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/foot.png"),

							ModAPI.LoadTexture("Characters/bratty and catty/catty/armtop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/armbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/armtop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/armbot.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/bratty and catty/catty/head.png"),

							ModAPI.LoadTexture("Characters/bratty and catty/catty/bodytop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/bodymid.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/bratty and catty/catty/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/legbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/foot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/legbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/foot.png"),

							ModAPI.LoadTexture("Characters/bratty and catty/catty/armtop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/armbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/armtop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/catty/armbot.png")
						};
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0f, 0.96f);
						head.transform.localScale = new Vector3(0.9f, 0.9f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.505f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.21f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(-0.014f, -0.08f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
 						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.45f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(0f, -0.848f);
						legLeft.Find("FootFront").transform.localPosition = new Vector2(0.086f, -1.115f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.45f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(0f, -0.848f);
						legRight.Find("Foot").transform.localPosition = new Vector2(0.086f, -1.115f);
						
  						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(-0.06f, -0.05f);
 						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(-0.06f, -0.5f);
						
 						armRight.Find("UpperArm").transform.localPosition = new Vector2(-0.06f, -0.05f);
 						armRight.Find("LowerArm").transform.localPosition = new Vector2(-0.06f, -0.5f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.transform.root.localScale *= -0.9900f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Bratty",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "I'm Bratty, and this is my best friend, Catty.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Bricon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/head.png"),

							ModAPI.LoadSprite("Characters/bratty and catty/bratty/bodytop.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/bodymid.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/bratty and catty/bratty/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/legbot.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/foot.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/legbot.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/foot.png"),

							ModAPI.LoadSprite("Characters/bratty and catty/bratty/armtop.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/armbot.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/armtop.png"),
							ModAPI.LoadSprite("Characters/bratty and catty/bratty/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/head.png"),

							ModAPI.LoadTexture("Characters/bratty and catty/bratty/bodytop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/bodymid.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/bratty and catty/bratty/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/legbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/foot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/legbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/foot.png"),

							ModAPI.LoadTexture("Characters/bratty and catty/bratty/armtop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/armbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/armtop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/armbot.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/head.png"),

							ModAPI.LoadTexture("Characters/bratty and catty/bratty/bodytop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/bodymid.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/bratty and catty/bratty/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/legbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/foot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/legbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/foot.png"),

							ModAPI.LoadTexture("Characters/bratty and catty/bratty/armtop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/armbot.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/armtop.png"),
							ModAPI.LoadTexture("Characters/bratty and catty/bratty/armbot.png")
						};

						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0f, 1.135f);
						head.transform.localScale = new Vector3(0.9f, 0.9f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(-0.014f, 0.67f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(-0.014f, 0.30f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(-0.014f, -0.005f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
 						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.4f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(0f, -0.85f);
						legLeft.Find("FootFront").transform.localPosition = new Vector2(0.115f, -1.115f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.4f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(0f, -0.85f);
						legRight.Find("Foot").transform.localPosition = new Vector2(0.115f, -1.115f);
						
  						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(-0.06f, 0.1f);
 						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(-0.06f, -0.4f);
						
 						armRight.Find("UpperArm").transform.localPosition = new Vector2(-0.06f, 0.1f);
 						armRight.Find("LowerArm").transform.localPosition = new Vector2(-0.06f, -0.4f);
						
						var head2 = Instance.transform.GetChild(5);
						var hat2 = new GameObject("hat2");
						hat2.transform.SetParent(head2);
						var hatsprite2 = hat2.AddComponent<SpriteRenderer>();
						hat2.transform.localScale = new Vector3(1f, 1f);
						hat2.transform.localPosition = new Vector3(0.522f, 0f);
						hatsprite2.sprite = ModAPI.LoadSprite("Characters/bratty and catty/bratty/head2.png");
						hatsprite2.sortingLayerName = "Bubbles";
						
						Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
						Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.transform.root.localScale *= -0.9950f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"), 
                    NameOverride = "Cowboy Hat", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This battle-worn hat makes you want to grow a beard.", 
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/CHaticon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Cowboy_Hat.png"); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "Head";
                        prop.armorTier = 1;
                        prop.sprite = ModAPI.LoadSprite("item/Cowboy_Hat.png");
                        prop.armorPoints = 200;
                        prop.offset = new Vector2(0f, 1f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Magnum Revolver"),
                NameOverride = "Empty Gun",
				NameToOrderByOverride = "A-HNR",
                DescriptionOverride = "An antique revolver. Must be used precisely, or damage will be low.",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/EGicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Empty Gun.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Burgerpants",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "I can't go to hell. I'm all out of vacation days.",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/BPicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/Burgerpants/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/Burgerpants/flesh.png");
							var bone = ModAPI.LoadTexture("Characters/Burgerpants/flesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							GameObject horns = new GameObject();
							horns.transform.SetParent(Instance.transform.Find("Head"));
							horns.transform.localPosition = new Vector3(-0.086f, 0.0568f);
							horns.transform.localScale = new Vector3(0.5f, 0.5f);
							var hornsSprite = horns.AddComponent<SpriteRenderer>();
							hornsSprite.sprite = ModAPI.LoadSprite("Characters/Burgerpants/hairstyle.png");
							hornsSprite.sortingLayerName = "Bubbles";
							
							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Final Froggit",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Its future looks brighter and brighter",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/FFicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Final Froggit/head.png"),
						
						ModAPI.LoadSprite("Characters/Final Froggit/bodytop.png"),
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
								
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),

						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
						ModAPI.LoadSprite("Characters/Final Froggit/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Final Froggit/head.png"),
						
						ModAPI.LoadTexture("Characters/Final Froggit/bodytop.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
								
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),

						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Final Froggit/head.png"),
						
						ModAPI.LoadTexture("Characters/Final Froggit/bodytop.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
								
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),

						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
						ModAPI.LoadTexture("Characters/Final Froggit/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
                    var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0.1f, -0.3f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, -1f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.BaseStrength += 1.5f;
								body.Health = 1100f;
								body.InitialHealth = 1500f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Whimsalot",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "It finally stopped worrying",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/WSicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Whimsalot/head.png"),
						
						ModAPI.LoadSprite("Characters/Whimsalot/bodytop.png"),
						ModAPI.LoadSprite("Characters/Whimsalot/bodymid.png"),
						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),
								
						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),

						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),
						ModAPI.LoadSprite("Characters/Whimsalot/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Whimsalot/head.png"),
						
						ModAPI.LoadTexture("Characters/Whimsalot/bodytop.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/bodymid.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
								
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),

						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Whimsalot/head.png"),
						
						ModAPI.LoadTexture("Characters/Whimsalot/bodytop.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/bodymid.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
								
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),

						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
						ModAPI.LoadTexture("Characters/Whimsalot/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0.02f, 0.66f);
						
						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.22f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0f);
						
							AnimationBehaviour1 animBeh = Instance.transform.Find("Body").Find("UpperBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							animBeh.AnimationDelay = 0.05f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Whimsun/1.png"),
								ModAPI.LoadSprite("Characters/Whimsun/2.png"),
								ModAPI.LoadSprite("Characters/Whimsun/3.png"),
								ModAPI.LoadSprite("Characters/Whimsun/4.png"),
								ModAPI.LoadSprite("Characters/Whimsun/5.png"),
								ModAPI.LoadSprite("Characters/Whimsun/6.png"),
								ModAPI.LoadSprite("Characters/Whimsun/6.png"),
								ModAPI.LoadSprite("Characters/Whimsun/5.png"),
								ModAPI.LoadSprite("Characters/Whimsun/4.png"),
								ModAPI.LoadSprite("Characters/Whimsun/3.png"),
								ModAPI.LoadSprite("Characters/Whimsun/2.png"),
								ModAPI.LoadSprite("Characters/Whimsun/1.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(-0.3571f, 0.0854f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.BaseStrength += 1.5f;
								body.Health = 1100f;
								body.InitialHealth = 1500f;
								body.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Astigmatism",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This relentless bully ALWAYS gets its way.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/AMicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {

                    ModAPI.LoadSprite("Characters/Astigmatism/head.png"),
					
					ModAPI.LoadSprite("Characters/Astigmatism/bodytop.png"),
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
								
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),

						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
						ModAPI.LoadSprite("Characters/Astigmatism/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Astigmatism/headflesh.png"),
						
						ModAPI.LoadTexture("Characters/Astigmatism/bodytopflesh.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
								
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),

						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Astigmatism/headflesh.png"),
						
						ModAPI.LoadTexture("Characters/Astigmatism/bodytopflesh.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
								
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),

						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
						ModAPI.LoadTexture("Characters/Astigmatism/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
					var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0f, 0f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0.015f, -0.375f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.BaseStrength += 1.5f;
								body.Health = 1100f;
								body.InitialHealth = 1500f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Madjick",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This enemy can only speak in magic words.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Madjicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Madjick/head.png"),
						
						ModAPI.LoadSprite("Characters/Madjick/bodytop.png"),
						ModAPI.LoadSprite("Characters/Madjick/bodymid.png"),
						ModAPI.LoadSprite("Characters/Madjick/bodybot.png"),
								
						ModAPI.LoadSprite("Characters/Madjick/skinlowerleg.png"),
						ModAPI.LoadSprite("Characters/Madjick/empty.png"),
						ModAPI.LoadSprite("Characters/Madjick/empty.png"),
						ModAPI.LoadSprite("Characters/Madjick/skinlowerleg.png"),
						ModAPI.LoadSprite("Characters/Madjick/empty.png"),
						ModAPI.LoadSprite("Characters/Madjick/empty.png"),

						ModAPI.LoadSprite("Characters/Madjick/empty.png"),
						ModAPI.LoadSprite("Characters/Madjick/empty.png"),
						ModAPI.LoadSprite("Characters/Madjick/empty.png"),
						ModAPI.LoadSprite("Characters/Madjick/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Madjick/head.png"),
						
						ModAPI.LoadTexture("Characters/Madjick/bodytop.png"),
						ModAPI.LoadTexture("Characters/Madjick/bodymid.png"),
						ModAPI.LoadTexture("Characters/Madjick/bodybot.png"),
								
						ModAPI.LoadTexture("Characters/Madjick/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),

						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Madjick/head.png"),
						
						ModAPI.LoadTexture("Characters/Madjick/bodytop.png"),
						ModAPI.LoadTexture("Characters/Madjick/bodymid.png"),
						ModAPI.LoadTexture("Characters/Madjick/bodybot.png"),
								
						ModAPI.LoadTexture("Characters/Madjick/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/skinlowerleg.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),

						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
						ModAPI.LoadTexture("Characters/Madjick/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerLeg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerLegFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
					var middle = Instance.transform.Find("Head");
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }
					
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0.057f, 0.675f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(-0.0583f, 0.2855f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(-0.0583f, 0.0855f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(-0.0154f, -0.2f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
 						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0.045f, -0.47f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0.045f, -0.47f);
						
						
						var ATLASHEAD = new GameObject("ATLASHEAD");
						ATLASHEAD = GameObject.Instantiate(ModAPI.FindSpawnable("Wooden Pillar").Prefab);
						ATLASHEAD.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Soft");
						ATLASHEAD.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";

						SpriteRenderer rotorRenderer = ATLASHEAD.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("Characters/Madjick/hvst.png");
						ATLASHEAD.transform.SetParent(middle.transform);
						ATLASHEAD.transform.localScale = new Vector3(1f, 1f);
									
						ATLASHEAD.GetComponent<PhysicalBehaviour>().MakeWeightless();
							

						ATLASHEAD.FixColliders();

						HingeJoint2D hingeJoint = ATLASHEAD.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = middle.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;
						limits.min = 0;
                        limits.max = 0;
                        hingeJoint.limits = limits;
                        hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						ATLASHEAD.transform.localPosition = new Vector3(-0.1f, 0.4285f);
									
						ATLASHEAD.gameObject.layer = 9;
						
/* 							AnimationBehaviour2 animBeh = Instance.transform.Find("Head").gameObject.AddComponent<AnimationBehaviour2>();
							animBeh.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							animBeh.AnimationDelay = 0.1f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Pyrope/1.png"),
								ModAPI.LoadSprite("Characters/Pyrope/2.png"),
								ModAPI.LoadSprite("Characters/Pyrope/3.png"),
								ModAPI.LoadSprite("Characters/Pyrope/4.png"),
								ModAPI.LoadSprite("Characters/Pyrope/5.png"),
								ModAPI.LoadSprite("Characters/Pyrope/6.png"),
								ModAPI.LoadSprite("Characters/Pyrope/7.png"),
								ModAPI.LoadSprite("Characters/Pyrope/8.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(-0.3f, 0.2857f);
							animBeh.AnimationObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
							animBeh.AnimationObject.GetComponent<SpriteRenderer>().color = new Color(0.15f, 0.15f, 0.15f, 1f); */
							
/* 							Instance.transform.Find("FrontLeg").Find("LowerLegFront").FixColliders(GameObject);
							Instance.transform.Find("BackLeg").Find("LowerLeg").FixColliders(GameObject); */
							
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BloodDecal = null;
								body.BaseStrength += 1.5f;
								body.Health = 1100f;
								body.InitialHealth = 1500f;
								body.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0.35f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Knight Knight",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This megaton mercenary wields the Good Morningstar",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/KKicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Knight Knight/head.png"),

							ModAPI.LoadSprite("Characters/Knight Knight/bodytop.png"),
							ModAPI.LoadSprite("Characters/Knight Knight/bodymid.png"),
							ModAPI.LoadSprite("Characters/Knight Knight/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/Knight Knight/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Knight Knight/legbot.png"),
							ModAPI.LoadSprite("Characters/Knight Knight/foot.png"),
							ModAPI.LoadSprite("Characters/Knight Knight/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Knight Knight/legbot.png"),
							ModAPI.LoadSprite("Characters/Knight Knight/foot.png"),

							ModAPI.LoadSprite("Characters/Knight Knight/armtop.png"),
							ModAPI.LoadSprite("Characters/Knight Knight/armbot.png"),
							ModAPI.LoadSprite("Characters/Knight Knight/armtop.png"),
							ModAPI.LoadSprite("Characters/Knight Knight/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Knight Knight/head.png"),

							ModAPI.LoadTexture("Characters/Knight Knight/bodytop.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/bodymid.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Knight Knight/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/legbot.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/foot.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/legbot.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/foot.png"),

							ModAPI.LoadTexture("Characters/Knight Knight/armtop.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/armbot.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/armtop.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/armbot.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Knight Knight/head.png"),

							ModAPI.LoadTexture("Characters/Knight Knight/bodytop.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/bodymid.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Knight Knight/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/legbot.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/foot.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/legbot.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/foot.png"),

							ModAPI.LoadTexture("Characters/Knight Knight/armtop.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/armbot.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/armtop.png"),
							ModAPI.LoadTexture("Characters/Knight Knight/armbot.png")
						};
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(-0.07f, 2.04f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0.029f, 1.322f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0.13f, 0.64f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, 0.13f);
						
						/* legLeft.transform.localPosition = new Vector2(0f, 0f); */
 						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(-0.0275f, -0.35f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(0f, -0.83f);
						legLeft.Find("FootFront").transform.localPosition = new Vector2(0.185f, -1.16f);

						
						/* legRight.transform.localPosition = new Vector2(0f, 0f); */
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(-0.0272f, -0.35f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(0f, -0.83f);
						legRight.Find("Foot").transform.localPosition = new Vector2(0.185f, -1.16f);
						
 						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(0f, 0.75f);
 						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(-0.07f, 0.05f);
						
 						armRight.Find("UpperArm").transform.localPosition = new Vector2(0f, 0.75f);
 						armRight.Find("LowerArm").transform.localPosition = new Vector2(-0.07f, 0.05f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);
						
 						foreach (var body in persn.Limbs)
							{
								body.IsAndroid = true;
								body.BloodDecal = null;
								body.CirculationBehaviour.BleedingRate = 0.000000000f;
								body.CirculationBehaviour.BloodFlow = 0.000000000f;
								body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Staff Knight Knight",
                DescriptionOverride = "",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/knife_KKicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/knife_KK.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Android"),
						NameOverride = "Mettaton EX",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "I'll make your last living moments... ABSOLUTELY beautiful!",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/MTTexicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/mettaton/EX/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/mettaton/EX/flesh.png");
							var bone = ModAPI.LoadTexture("Characters/mettaton/EX/flesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							foreach (var body in person.Limbs)
							{
								body.transform.root.localScale *= 1.0100f;
							}
							
							Instance.AddComponent<SpawnsItemWhenDead>().Name = "Mettaton NEO";
							Instance.GetComponent<SpawnsItemWhenDead>().isPerson = true;
							Instance.GetComponent<SpawnsItemWhenDead>().NewSprite = ModAPI.LoadSprite("Characters/mettaton/NEO/skin.png", 2f);
							Instance.GetComponent<SpawnsItemWhenDead>().IconSprite = ModAPI.LoadSprite("icon/NEOicon.png");
						}
					}
				);

            if (PlayerPrefs.HasKey("Undertale: Mettaton NEO") && PlayerPrefs.GetInt("Undertale: Mettaton NEO") == 1)
            {
				ModAPI.Register(
					new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Android"),
						NameOverride = "Mettaton NEO",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "COME ANY CLOSER, AND I'LL BE FORCED TO SHOW YOU... MY TRUE FORM!",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/NEOicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/mettaton/NEO/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/mettaton/NEO/flesh.png");
							var bone = ModAPI.LoadTexture("Characters/mettaton/NEO/flesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							GameObject hairstyle = new GameObject();
							hairstyle.transform.SetParent(Instance.transform.Find("Head"));
							hairstyle.transform.localPosition = new Vector3(-0.1f, 0.07f);
							hairstyle.transform.localScale = new Vector3(0.5f, 0.5f);
							var hairstyleSprite = hairstyle.AddComponent<SpriteRenderer>();
							hairstyleSprite.sprite = ModAPI.LoadSprite("Characters/mettaton/NEO/hvst2.png");
							hairstyleSprite.sortingLayerName = "Bubbles";
							
							var backpack1 = new GameObject("Backpack1");
							backpack1.transform.SetParent(Instance.transform.Find("FrontLeg").Find("LowerLegFront"));
							backpack1.transform.localPosition = new Vector3(0.0785f, 0.263f);
							backpack1.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack1Sprite = backpack1.AddComponent<SpriteRenderer>();
							backpack1Sprite.sprite = ModAPI.LoadSprite("Characters/mettaton/NEO/hvst.png");
							backpack1.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
							
							var backpack2 = new GameObject("Backpack2");
							backpack2.transform.SetParent(Instance.transform.Find("BackLeg").Find("LowerLeg"));
							backpack2.transform.localPosition = new Vector3(0.0785f, 0.263f);
							backpack2.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack2Sprite = backpack2.AddComponent<SpriteRenderer>();
							backpack2Sprite.sprite = ModAPI.LoadSprite("Characters/mettaton/NEO/hvst.png");
							backpack2.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							
							var backpack5 = new GameObject("backpack5");
							backpack5.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
							backpack5.transform.localPosition = new Vector3(-0.32f, 0.2f);
							backpack5.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack5Sprite = backpack5.AddComponent<SpriteRenderer>();
							backpack5Sprite.sprite = ModAPI.LoadSprite("Characters/mettaton/NEO/hvst5.png");
							backpack5.GetComponent<SpriteRenderer>().sortingLayerName = "Default";

							GameObject talon = GameObject.Instantiate<GameObject>(ModAPI.FindSpawnable("Accelerator").Prefab);
							talon.transform.position = person.Limbs[11].transform.TransformPoint(new Vector2(0f, -0.2f));
							talon.transform.localScale = new Vector3(0.55f, 0.55f, 1f);
							talon.transform.rotation = Quaternion.identity;
							talon.transform.SetParent(person.Limbs[11].transform);
							
							if (Instance.transform.localScale.x < 0) {
								talon.transform.localRotation = Quaternion.Euler(0f, 0f, 90f);
							} else {
								talon.transform.localRotation = Quaternion.Euler(0f, 0f, -90f);
							}
							
							talon.AddComponent<FixedJoint2D>().connectedBody = person.Limbs[11].PhysicalBehaviour.rigidbody;
							talon.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Characters/mettaton/NEO/gun.png");
							talon.FixColliders();
							talon.GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							Instance.AddComponent<NoChildrenCollide>();
							
/* 							var backpack6 = new GameObject("backpack6");
							backpack6.transform.SetParent(Instance.transform.Find("FrontArm").Find("LowerArmFront"));
							backpack6.transform.localPosition = new Vector3(0f, -0.2f);
							backpack6.transform.localScale = new Vector3(0.5f, 0.5f);
							var backpack6Sprite = backpack6.AddComponent<SpriteRenderer>();
							backpack6Sprite.sprite = ModAPI.LoadSprite("Characters/mettaton/NEO/gun.png");
							backpack6.GetComponent<SpriteRenderer>().sortingLayerName = "Decals"; */

							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";						
							
							AnimationBehaviour1 animBeh = Instance.transform.Find("Body").Find("UpperBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh.AnimationObject.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
							animBeh.AnimationDelay = 0.05f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/mettaton/NEO/1.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/1.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/2.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/3.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/2.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/1.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/1.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(-0.47f, -0.25f);
							if (Instance.transform.localScale.x < 0) {
								animBeh.AnimationObject.transform.rotation = Quaternion.Euler(0f, 26f, 26f);
							} else {
								animBeh.AnimationObject.transform.rotation = Quaternion.Euler(-0f, -26f, -26f);
							}
							animBeh.AnimationObject.transform.localScale = new Vector3(0.5f, 0.5f);
							
							AnimationBehaviour2 animBeh2 = Instance.transform.Find("Head").gameObject.AddComponent<AnimationBehaviour2>();
							animBeh2.AnimationObject.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							animBeh2.AnimationDelay = 0.05f;
							animBeh2.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/mettaton/NEO/1hvst3.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/1hvst3.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/2hvst3.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/3hvst3.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/2hvst3.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/1hvst3.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/1hvst3.png"),
							};
							animBeh2.AnimationObject.transform.localPosition = new Vector3(0.0643f, 0.0071f);
							animBeh2.AnimationObject.transform.localScale = new Vector3(0.5f, 0.5f);
							animBeh2.AnimationObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
							animBeh2.AnimationObject.GetComponent<SpriteRenderer>().color = new Color(0.30f, 0.30f, 0.30f, 1f);
							
							AnimationBehaviour2 animBeh3 = Instance.transform.Find("Body").Find("MiddleBody").gameObject.AddComponent<AnimationBehaviour2>();
							animBeh3.AnimationObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							animBeh3.AnimationDelay = 1f;
							animBeh3.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/mettaton/NEO/hvst4.png"),
								ModAPI.LoadSprite("Characters/mettaton/NEO/hvst4.png"),
							};
							animBeh3.AnimationObject.transform.localPosition = new Vector3(0.0857f, -0.0145f);
							animBeh3.AnimationObject.transform.localScale = new Vector3(0.5f, 0.5f);
							animBeh3.AnimationObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
							animBeh3.AnimationObject.GetComponent<SpriteRenderer>().color = new Color(0.20f, 0.20f, 0.20f, 1f);

							foreach (var body in person.Limbs)
							{
								body.transform.root.localScale *= 1.0100f;
								body.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0.5f;
							}
						}
					}
				);
			}
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Memoryhead",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "No data available.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/Memicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {

                    ModAPI.LoadSprite("Characters/Memoryhead/empty.png"),
					
					ModAPI.LoadSprite("Characters/Memoryhead/head.png"),
							ModAPI.LoadSprite("Characters/Endogeny/empty.png"),
							ModAPI.LoadSprite("Characters/Endogeny/empty.png"),
							

							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),

							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png")
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Memoryhead/empty.png"),
						
						ModAPI.LoadTexture("Characters/Memoryhead/head.png"),
							ModAPI.LoadTexture("Characters/Endogeny/empty.png"),
							ModAPI.LoadTexture("Characters/Endogeny/empty.png"),
							

							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),

							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png")
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Memoryhead/empty.png"),
						
						ModAPI.LoadTexture("Characters/Memoryhead/head.png"),
							ModAPI.LoadTexture("Characters/Endogeny/empty.png"),
							ModAPI.LoadTexture("Characters/Endogeny/empty.png"),
							

							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),

							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png")
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
							if (limbs.gameObject.name.Contains("Head"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
					
                    head.transform.localPosition = new Vector2(0f, 0f);
					
							AnimationBehaviour1 animBeh = Instance.transform.Find("Body").Find("UpperBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh.GetComponent<SpriteRenderer>().sortingOrder = 1;
							animBeh.AnimationDelay = 0.5f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Memoryhead/1.png"),
								ModAPI.LoadSprite("Characters/Memoryhead/2.png"),
								ModAPI.LoadSprite("Characters/Memoryhead/2.png"),
								ModAPI.LoadSprite("Characters/Memoryhead/1.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(0f, 0f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.BloodDecal = null;
								body.RegenerationSpeed += 10f;
								body.Numbness *= 3f;
								body.CirculationBehaviour.BloodFlow *= 4f;
								body.ImpactPainMultiplier *= 0f;
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.PhysicalBehaviour.ReflectsLasers = true;
								body.PhysicalBehaviour.SimulateTemperature = false;
								body.PhysicalBehaviour.Disintegratable = false;
								body.PhysicalBehaviour.Deletable = false;
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
								body.gameObject.AddComponent<undeath>();
							} 
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Endogeny",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "It's unclear how many dogs this counts as.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/DOOOGicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {

                    ModAPI.LoadSprite("Characters/Endogeny/empty.png"),
					
					ModAPI.LoadSprite("Characters/Endogeny/head.png"),
							ModAPI.LoadSprite("Characters/Endogeny/empty.png"),
							ModAPI.LoadSprite("Characters/Endogeny/empty.png"),
							

							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),

							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png"),
							ModAPI.LoadSprite("sprites/Endogeny/empty.png")
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Endogeny/empty.png"),
						
						ModAPI.LoadTexture("Characters/Endogeny/head.png"),
							ModAPI.LoadTexture("Characters/Endogeny/empty.png"),
							ModAPI.LoadTexture("Characters/Endogeny/empty.png"),
							

							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),

							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png")
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
                        ModAPI.LoadTexture("Characters/Endogeny/empty.png"),
						
						ModAPI.LoadTexture("Characters/Endogeny/head.png"),
							ModAPI.LoadTexture("Characters/Endogeny/empty.png"),
							ModAPI.LoadTexture("Characters/Endogeny/empty.png"),
							

							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),

							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png"),
							ModAPI.LoadTexture("sprites/Endogeny/empty.png")
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
							if (limbs.gameObject.name.Contains("Head"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
					
                    head.transform.localPosition = new Vector2(0f, 0f);
					
					
							AnimationBehaviour1 animBeh = Instance.transform.Find("Body").Find("UpperBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh.GetComponent<SpriteRenderer>().sortingOrder = 1;
							animBeh.AnimationDelay = 0.4f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Endogeny/hvst.png"),
								ModAPI.LoadSprite("Characters/Endogeny/hvst2.png"),
								ModAPI.LoadSprite("Characters/Endogeny/hvst3.png"),
								ModAPI.LoadSprite("Characters/Endogeny/hvst4.png"),
								ModAPI.LoadSprite("Characters/Endogeny/hvst4.png"),
								ModAPI.LoadSprite("Characters/Endogeny/hvst3.png"),
								ModAPI.LoadSprite("Characters/Endogeny/hvst2.png"),
								ModAPI.LoadSprite("Characters/Endogeny/hvst.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(0f, 0f);
							
							AnimationBehaviour1 animBeh1 = Instance.transform.Find("Body").Find("UpperBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh1.GetComponent<SpriteRenderer>().sortingOrder = 1;
							animBeh1.AnimationDelay = 0.2f;
							animBeh1.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Endogeny/sst1.png"),
								ModAPI.LoadSprite("Characters/Endogeny/sst2.png"),
								ModAPI.LoadSprite("Characters/Endogeny/sst3.png"),
								ModAPI.LoadSprite("Characters/Endogeny/sst4.png"),
								ModAPI.LoadSprite("Characters/Endogeny/sst5.png"),
								ModAPI.LoadSprite("Characters/Endogeny/sst5.png"),
								ModAPI.LoadSprite("Characters/Endogeny/sst4.png"),
								ModAPI.LoadSprite("Characters/Endogeny/sst3.png"),
								ModAPI.LoadSprite("Characters/Endogeny/sst2.png"),
								ModAPI.LoadSprite("Characters/Endogeny/sst1.png"),
							};
							animBeh1.AnimationObject.transform.localPosition = new Vector3(-0.085f, 0f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.BloodDecal = null;
								body.RegenerationSpeed += 10f;
								body.Numbness *= 3f;
								body.CirculationBehaviour.BloodFlow *= 4f;
								body.ImpactPainMultiplier *= 0f;
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.PhysicalBehaviour.ReflectsLasers = true;
								body.PhysicalBehaviour.SimulateTemperature = false;
								body.PhysicalBehaviour.Disintegratable = false;
								body.PhysicalBehaviour.Deletable = false;
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
								body.gameObject.AddComponent<undeath>();
							} 
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
				}
			}
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Reaper Bird",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "This relentless future finally looks brighter and brighter.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/RBicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Reaper Bird/head.png"),

							ModAPI.LoadSprite("Characters/Reaper Bird/bodytop.png"),
							ModAPI.LoadSprite("Characters/Reaper Bird/bodymid.png"),
							ModAPI.LoadSprite("Characters/Reaper Bird/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/Reaper Bird/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Reaper Bird/legbot.png"),
							ModAPI.LoadSprite("Characters/Reaper Bird/foot.png"),
							ModAPI.LoadSprite("Characters/Reaper Bird/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Reaper Bird/legbot.png"),
							ModAPI.LoadSprite("Characters/Reaper Bird/foot.png"),

							ModAPI.LoadSprite("Characters/Reaper Bird/empty.png"),
							ModAPI.LoadSprite("Characters/Reaper Bird/empty.png"),
							ModAPI.LoadSprite("Characters/Reaper Bird/empty.png"),
							ModAPI.LoadSprite("Characters/Reaper Bird/empty.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Reaper Bird/head.png"),

							ModAPI.LoadTexture("Characters/Reaper Bird/bodytop.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/bodymid.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Reaper Bird/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/legbot.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/foot.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/legbot.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/foot.png"),

							ModAPI.LoadTexture("Characters/Reaper Bird/empty.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/empty.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/empty.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/empty.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Reaper Bird/head.png"),

							ModAPI.LoadTexture("Characters/Reaper Bird/bodytop.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/bodymid.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Reaper Bird/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/legbot.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/foot.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/legbot.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/foot.png"),

							ModAPI.LoadTexture("Characters/Reaper Bird/empty.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/empty.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/empty.png"),
							ModAPI.LoadTexture("Characters/Reaper Bird/empty.png")
						};
						
						foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
							if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0.08f, 1.5f);
						
						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.95f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.45f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(-0.28f, 0.1f);
						daBod.Find("LowerBody").GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.4f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(0f, -0.9f);
						legLeft.Find("FootFront").transform.localPosition = new Vector2(0.06f, -1.2f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.4f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(0f, -0.9f);
						legRight.Find("Foot").transform.localPosition = new Vector2(0.06f, -1.2f);
						
						/* armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(-0.05f, -0.45f); */
						
						/* armRight.Find("LowerArm").transform.localPosition = new Vector2(-0.05f, -0.45f); */
						
							AnimationBehaviour1 animBeh = Instance.transform.Find("Body").Find("LowerBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh.GetComponent<SpriteRenderer>().sortingOrder = 1;
							animBeh.AnimationDelay = 0.4f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Reaper Bird/hvst1.png"),
								ModAPI.LoadSprite("Characters/Reaper Bird/hvst2.png"),
								ModAPI.LoadSprite("Characters/Reaper Bird/hvst3.png"),
								ModAPI.LoadSprite("Characters/Reaper Bird/hvst3.png"),
								ModAPI.LoadSprite("Characters/Reaper Bird/hvst2.png"),
								ModAPI.LoadSprite("Characters/Reaper Bird/hvst1.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(0f, 0f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.BloodDecal = null;
								body.RegenerationSpeed += 10f;
								body.Numbness *= 3f;
								body.CirculationBehaviour.BloodFlow *= 4f;
								body.ImpactPainMultiplier *= 0f;
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.PhysicalBehaviour.ReflectsLasers = true;
								body.PhysicalBehaviour.SimulateTemperature = false;
								body.PhysicalBehaviour.Disintegratable = false;
								body.PhysicalBehaviour.Deletable = false;
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
								body.gameObject.AddComponent<undeath>();
							} 
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)
								Physics2D.IgnoreCollision(a, b);

					}
				}
			);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Everyman",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/EMicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/Everyman/head.png"),

							ModAPI.LoadSprite("Characters/Everyman/bodytop.png"),
							ModAPI.LoadSprite("Characters/Everyman/bodymid.png"),
							ModAPI.LoadSprite("Characters/Everyman/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/Everyman/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Everyman/legbot.png"),
							ModAPI.LoadSprite("Characters/Everyman/empty.png"),
							ModAPI.LoadSprite("Characters/Everyman/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/Everyman/legbot.png"),
							ModAPI.LoadSprite("Characters/Everyman/empty.png"),

							ModAPI.LoadSprite("Characters/Everyman/armtop.png"),
							ModAPI.LoadSprite("Characters/Everyman/armbot.png"),
							ModAPI.LoadSprite("Characters/Everyman/armtop.png"),
							ModAPI.LoadSprite("Characters/Everyman/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Everyman/head.png"),

							ModAPI.LoadTexture("Characters/Everyman/bodytop.png"),
							ModAPI.LoadTexture("Characters/Everyman/bodymid.png"),
							ModAPI.LoadTexture("Characters/Everyman/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Everyman/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Everyman/legbot.png"),
							ModAPI.LoadTexture("Characters/Everyman/empty.png"),
							ModAPI.LoadTexture("Characters/Everyman/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Everyman/legbot.png"),
							ModAPI.LoadTexture("Characters/Everyman/empty.png"),

							ModAPI.LoadTexture("Characters/Everyman/armtop.png"),
							ModAPI.LoadTexture("Characters/Everyman/armbot.png"),
							ModAPI.LoadTexture("Characters/Everyman/armtop.png"),
							ModAPI.LoadTexture("Characters/Everyman/armbot.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/Everyman/head.png"),

							ModAPI.LoadTexture("Characters/Everyman/bodytop.png"),
							ModAPI.LoadTexture("Characters/Everyman/bodymid.png"),
							ModAPI.LoadTexture("Characters/Everyman/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/Everyman/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Everyman/legbot.png"),
							ModAPI.LoadTexture("Characters/Everyman/empty.png"),
							ModAPI.LoadTexture("Characters/Everyman/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/Everyman/legbot.png"),
							ModAPI.LoadTexture("Characters/Everyman/empty.png"),

							ModAPI.LoadTexture("Characters/Everyman/armtop.png"),
							ModAPI.LoadTexture("Characters/Everyman/armbot.png"),
							ModAPI.LoadTexture("Characters/Everyman/armtop.png"),
							ModAPI.LoadTexture("Characters/Everyman/armbot.png")
						};
						
						foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
							if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0.06f, 0.83f);
						
						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.46f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.26f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, 0f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(-0.05f, -0.235f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(-0.05f, -0.485f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(-0.05f, -0.235f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(-0.05f, -0.485f);
						
						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(-0.05f, -0.1f);
						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(-0.05f, -0.45f);
						
						armRight.Find("UpperArm").transform.localPosition = new Vector2(-0.05f, -0.1f);
						armRight.Find("LowerArm").transform.localPosition = new Vector2(-0.05f, -0.45f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.transform.root.localScale *= -0.9900f;
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.BloodDecal = null;
								body.RegenerationSpeed += 10f;
								body.Numbness *= 3f;
								body.CirculationBehaviour.BloodFlow *= 4f;
								body.ImpactPainMultiplier *= 0f;
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.PhysicalBehaviour.ReflectsLasers = true;
								body.PhysicalBehaviour.SimulateTemperature = false;
								body.PhysicalBehaviour.Disintegratable = false;
								body.PhysicalBehaviour.Deletable = false;
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
								body.gameObject.AddComponent<undeath>();
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Lemon Bread",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Welcome to my special hell.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/LBicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Lemon Bread/head.png"),
						
						ModAPI.LoadSprite("Characters/Lemon Bread/bodytop.png"),
						ModAPI.LoadSprite("Characters/Lemon Bread/bodymid.png"),
						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),
								
						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),

						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadSprite("Characters/Lemon Bread/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Lemon Bread/head.png"),
						
						ModAPI.LoadTexture("Characters/Lemon Bread/bodytop.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/bodymid.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
								
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),

						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Lemon Bread/head.png"),
						
						ModAPI.LoadTexture("Characters/Lemon Bread/bodytop.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/bodymid.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
								
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),

						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
						ModAPI.LoadTexture("Characters/Lemon Bread/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
                    var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0.139f, 1.6f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(-0.057f, 0.8f);
					daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, 0f);
					
							AnimationBehaviour1 animBeh = Instance.transform.Find("Head").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh.GetComponent<SpriteRenderer>().sortingOrder = 1;
							animBeh.AnimationDelay = 0.2f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst1.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst2.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst3.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst4.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst5.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst6.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst7.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst8.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst7.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst6.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst5.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst4.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst3.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst2.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst1.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/hvst0.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(0f, 0.2f);
							
							AnimationBehaviour1 animBeh1 = Instance.transform.Find("Body").Find("MiddleBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh1.GetComponent<SpriteRenderer>().sortingOrder = 1;
							animBeh1.AnimationDelay = 0.7f;
							animBeh1.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Lemon Bread/slz1.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/slz1.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/slz2.png"),
								ModAPI.LoadSprite("Characters/Lemon Bread/slz2.png"),
							};
							animBeh1.AnimationObject.transform.localPosition = new Vector3(0f, 0f);
						
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.BloodDecal = null;
								body.RegenerationSpeed += 10f;
								body.Numbness *= 3f;
								body.CirculationBehaviour.BloodFlow *= 4f;
								body.ImpactPainMultiplier *= 0f;
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.PhysicalBehaviour.ReflectsLasers = true;
								body.PhysicalBehaviour.SimulateTemperature = false;
								body.PhysicalBehaviour.Disintegratable = false;
								body.PhysicalBehaviour.Deletable = false;
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
								body.gameObject.AddComponent<undeath>();
							} 
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
					
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
				}
			}
		);
ModAPI.Register(
				new Modification()
				{
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Snowdrake's Mother",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Sn... o... wy...",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/SMicon.png"),
                    AfterSpawn = (Instance) =>
					{						
                    Sprite[] skinTextures = new Sprite[] {
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/head.png"),
						
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/bodytop.png"),
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
								
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),

						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadSprite("Characters/Snowdrake's Mother/empty.png"),
				    };
					
                    Texture2D[] meattextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/head.png"),
						
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/bodytop.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
								
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),

						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						
                    };

                    Texture2D[] bonetextures = new Texture2D[] {
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/head.png"),
						
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/bodytop.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
								
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),

						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
						ModAPI.LoadTexture("Characters/Snowdrake's Mother/empty.png"),
					};
					
					foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("MiddleBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("LowerBody"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Leg"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArmFront"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("LowerArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
						  if (limbs.gameObject.name.Contains("UpperArm"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
					
					var persn = Instance.GetComponent<PersonBehaviour>();
                    var limbpr = persn.Limbs;
                    for (int i = 0; i < limbpr.Length; i++)
                    {
                        limbpr[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
                        limbpr[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
                        foreach (var collider in limbpr[i].GetComponents<Collider2D>());
                        var hitbox = limbpr[i].gameObject.AddComponent<BoxCollider2D>();
                    }

                    var head = Instance.transform.Find("Head");
                    var daBod = Instance.transform.Find("Body");
					
                    head.transform.localPosition = new Vector2(0.14f, 0.9f);
					
					daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0f);
					
					
							AnimationBehaviour1 animBeh = Instance.transform.Find("Head").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh.GetComponent<SpriteRenderer>().sortingOrder = 1;
							animBeh.AnimationDelay = 0.5f;
							animBeh.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst1.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst2.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst3.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst4.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst5.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst6.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst6.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst5.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst4.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst3.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst2.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/hvst1.png"),
							};
							animBeh.AnimationObject.transform.localPosition = new Vector3(0f, 0f);
							
							AnimationBehaviour1 animBeh1 = Instance.transform.Find("Body").Find("UpperBody").gameObject.AddComponent<AnimationBehaviour1>();
							animBeh1.GetComponent<SpriteRenderer>().sortingOrder = 1;
							animBeh1.AnimationDelay = 0.5f;
							animBeh1.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/cst1.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/cst2.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/cst3.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/cst3.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/cst2.png"),
								ModAPI.LoadSprite("Characters/Snowdrake's Mother/cst1.png"),
							};
							animBeh1.AnimationObject.transform.localPosition = new Vector3(0f, 0f);
					
							persn.SetBruiseColor(255, 255, 255);
							persn.SetSecondBruiseColor(255, 255, 255);
							persn.SetThirdBruiseColor(255, 255, 255);
							persn.SetRottenColour(255, 255, 255);
							persn.SetBloodColour(255, 255, 255);							
							foreach (var body in persn.Limbs)
							{
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.BloodDecal = null;
								body.RegenerationSpeed += 10f;
								body.Numbness *= 3f;
								body.CirculationBehaviour.BloodFlow *= 4f;
								body.ImpactPainMultiplier *= 0f;
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.PhysicalBehaviour.ReflectsLasers = true;
								body.PhysicalBehaviour.SimulateTemperature = false;
								body.PhysicalBehaviour.Disintegratable = false;
								body.PhysicalBehaviour.Deletable = false;
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
								body.gameObject.AddComponent<undeath>();
							} 
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
				}
			}
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Heart Locket", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "It says ''Best Friends Forever.''", 
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/HLocicon.png"), 
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Heart_Locket.png"); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 3;
                        prop.sprite = ModAPI.LoadSprite("item/Heart_Locket.png");
                        prop.armorPoints = 200;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Knife"),
                NameOverride = "Real Knife",
				NameToOrderByOverride = "A-HNR",
                DescriptionOverride = "Here we are!",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/RKicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Real Knife.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Asgore",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Human... It was nice to meet you. Goodbye.",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/Asgoreicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var middle = Instance.transform.Find("Head");
							var skin = ModAPI.LoadTexture("Characters/asgore/asgoreskin.png");
							var flesh = ModAPI.LoadTexture("Characters/asgore/asgoreflesh.png");
							var bone = ModAPI.LoadTexture("Characters/asgore/asgoreflesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							Instance.AddComponent<MonsterSoulBehaviour>();
							
							GameObject horns = new GameObject();
							horns.transform.SetParent(Instance.transform.Find("Head"));
							horns.transform.localPosition = new Vector3(-0.07145f, 0.02145f);
							horns.transform.localScale = new Vector3(0.5f, 0.5f);
							var hornsSprite = horns.AddComponent<SpriteRenderer>();
							hornsSprite.sprite = ModAPI.LoadSprite("Characters/asgore/hornsandbeard.png");
							hornsSprite.sortingLayerName = "Top";
							
							GameObject horns1 = new GameObject();
							horns1.transform.SetParent(Instance.transform.Find("Head"));
							horns1.transform.localPosition = new Vector3(-0.07145f, 0.02145f);
							horns1.transform.localScale = new Vector3(0.5f, 0.5f);
							var horns1Sprite = horns1.AddComponent<SpriteRenderer>();
							horns1Sprite.sprite = ModAPI.LoadSprite("Characters/asgore/hornsandbeard1.png");
							horns1Sprite.sortingLayerName = "Foreground";
							
							GameObject horns2 = new GameObject();
							horns2.transform.SetParent(Instance.transform.Find("Head"));
							horns2.transform.localPosition = new Vector3(-0.07145f, 0.02145f);
							horns2.transform.localScale = new Vector3(0.5f, 0.5f);
							var horns2Sprite = horns2.AddComponent<SpriteRenderer>();
							horns2Sprite.sprite = ModAPI.LoadSprite("Characters/asgore/Crown.png");
							horns2Sprite.sortingLayerName = "Bubbles";
							
							var Backpack3 = new GameObject("Backpack3");
							Backpack3.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
							Backpack3.transform.localPosition = new Vector3(0, 0.1f);
							Backpack3.transform.localScale = new Vector3(1f, 1f);
							var Backpack3Sprite = Backpack3.AddComponent<SpriteRenderer>();
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/asgore/Scarf.png");
							Backpack3.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
							Backpack3.AddComponent<UseEventTrigger>().Action = () => {
							Backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/asgore/Scarf.png");
							};
							
							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);

							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
							foreach (var body in person.Limbs)
							{
								if (body.gameObject.name == "UpperBody")
								{
									body.IsAndroid = true;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "Head")
								{
									body.BloodDecal = null;
									body.BaseStrength += 7f;
									body.Health *= 4000;
									body.InitialHealth *= 4500;
								}
								else if (body.gameObject.name == "MiddleBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerBody")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperLegFront")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerLegFront")
								{
									body.IsAndroid = true;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperLeg")
								{
									body.IsAndroid = true;
									body.CirculationBehaviour.BleedingRate = 0.000000000f;
									body.CirculationBehaviour.BloodFlow = 0.000000000f;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerLeg")
								{
									body.IsAndroid = true;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperArmFront")
								{
									body.IsAndroid = true;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerArmFront")
								{
									body.IsAndroid = true;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "UpperArm")
								{
									body.IsAndroid = true;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								else if (body.gameObject.name == "LowerArm")
								{
									body.IsAndroid = true;
									body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Bulletproof");
								}
								
								body.transform.root.localScale *= 1.0180f;
							}
							
							var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Spear"),
					NameOverride = "Trident of Asgore",
					DescriptionOverride = "",
					NameToOrderByOverride = "A-HNR",
					CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
					ThumbnailOverride = ModAPI.LoadSprite("icon/Trident_icon.png"),
					AfterSpawn = (Instance) =>
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("DM Knife.png");
						foreach (var c in Instance.GetComponents<Collider2D>())
						{
							GameObject.Destroy(c);
						}
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Trident_Asgore.png");
						Instance.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
						Instance.GetComponent<SpriteRenderer>().color = new Color(0.10f, 0.10f, 0.10f, 1f);
						Instance.AddComponent<PolygonCollider2D>();
						
						Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
				new Modification()
				{
					OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"),
					NameOverride = "Flask for the soul",
					DescriptionOverride = "Helps the soul not to disintegrate and restrains its limitless power",
					NameToOrderByOverride = "A-HNR",
					CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
					ThumbnailOverride = ModAPI.LoadSprite("icon/Flaskicon.png"),
					AfterSpawn = (Instance) =>
					{
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Flask1.png");
						Instance.FixColliders();
					
						GameObject hat2 = new GameObject();
						hat2.transform.SetParent(Instance.transform);
						var hatsprite2 = hat2.AddComponent<SpriteRenderer>();
						hat2.transform.localPosition = new Vector3(0f, 0.085f);
						hatsprite2.sprite = ModAPI.LoadSprite("item/Flask2.png");	
						hatsprite2.sortingLayerName = "Top";
				}
            }
		);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Photoshop Flowey",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "Howdy! It's me, FLOWEY. FLOWEY the FLOWER!",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/PFicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {							
							ModAPI.LoadSprite("Characters/flowey/Photoshop/empty.png"),

							ModAPI.LoadSprite("Characters/flowey/Photoshop/bodytop.png"),
							ModAPI.LoadSprite("Characters/flowey/Photoshop/bodymid.png"),
							ModAPI.LoadSprite("Characters/flowey/Photoshop/bodybot.png"),
							

							ModAPI.LoadSprite("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadSprite("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadSprite("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadSprite("Characters/flowey/Photoshop/skinlowerleg.png"),
							ModAPI.LoadSprite("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadSprite("Characters/flowey/Photoshop/empty.png"),

							ModAPI.LoadSprite("Characters/flowey/Photoshop/armtop.png"),
							ModAPI.LoadSprite("Characters/flowey/Photoshop/armbot.png"),
							ModAPI.LoadSprite("Characters/flowey/Photoshop/armtop.png"),
							ModAPI.LoadSprite("Characters/flowey/Photoshop/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),

							ModAPI.LoadTexture("Characters/flowey/Photoshop/bodytop.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/bodymid.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),

							ModAPI.LoadTexture("Characters/flowey/Photoshop/armtop.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/armbot.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/armtop.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/armbot.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),

							ModAPI.LoadTexture("Characters/flowey/Photoshop/bodytop.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/bodymid.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/bodybot.png"),
							

							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/skinlowerleg.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/empty.png"),

							ModAPI.LoadTexture("Characters/flowey/Photoshop/armtop.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/armbot.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/armtop.png"),
							ModAPI.LoadTexture("Characters/flowey/Photoshop/armbot.png")
						};
						
						foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
								if (limbs.gameObject.name.Contains("Head"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  	if (limbs.gameObject.name.Contains("LowerLeg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Foot"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(-1.1f, -1.5f);
						daBod.Find("UpperBody").GetComponent<SpriteRenderer>().sortingLayerName = "Background";
 						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0f);
						daBod.Find("MiddleBody").GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						daBod.Find("MiddleBody").GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
 						daBod.Find("LowerBody").transform.localPosition = new Vector2(1.38f, -1.73f);
						daBod.Find("LowerBody").GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(2.1f, -2.3f);
						legRight.Find("UpperLeg").GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						
  						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(0f, -2f); 
						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(0f, -5f); 
						
  						armRight.Find("UpperArm").transform.localPosition = new Vector2(0f, -2f);
						armRight.Find("UpperArm").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						armRight.Find("LowerArm").transform.localPosition = new Vector2(0f, -5f);
						armRight.Find("LowerArm").GetComponent<SpriteRenderer>().sortingLayerName = "Top";

						var backpack = new GameObject("Backpack");
                        backpack.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        backpack.transform.localPosition = new Vector3(1f, 10f);
						backpack.transform.rotation = Quaternion.Euler(0f, 5f, -5f);
						if (Instance.transform.localScale.x < 0) { 
							backpack.transform.rotation = Quaternion.Euler(0f, -5f, 5f); 
						} else {
							backpack.transform.rotation = Quaternion.Euler(0f, 5f, -5f);
						}
                        var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                        backpackSprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst3.png");
                        backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        backpack.AddComponent<UseEventTrigger>().Action = () => {
                        backpackSprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst3.png");
						};
						
						var backpack1 = new GameObject("Backpack1");
                        backpack1.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        backpack1.transform.localPosition = new Vector3(-1f, 10f);
						if (Instance.transform.localScale.x < 0) { 
							backpack1.transform.rotation = Quaternion.Euler(0f, -5f, -5f); 
						} else {
							backpack1.transform.rotation = Quaternion.Euler(0f, 5f, 5f);
						}
                        var backpack1Sprite = backpack1.AddComponent<SpriteRenderer>();
                        backpack1Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst3.png");
                        backpack1.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        backpack1.AddComponent<UseEventTrigger>().Action = () => {
                        backpack1Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst3.png");
						};
						
						var backpack2 = new GameObject("Backpack2");
                        backpack2.transform.SetParent(Instance.transform.Find("BackLeg").Find("UpperLeg"));
                        backpack2.transform.localPosition = new Vector3(0.957f, 1.7857f);
						backpack2.transform.localScale = new Vector3(1f, 1f);
                        var backpack2Sprite = backpack2.AddComponent<SpriteRenderer>();
                        backpack2Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst4.png");
						backpack2Sprite.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
						backpack2Sprite.GetComponent<SpriteRenderer>().color = new Color(0.20f, 0.20f, 0.20f, 1f);
                        backpack2.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        backpack2.AddComponent<UseEventTrigger>().Action = () => {
                        backpack2Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst4.png");
						};
						
						var backpack3 = new GameObject("Backpack3");
                        backpack3.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        backpack3.transform.localPosition = new Vector3(-2f, 10f);
						if (Instance.transform.localScale.x < 0) { 
							backpack3.transform.rotation = Quaternion.Euler(0f, -6f, -6f); 
						} else {
							backpack3.transform.rotation = Quaternion.Euler(0f, 6f, 6f);
						}
                        var backpack3Sprite = backpack3.AddComponent<SpriteRenderer>();
                        backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst3.png");
                        backpack3.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                        backpack3.AddComponent<UseEventTrigger>().Action = () => {
                        backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst3.png");
						};
						
						var backpack4 = new GameObject("Backpack4");
                        backpack4.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        backpack4.transform.localPosition = new Vector3(1.5f, 10f);
						if (Instance.transform.localScale.x < 0) { 
							backpack4.transform.rotation = Quaternion.Euler(0f, 7.5f, 7.5f); 
						} else {
							backpack4.transform.rotation = Quaternion.Euler(0f, -7.5f, -7.5f);
						}
                        var backpack4Sprite = backpack4.AddComponent<SpriteRenderer>();
                        backpack4Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst.png");
                        backpack4.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                        backpack4.AddComponent<UseEventTrigger>().Action = () => {
                        backpack4Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst.png");
						};
						
						var Backpack5 = new GameObject("Backpack5");
                        Backpack5.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        Backpack5.transform.localPosition = new Vector3(-1.5f, 10f);
						if (Instance.transform.localScale.x < 0) { 
							Backpack5.transform.rotation = Quaternion.Euler(0f, -7.5f, -7.5f); 
						} else {
							Backpack5.transform.rotation = Quaternion.Euler(0f, 7.5f, 7.5f);
						}
                        var backpack5Sprite = Backpack5.AddComponent<SpriteRenderer>();
                        backpack5Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst.png");
                        Backpack5.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
						var Backpack6 = new GameObject("Backpack6");
                        Backpack6.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        Backpack6.transform.localPosition = new Vector3(-2f, 10f);
						if (Instance.transform.localScale.x < 0) { 
							Backpack6.transform.rotation = Quaternion.Euler(0f, -8f, -8f); 
						} else {
							Backpack6.transform.rotation = Quaternion.Euler(0f, 8f, 8f);
						}
                        var backpack6Sprite = Backpack6.AddComponent<SpriteRenderer>();
                        backpack6Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst2.png");
                        Backpack6.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
						var Backpack7 = new GameObject("Backpack7");
						Backpack7.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
						Backpack7.transform.localPosition = new Vector3(2.5f, 10f);
						if (Instance.transform.localScale.x < 0) { 
							Backpack7.transform.rotation = Quaternion.Euler(0f, 9f, 9f); 
						} else {
							Backpack7.transform.rotation = Quaternion.Euler(0f, -9f, -9f);
						}
						var backpack7Sprite = Backpack7.AddComponent<SpriteRenderer>();
						backpack7Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst2.png");
						Backpack7.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
						var Backpack8 = new GameObject("Backpack8");
                        Backpack8.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        Backpack8.transform.localPosition = new Vector3(1f, 10f);
						if (Instance.transform.localScale.x < 0) { 
							Backpack8.transform.rotation = Quaternion.Euler(0f, -1f, -1f); 
						} else {
							Backpack8.transform.rotation = Quaternion.Euler(0f, 1f, 1f);
						}
                        var backpack8Sprite = Backpack8.AddComponent<SpriteRenderer>();
                        backpack8Sprite.sprite = ModAPI.LoadSprite("Characters/flowey/Photoshop/hvst2.png");
                        Backpack8.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
						foreach (var body in persn.Limbs)
							{
								body.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.BloodDecal = null;
								body.RegenerationSpeed += 10f;
								body.Numbness *= 3f;
								body.CirculationBehaviour.BloodFlow *= 4f;
								body.ImpactPainMultiplier *= 0f;
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.PhysicalBehaviour.ReflectsLasers = true;
								body.PhysicalBehaviour.SimulateTemperature = false;
								body.PhysicalBehaviour.Disintegratable = false;
								body.PhysicalBehaviour.Deletable = false;
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
								body.gameObject.AddComponent<undeath>();
							}
							
						
						var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
                        foreach (LimbBehaviour limb in persn.Limbs)
                        {
                            limb.BloodLiquidType = "GreenBlood";
                            limb.CirculationBehaviour.ClearLiquid();
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("GreenBlood"), 2f);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Asriel",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Don’t kill, and don’t be killed, alright? That’s the best you can strive for.",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/Azzyicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/asriel/kid/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/asriel/kid/flesh.png");
							var bone = ModAPI.LoadTexture("Characters/asriel/kid/flesh.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							GameObject horns = new GameObject();
							horns.transform.SetParent(Instance.transform.Find("Head"));
							horns.transform.localPosition = new Vector3(-0.086f, -0.015f);
							horns.transform.localScale = new Vector3(0.5f, 0.5f);
							var hornsSprite = horns.AddComponent<SpriteRenderer>();
							hornsSprite.sprite = ModAPI.LoadSprite("Characters/asriel/kid/hairstyle.png");
							hornsSprite.sortingLayerName = "Bubbles";
							
							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Decals";
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.BloodDecal = null;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
								var dustBehavior = Instance.AddComponent<DustBehavior>(); dustBehavior.audioClip = ModAPI.LoadSound("snd_mnstrDD_b.wav");
						}
					}
				);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Asriel God of Hyperdeath",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "The Absolute GOD of Hyperdeath!",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/AzzyGodicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/asriel/god/skin.png");
							var flesh = ModAPI.LoadTexture("Characters/asriel/god/skin.png");
							var bone = ModAPI.LoadTexture("Characters/asriel/god/skin.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 2f);
							
							GameObject horns = new GameObject();
							horns.transform.SetParent(Instance.transform.Find("Head"));
							horns.transform.localPosition = new Vector3(0.0926f, 0.1428f);
							horns.transform.localScale = new Vector3(0.5f, 0.5f);
							var hornsSprite = horns.AddComponent<SpriteRenderer>();
							hornsSprite.sprite = ModAPI.LoadSprite("Characters/asriel/god/hvst4.png");
							hornsSprite.sortingLayerName = "Default";
							
							GameObject horns1 = new GameObject();
							horns1.transform.SetParent(Instance.transform.Find("Head"));
							horns1.transform.localPosition = new Vector3(0.0642f, 0.114f);
							horns1.transform.localScale = new Vector3(0.5f, 0.5f);
							var horns1Sprite = horns1.AddComponent<SpriteRenderer>();
							horns1Sprite.sprite = ModAPI.LoadSprite("Characters/asriel/god/hvst3.png");
							horns1Sprite.sortingLayerName = "Bubbles";
							
							GameObject horns2 = new GameObject();
							horns2.transform.SetParent(Instance.transform.Find("Head"));
							horns2.transform.localPosition = new Vector3(-0.014f, 0.15f);
							horns2.transform.localScale = new Vector3(0.5f, 0.5f);
							var horns2Sprite = horns2.AddComponent<SpriteRenderer>();
							horns2Sprite.sprite = ModAPI.LoadSprite("Characters/asriel/god/hvst2.png");
							horns2Sprite.sortingLayerName = "Top";
							
							GameObject horns3 = new GameObject();
							horns3.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
							horns3.transform.localPosition = new Vector3(-0.0214f, 0.15f);
							horns3.transform.localScale = new Vector3(0.5f, 0.5f);
							var horns3Sprite = horns3.AddComponent<SpriteRenderer>();
							horns3Sprite.sprite = ModAPI.LoadSprite("Characters/asriel/god/hvst.png");
							horns3Sprite.sortingLayerName = "Bubbles";
							
							Instance.transform.Find("FrontArm").Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							Instance.transform.Find("FrontArm").Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
							
							person.SetBruiseColor(255, 255, 255);
							person.SetSecondBruiseColor(255, 255, 255);
							person.SetThirdBruiseColor(255, 255, 255);
							person.SetRottenColour(255, 255, 255);
							person.SetBloodColour(255, 255, 255);							
							foreach (var body in person.Limbs)
							{
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.BloodDecal = null;
								body.RegenerationSpeed += 10f;
								body.Numbness *= 3f;
								body.CirculationBehaviour.BloodFlow *= 4f;
								body.ImpactPainMultiplier *= 0f;
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.PhysicalBehaviour.ReflectsLasers = true;
								body.PhysicalBehaviour.SimulateTemperature = false;
								body.PhysicalBehaviour.Disintegratable = false;
								body.PhysicalBehaviour.Deletable = false;
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
								body.gameObject.AddComponent<undeath>();
								body.transform.root.localScale *= 1.0160f;
								body.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0.35f;
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in person.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
						}
					}
				);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Sword"),
                NameOverride = "Sword of Asriel",
                DescriptionOverride = "Capable of cutting through time and space",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/Knife_Azziicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Knife_Azzi.png");
					Instance.FixColliders();
				}
            }
		);
ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Archelix Caster"),
                NameOverride = "Gun of Asriel",
                DescriptionOverride = "Shoots out powerful rays of Determination",
				NameToOrderByOverride = "A-HNR",
                CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                ThumbnailOverride = ModAPI.LoadSprite("icon/AzzGunicon.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/Gun_Azzi2.png");
					Instance.FixColliders();

					Instance.transform.localScale = new Vector3(0.8f, 0.8f);
					
					var GasterBlasterBehaviour = Instance.GetOrAddComponent<GasterBlasterBehaviour>();					
					var GBlaster = Instance.GetComponent<GasterBlasterBehaviour>();

					GBlaster.A = ModAPI.LoadSprite("item/Gun_Azzi2.png");
					GBlaster.B = ModAPI.LoadSprite("item/Gun_Azzi1.png");
					Instance.FixColliders();
					Instance.AddComponent<UseEventTrigger>().Action = () => {
					};
					
							AnimationBehaviour3 animBeh5 = Instance.gameObject.AddComponent<AnimationBehaviour3>();
							animBeh5.AnimationDelay = 0.6f;
							animBeh5.AnimationSprites = new Sprite[]
							{
								ModAPI.LoadSprite("item/Gun_Azzi2_1.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_2.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_3.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_4.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_5.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_6.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_7.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_8.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_9.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_10.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_9.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_8.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_7.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_6.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_5.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_4.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_3.png"),
								ModAPI.LoadSprite("item/Gun_Azzi2_2.png"),
							};
							animBeh5.GetComponent<SpriteRenderer>().sortingLayerName = "Background";
							animBeh5.AnimationObject.transform.localPosition = new Vector3(-0.45f, 0f);
							
						Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
				}
            }
		);
ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Chara",
						NameToOrderByOverride = "A-HNR",
						DescriptionOverride = "Greetings. I am Chara. Thank you. Your power awakened me from death.",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/Cicon.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/chara/charaskin.png");
							var flesh = ModAPI.LoadTexture("Characters/chara/charaflesh.png");
							var bone = ModAPI.LoadTexture("Characters/chara/charabone.png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
							
							Instance.AddComponent<SoulBehavior>();						

							foreach (var body in person.Limbs)
							{
								body.BaseStrength += 10f;
								body.Health *= 9999f;
								body.InitialHealth *= 9999f;
								body.ShotDamageMultiplier *= 0.2f;
								body.BreakingThreshold += 800f;
								body.RegenerationSpeed += 10f;
								body.Vitality *= 5f;
								body.ImpactPainMultiplier *= 0.1f;
								body.Numbness *= 2f;
							}
						}
					}
				);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "The Locket", 
					NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "You can feel it beating.", 
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/TLocicon.png"),
                    AfterSpawn = (Instance) => 
                    {   
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("item/The_Locket.png"); 
                        int PartCount = 1;
                        Instance.GetOrAddComponent<ArmorBehaviour>();
                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        ArmorProperties prop = new ArmorProperties();
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = ModAPI.LoadSprite("item/The_Locket.png");
                        prop.armorPoints = 200;
                        prop.offset = new Vector2(0f, 0f) * ModAPI.PixelSize;
                        armor.prop = prop;
                        armor.SetProperties();

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                        }
                        Instance.FixColliders();
                    }
                }
            );
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "A S R I E L  F I N A L  F O R M",
                    NameToOrderByOverride = "A-HNR",
                    DescriptionOverride = "THIS IS THE END",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/AzzyFFicon.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {							
							ModAPI.LoadSprite("Characters/asriel/Final Form/head.png"),

							ModAPI.LoadSprite("Characters/asriel/Final Form/bodytop.png"),
							ModAPI.LoadSprite("Characters/asriel/Final Form/bodymid.png"),
							ModAPI.LoadSprite("Characters/asriel/Final Form/empty.png"),
							

							ModAPI.LoadSprite("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadSprite("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadSprite("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadSprite("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadSprite("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadSprite("Characters/asriel/Final Form/empty.png"),

							ModAPI.LoadSprite("Characters/asriel/Final Form/armtop.png"),
							ModAPI.LoadSprite("Characters/asriel/Final Form/armbot.png"),
							ModAPI.LoadSprite("Characters/asriel/Final Form/armtop.png"),
							ModAPI.LoadSprite("Characters/asriel/Final Form/armbot.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/asriel/Final Form/head.png"),

							ModAPI.LoadTexture("Characters/asriel/Final Form/bodytop.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/bodymid.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							

							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),

							ModAPI.LoadTexture("Characters/asriel/Final Form/armtop.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/armbot.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/armtop.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/armbot.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/asriel/Final Form/head.png"),

							ModAPI.LoadTexture("Characters/asriel/Final Form/bodytop.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/bodymid.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							

							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/empty.png"),

							ModAPI.LoadTexture("Characters/asriel/Final Form/armtop.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/armbot.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/armtop.png"),
							ModAPI.LoadTexture("Characters/asriel/Final Form/armbot.png")
						};
						
						foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
								if (limbs.gameObject.name.Contains("LowerBody"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  	if (limbs.gameObject.name.Contains("UpperLeg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Foot"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerLeg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limbb = persn.Limbs;
						for (int i = 0; i < limbb.Length; i++)
						{
							limbb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limbb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limbb[i].GetComponents<Collider2D>());
							var hitbox = limbb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");

						head.transform.localPosition = new Vector2(0f, 4.2f);
						head.transform.localScale = new Vector3(0.85f, 0.85f);
						head.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
					
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 2.4f);
						/* daBod.Find("UpperBody").GetComponent<SpriteRenderer>().sortingLayerName = "Background"; */
 						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0f);
						/* daBod.Find("MiddleBody").GetComponent<SpriteRenderer>().sortingLayerName = "Default"; */
						
  						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(0f, 2.2f);
						armLeft.Find("UpperArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(0f, 0.2f);
						armLeft.Find("LowerArmFront").GetComponent<SpriteRenderer>().sortingLayerName = "Top";
						
  						armRight.Find("UpperArm").transform.localPosition = new Vector2(0f, 2.2f);
						/* armRight.Find("UpperArm").GetComponent<SpriteRenderer>().sortingLayerName = "Top"; */
						armRight.Find("LowerArm").transform.localPosition = new Vector2(0f, 0.2f);
						/* armRight.Find("LowerArm").GetComponent<SpriteRenderer>().sortingLayerName = "Top"; */
						




						var backpack = new GameObject("backpack");
                        backpack.transform.SetParent(Instance.transform.Find("Head"));
                        backpack.transform.localPosition = new Vector3(-0.329f, -1.05f);
						backpack.transform.localScale = new Vector3(0.85f, 0.85f);
                        var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                        backpackSprite.sprite = ModAPI.LoadSprite("Characters/asriel/Final Form/hvst2.png");
                        backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
						var backpack1 = new GameObject("Backpack1");
                        backpack1.transform.SetParent(Instance.transform.Find("Head"));
                        backpack1.transform.localPosition = new Vector3(0.43f, 0.83f);
                        backpack1.transform.localScale = new Vector3(0.85f, 0.85f);
                        var backpack1Sprite = backpack1.AddComponent<SpriteRenderer>();
                        backpack1Sprite.sprite = ModAPI.LoadSprite("Characters/asriel/Final Form/hvst4.png");
                        backpack1.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
						
						var backpack2 = new GameObject("Backpack2");
                        backpack2.transform.SetParent(Instance.transform.Find("Head"));
                        backpack2.transform.localPosition = new Vector3(0.58f, 1.05f);
						backpack2.transform.localScale = new Vector3(0.85f, 0.85f);
                        var backpack2Sprite = backpack2.AddComponent<SpriteRenderer>();
                        backpack2Sprite.sprite = ModAPI.LoadSprite("Characters/asriel/Final Form/hvst.png");
                        backpack2.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						
						var backpack3 = new GameObject("Backpack3");
                        backpack3.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                        backpack3.transform.localPosition = new Vector3(-0.7f, 1.2f);
						backpack3.transform.localScale = new Vector3(1f, 1f);
                        var backpack3Sprite = backpack3.AddComponent<SpriteRenderer>();
                        backpack3Sprite.sprite = ModAPI.LoadSprite("Characters/asriel/Final Form/hvst3.png");
                        backpack3.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
						
						var backpack4 = new GameObject("Backpack4");
                        backpack4.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                        backpack4.transform.localPosition = new Vector3(-3f, 0f);
						backpack4.transform.localScale = new Vector3(1f, 1f);
                        var backpack4Sprite = backpack4.AddComponent<SpriteRenderer>();
                        backpack4Sprite.sprite = ModAPI.LoadSprite("Characters/asriel/Final Form/hvst5.png");
						backpack4Sprite.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
						backpack4Sprite.GetComponent<SpriteRenderer>().color = new Color(0.17f, 0.17f, 0.17f, 0.50f);
                        backpack4.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
						
						foreach (var body in persn.Limbs)
							{
								body.transform.root.localScale *= 1.0160f;
								body.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;
								body.BaseStrength += 4f;
								body.Health = float.PositiveInfinity;
								body.InitialHealth = float.MaxValue;
								body.BreakingThreshold = float.PositiveInfinity;
								body.PhysicalBehaviour.Charge = 0f;
								body.ShotDamageMultiplier *= 0f;
								body.Vitality = 0f;
								body.BloodDecal = null;
								body.RegenerationSpeed += 10f;
								body.Numbness *= 3f;
								body.CirculationBehaviour.BloodFlow *= 4f;
								body.ImpactPainMultiplier *= 0f;
								body.IsLethalToBreak = false;
								body.DoBalanceJerk = false;
								body.PhysicalBehaviour.ReflectsLasers = true;
								body.PhysicalBehaviour.SimulateTemperature = false;
								body.PhysicalBehaviour.Disintegratable = false;
								body.PhysicalBehaviour.Deletable = false;
								body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Incredible");
								body.gameObject.AddComponent<undeath>();
							}
							
							var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(persn.Limbs[0].PhysicalBehaviour.Properties);						
							foreach (LimbBehaviour limb in persn.Limbs)
							{
								limb.BloodLiquidType = "dustblood";
								limb.CirculationBehaviour.ClearLiquid();
								limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("dustblood"), 1f);
								limb.PhysicalBehaviour.Properties = prop;
							}
							
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
/* ModAPI.Register(
				new Modification()
					{
						OriginalItem = ModAPI.FindSpawnable("Human"),
						NameOverride = "Goner Kid",
						NameToOrderByOverride = "",
						DescriptionOverride = "Please forget about me.",
						CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
						ThumbnailOverride = ModAPI.LoadSprite("icon/6666666.png"),
						AfterSpawn = (Instance) =>
						{
							var person = Instance.GetComponent<PersonBehaviour>();
							var skin = ModAPI.LoadTexture("Characters/666/room_water7/Have you ever thought of a world where everything is exactly the same....png");
							var flesh = ModAPI.LoadTexture("Characters/666/room_water7/Have you ever thought of a world where everything is exactly the same....png");
							var bone = ModAPI.LoadTexture("Characters/666/room_water7/Have you ever thought of a world where everything is exactly the same....png");
							Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1f);
							
							GameObject horns = new GameObject();
							horns.transform.SetParent(Instance.transform.Find("Head"));
							horns.transform.localPosition = new Vector3(0.186f, 0.0143f);
							horns.transform.localScale = new Vector3(1f, 1f);
							var hornsSprite = horns.AddComponent<SpriteRenderer>();
							hornsSprite.sprite = ModAPI.LoadSprite("Characters/666/room_water7/Except that you don't exist.png");
							hornsSprite.sortingLayerName = "Top";
							
							foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
							  if (limbs.gameObject.name.Contains("LowerArmFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						}
					}
				);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Follower 1",
                    NameToOrderByOverride = "",
                    DescriptionOverride = "...After all, the old one... Doctor Gaster... However, his life... was cut short. One day, he fell into his creation, and...",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/666666.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/1.png"),

							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/2.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/3.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/4.png"),
							

							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/8.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/7.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/6666666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/8.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/7.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/6666666666.png"),

							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/6.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/5.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/6.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l3/5.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/1.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/2.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/3.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/4.png"),
								

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/8.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/7.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/8.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/7.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/6666666666.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/6.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/5.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/6.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/5.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/1.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/2.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/3.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/4.png"),
							

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/8.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/7.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/8.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/7.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/6666666666.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/6.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/5.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/6.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l3/5.png")
						};
						
						foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
                        {
                          if (limbs.gameObject.name.Contains("Foot"))
                          {
                            limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                          }
                        }
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limb = persn.Limbs;
						for (int i = 0; i < limb.Length; i++)
						{
							limb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limb[i].GetComponents<Collider2D>());
							var hitbox = limb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0f, 0.8f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.4f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.2f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, 0f);
						
						legLeft.transform.localPosition = new Vector2(0f, 0f);
 						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.24f);
						legLeft.Find("LowerLegFront").transform.localPosition = new Vector2(0f, -0.51f);

						
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.24f);
						legRight.Find("LowerLeg").transform.localPosition = new Vector2(0f, -0.51f); 
						
 						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(-0.02f, -0.15f);
 						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(-0.02f, -0.46f);
						
 						armRight.Find("UpperArm").transform.localPosition = new Vector2(-0.02f, -0.15f);
 						armRight.Find("LowerArm").transform.localPosition = new Vector2(-0.02f, -0.46f);
						
  						foreach (var body in persn.Limbs)
							{
								body.transform.root.localScale *= -0.9900f;
							} 
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Follower 2",
                    NameToOrderByOverride = "",
                    DescriptionOverride = "...But the old Royal Scientist, Doctor W.D. Gaster? One day, he vanished without a trace. They say he shattered across time and space... I'm holding a piece of him right here.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/66666.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/6.png"),

							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/66.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/6666.png"),
							

							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/66666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/666666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/6666666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/66666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/666666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/6666666666.png"),

							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/66666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/66666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/666666.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/6.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/66.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/6666.png"),
							

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/66666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/66666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/6666666666.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/66666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/66666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/666666.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/6.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/66.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/6666.png"),
							

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/66666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/66666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/6666666666.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/66666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/66666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_r1/666666.png")
						};
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var middle = Instance.transform.Find("FrontArm").Find("LowerArmFront");
						var limb = persn.Limbs;
						for (int i = 0; i < limb.Length; i++)
						{
							limb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limb[i].GetComponents<Collider2D>());
							var hitbox = limb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0f, 0.75f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 0.31f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.08f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, -0.18f);
						
 						legLeft.Find("UpperLegFront").transform.localPosition = new Vector2(0f, -0.5f);

						
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.5f);
						
 						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(0f, -0.24f);
 						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(0f, -0.65f);
						
 						armRight.Find("UpperArm").transform.localPosition = new Vector2(0f, -0.24f);
 						armRight.Find("LowerArm").transform.localPosition = new Vector2(0f, -0.65f);
						
						var ATLASHEAD = new GameObject("ATLASHEAD");
						ATLASHEAD = GameObject.Instantiate(ModAPI.FindSpawnable("Wooden Pillar").Prefab);
						ATLASHEAD.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
						ATLASHEAD.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";

						SpriteRenderer rotorRenderer = ATLASHEAD.GetComponent<SpriteRenderer>();
						rotorRenderer.sprite = ModAPI.LoadSprite("Characters/666/room_fire_evelator_r1/6666666.png");
						ATLASHEAD.transform.SetParent(middle.transform);
									
						ATLASHEAD.GetComponent<PhysicalBehaviour>().MakeWeightless();
							

						ATLASHEAD.FixColliders();

						HingeJoint2D hingeJoint = ATLASHEAD.GetOrAddComponent<HingeJoint2D>();
						hingeJoint.connectedBody = middle.GetComponent<Rigidbody2D>();
						hingeJoint.anchor = new Vector3(0f, 0f);
						JointAngleLimits2D limits = hingeJoint.limits;
						limits.min = 0;
                        limits.max = 0;
                        hingeJoint.limits = limits;
                        hingeJoint.useLimits = true;
						hingeJoint.enableCollision = false;

						ATLASHEAD.transform.localPosition = new Vector3(0.104f, -0.12f);
									
						ATLASHEAD.gameObject.layer = 9;
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Follower 3",
                    NameToOrderByOverride = "",
                    DescriptionOverride = "The previous one... Dr. Gaster. His brilliance was irreplaceable. However, his life... was cut short... After all, it's rude to talk about someone who's listening.",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/6666.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/6666666666.png"),

							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/4.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/2.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/1.png"),
							

							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/5.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/5.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/6666666666.png"),

							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/3.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/3.png"),
							ModAPI.LoadSprite("Characters/666/room_fire_evelator_l2/6666666666.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/4.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/2.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/1︎.png"),
							

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/5.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/5.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/3.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/3.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/4.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/2.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/1︎.png"),
							

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/5.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/5.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),

							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/3.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/3.png"),
							ModAPI.LoadTexture("Characters/666/room_fire_evelator_l2/6666666666.png")
						};
						
						foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
								if (limbs.gameObject.name.Contains("Head"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperLegFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  	if (limbs.gameObject.name.Contains("LowerLeg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Foot"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerArmFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("LowerArm"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("UpperArmFront"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limb = persn.Limbs;
						for (int i = 0; i < limb.Length; i++)
						{
							limb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limb[i].GetComponents<Collider2D>());
							var hitbox = limb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0.1285f, 0.94f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(-0.157f, 0.345f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0.043f, -0.14f);
					
						legRight.transform.localPosition = new Vector2(0f, 0f);
						legRight.Find("UpperLeg").transform.localPosition = new Vector2(0f, -0.5f);
						
 						armRight.Find("UpperArm").transform.localPosition = new Vector2(0.5f, 0.132f);
						
  						foreach (var body in persn.Limbs)
							{
								body.transform.root.localScale *= -0.9960f;
							}
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			);
ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Mystery Man",
                    NameToOrderByOverride = "",
                    DescriptionOverride = "👎︎✌︎☼︎😐︎📬︎📬︎📬︎ 👎︎✌︎☼︎😐︎☜︎☼︎📬︎📬︎📬︎ ✡︎☜︎❄︎ 👎︎✌︎☼︎😐︎☜︎☼︎",
                    CategoryOverride = ModAPI.FindCategory("UNDERTALE Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("icon/666.png"),
                    AfterSpawn = (Instance) =>
                    {
							Sprite[] skinTextures = new Sprite[] {
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/2.png"),

							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/1.png"),
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/6.png"),
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/5.png"),
							

							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/66666666.png"),
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/666666666.png"),
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/6666666666.png"),
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/66666666.png"),
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/666666666.png"),
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/6666666666.png"),

							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/3.png"),
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/4.png"),
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/3.png"),
							ModAPI.LoadSprite("Characters/666/WHY_ARE_YOU_DOING_THIS/4.png")

						};
						
						Texture2D[] meattextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/2.png"),

							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/1.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/6.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/5.png"),
							

							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/66666666.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/666666666.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/66666666.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/666666666.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/6666666666.png"),

							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/3.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/4.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/3.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/4.png")
						};
						
						Texture2D[] bonetextures = new Texture2D[] {
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/2.png"),

							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/1.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/6.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/5.png"),
							

							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/66666666.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/666666666.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/6666666666.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/66666666.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/666666666.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/6666666666.png"),

							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/3.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/4.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/3.png"),
							ModAPI.LoadTexture("Characters/666/WHY_ARE_YOU_DOING_THIS/4.png")
						};
						
						foreach (var limbs in Instance.GetComponent<PersonBehaviour>().Limbs)
							{
							  if (limbs.gameObject.name.Contains("Leg"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							  if (limbs.gameObject.name.Contains("Foot"))
							  {
								limbs.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
							  }
							}
						
						var persn = Instance.GetComponent<PersonBehaviour>();
						var limb = persn.Limbs;
						for (int i = 0; i < limb.Length; i++)
						{
							limb[i].GetComponent<SpriteRenderer>().sprite = skinTextures[i];
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_FleshTex", meattextures[i]);
							limb[i].GetComponent<SpriteRenderer>().material.SetTexture("_BoneTex", bonetextures[i]);
							foreach (var collider in limb[i].GetComponents<Collider2D>());
							var hitbox = limb[i].gameObject.AddComponent<BoxCollider2D>();
						}
						
						var armLeft = Instance.transform.Find("FrontArm");
						var armRight = Instance.transform.Find("BackArm");
						var legLeft = Instance.transform.Find("FrontLeg");
						var legRight = Instance.transform.Find("BackLeg");
						var head = Instance.transform.Find("Head");
						var daBod = Instance.transform.Find("Body");
						
						head.transform.localPosition = new Vector2(0f, 1.71f);
						
 						daBod.Find("UpperBody").transform.localPosition = new Vector2(0f, 1.14f);
						daBod.Find("MiddleBody").transform.localPosition = new Vector2(0f, 0.57f);
						daBod.Find("LowerBody").transform.localPosition = new Vector2(0f, 0f);				
 						armLeft.Find("UpperArmFront").transform.localPosition = new Vector2(0f, 0.6f);
 						armLeft.Find("LowerArmFront").transform.localPosition = new Vector2(0f, 0.15f);
						
 						armRight.Find("UpperArm").transform.localPosition = new Vector2(0f, 0.6f);
 						armRight.Find("LowerArm").transform.localPosition = new Vector2(0f, 0.15f);
						
  						foreach (var body in persn.Limbs)
							{
								body.transform.root.localScale *= -0.9940f;
							}
						
						var allColliders = Instance.GetComponentsInChildren<Collider2D>();
						foreach (var a in allColliders)
							foreach (var b in allColliders)

								Physics2D.IgnoreCollision(a, b);
					}
				}
			); */
		}
	}
}

    public class SpawnsItemWhenDead : MonoBehaviour
    {
        public SpawnableAsset ObjectToSpawnAfterDeath;
        public string Name = "Broken Aftermath Object";
        public bool isPerson = false;
        public Sprite NewSprite;
        public Sprite IconSprite;
        GameObject Instance;


        public void Update()
        {
            if (!GetComponent<PersonBehaviour>().IsAlive())
            {
                if (!isPerson)
                {
                    GameObject SpawnedObject = Instantiate(ObjectToSpawnAfterDeath.Prefab);
                    CatalogBehaviour.PerformMod(ObjectToSpawnAfterDeath, SpawnedObject);
                    SpawnedObject.GetComponent<PhysicalBehaviour>().SpawnSpawnParticles = false;
                    SpawnedObject.transform.position = transform.position;
                    SpawnedObject.name = Name;
                }
                else switch (Name)
                    {
                        case "Undyne the Undying":
                            if (OtherStuff.UnlockItem(Name))
                            {

                            }

                            break;
                       case "Mettaton NEO":
                            if (OtherStuff.UnlockItem(Name))
                            {
								
                            }
							
							break;
                    }


                Destroy(this);
            }
        }
    }
	
	
    public class OtherStuff : MonoBehaviour
    {
		public static bool UnlockItem(string ItemName)
        {
            if (!PlayerPrefs.HasKey($"Undertale: {ItemName}") || PlayerPrefs.GetInt($"Undertale: {ItemName}") == 0)
            {
                DialogBox dialog = (DialogBox)null;
                dialog = DialogBoxManager.Notification($"You've unlocked the {ItemName}!\n It will now appear in your spawn menu when you restart the map.");
                PlayerPrefs.SetInt($"Undertale: {ItemName}", 1);
                return true;
            }
            return false;
        }
	}

public static class ModResources
{
    public static void SetMass(GameObject Instance, float Mass)
    {
        var phys = Instance.GetComponent<PhysicalBehaviour>();
        phys.TrueInitialMass = Mass;
        phys.rigidbody.mass = Mass;
        phys.InitialMass = Mass;
    }
}

public class AnimationBehaviour1 : MonoBehaviour
	{
		private int SpriteNumber = 0;

		private bool nowAlive = false;

		public GameObject AnimationObject;
		[SkipSerialisation]
		private SpriteRenderer render;
		[SkipSerialisation]
		private PersonBehaviour Person;
		public float AnimationDelay = 0.03f;

		public Sprite[] AnimationSprites; //спрайты анимации
		
		private void Awake()
		{
			AnimationObject = new GameObject();
			AnimationObject.transform.SetParent(gameObject.transform);
			AnimationObject.transform.localPosition = Vector3.zero;
			AnimationObject.transform.localEulerAngles = Vector3.zero;
			AnimationObject.transform.localScale = Vector3.one;


			render = AnimationObject.AddComponent<SpriteRenderer>();
			 render.sortingLayerName = "Top";
			//render.color = new Color(1f, 1f, 1f, 0.5f);

			Person = gameObject.GetComponent<LimbBehaviour>().Person;
			//body.PhysicalBehaviour.MakeWeightless();
		}
		private IEnumerator Animation()
		{
			while (nowAlive)
			{
				if (SpriteNumber >= AnimationSprites.Length) //перезапуск при последнем спрайте анимации
				{
					SpriteNumber = 0;
				}
				render.sprite = AnimationSprites[SpriteNumber];
				SpriteNumber++;
				yield return new WaitForSeconds(AnimationDelay); //задержка между кадрами анимации
			}
		}
		private void Update()
		{
			if (Person.IsAlive() && !nowAlive)        
			{
				nowAlive = true;
				StartCoroutine(Animation());
			}
			else if (!Person.IsAlive() && nowAlive)
			{
				nowAlive = false;
				StopCoroutine(Animation());
			}
		}
	}

	public class AnimationBehaviour2 : MonoBehaviour
	{
		private int SpriteNumber = 0;

		private bool nowAlive = false;

		public GameObject AnimationObject;
		[SkipSerialisation]
		private SpriteRenderer render;
		[SkipSerialisation]
		private PersonBehaviour Person;
		public float AnimationDelay = 0.03f;

		public Sprite[] AnimationSprites; //спрайты анимации
		
		private void Awake()
		{
			AnimationObject = new GameObject();
			AnimationObject.transform.SetParent(gameObject.transform);
			AnimationObject.transform.localPosition = Vector3.zero;
			AnimationObject.transform.localEulerAngles = Vector3.zero;
			AnimationObject.transform.localScale = Vector3.one;


			render = AnimationObject.AddComponent<SpriteRenderer>();
			 render.sortingLayerName = "Top";
			//render.color = new Color(1f, 1f, 1f, 0.5f);

			Person = gameObject.GetComponent<LimbBehaviour>().Person;
			//body.PhysicalBehaviour.MakeWeightless();
		}
		private IEnumerator Animation()
		{
			while (nowAlive)
			{
				if (SpriteNumber >= AnimationSprites.Length) //перезапуск при последнем спрайте анимации
				{
					SpriteNumber = 0;
				}
				render.sprite = AnimationSprites[SpriteNumber];
				SpriteNumber++;
				yield return new WaitForSeconds(AnimationDelay); //задержка между кадрами анимации
			}
		}
		private void Update()
		{
			if (Person.IsAlive() && !nowAlive)        
			{
				nowAlive = true;
				StartCoroutine(Animation());
			}
			else if (!Person.IsAlive() && nowAlive)
			{
				nowAlive = false;
				StopCoroutine(Animation());
				Destroy(AnimationObject);
			}
		}
	}
	
public class AnimationBehaviour3 : MonoBehaviour
{
    private int SpriteNumber = 0;

    private bool nowAlive = false;

    public GameObject AnimationObject;
    [SkipSerialisation]
    private SpriteRenderer render;
    [SkipSerialisation]
    private PhysicalBehaviour physicalBehaviour;
    public float AnimationDelay = 0.03f;

    public Sprite[] AnimationSprites;

    private void Awake()
    {
        AnimationObject = new GameObject();
        AnimationObject.transform.SetParent(gameObject.transform);
        AnimationObject.transform.localPosition = Vector3.zero;
        AnimationObject.transform.localEulerAngles = Vector3.zero;
        AnimationObject.transform.localScale = Vector3.one;

        render = AnimationObject.AddComponent<SpriteRenderer>();
        render.sortingLayerName = "Default";

        physicalBehaviour = gameObject.GetComponent<PhysicalBehaviour>();
    }

    private IEnumerator Animation()
    {
        while (nowAlive)
        {
            if (SpriteNumber >= AnimationSprites.Length)
            {
                SpriteNumber = 0;
            }
            render.sprite = AnimationSprites[SpriteNumber];
            SpriteNumber++;
            yield return new WaitForSeconds(AnimationDelay);
        }
    }

    private void Update()
    {
        if (physicalBehaviour != null && !nowAlive)
        {
            nowAlive = true;
            StartCoroutine(Animation());
        }
        else if (physicalBehaviour == null && nowAlive)
        {
            nowAlive = false;
            StopCoroutine(Animation());
            Destroy(AnimationObject);
        }
    }
}

	class GasterBlasterBehaviour : MonoBehaviour
	{
		private void Start()
		{
		this.renderer = gameObject.GetComponent<SpriteRenderer>();
		UpdateState();
		}

		void UpdateState()
		{
		if(this.Activated)
		{
		renderer.sprite = B;
		}
		else
		{
		renderer.sprite = A;
		}
		}

		private void Use() {
		if (!base.enabled) {
		return;
		}
		this.SetActivated(!this.Activated);
		}

		private void SetActivated(bool activated) {
		this.Activated = activated;
		UpdateState();
		 if (!isCoroutineRunning) {
			 StartCoroutine(ChangeSpriteAfterDelay());
		 }
		}

		IEnumerator ChangeSpriteAfterDelay()
		{
		isCoroutineRunning = true;

		  yield return new WaitForSeconds(0.6f);

		  SetActivated(!Activated);

		  isCoroutineRunning = false;
		}

		bool isCoroutineRunning = false;
		public bool Activated = false;
		[SkipSerialisation]
		public SpriteRenderer renderer;
		[SkipSerialisation]
		public Sprite A;
		[SkipSerialisation]
		public Sprite B;
	}
	
    public class TeleportForward : MonoBehaviour
    {
		
        public void Awake()
        {
			
        }


        public void Teleport()
        {
                if (GetComponent<LimbBehaviour>().Person.transform.localScale.x > 0)
                {
                    GetComponent<LimbBehaviour>().Person.transform.position = GetComponent<LimbBehaviour>().Person.transform.position + (Vector3.right * 5);
                }
                else if (GetComponent<LimbBehaviour>().Person.transform.localScale.x < 0)
                {
                    GetComponent<LimbBehaviour>().Person.transform.position = GetComponent<LimbBehaviour>().Person.transform.position - (Vector3.right * 5);
                }
        }
    }
// Originally uploaded by '󠀦󠀦hunter'. Do not reupload without their explicit permission.
